#include <Xm/Xm.h>
#include <Xm/Text.h>
#include <stdio.h>
#include <math.h>
#include <Xm/ToggleB.h>
#include "vars.h"


extern KeySet key_buf[];
extern char *hint[];
extern char *key_names[];

extern void open_warning();
extern void open_options();
extern void analyze_();


void driver();
void write_buf();


void
analyze_I(widget)
Widget widget;
{
    open_options(widget);
}

void
analysis_II(widget)
Widget widget;
{
    driver();
}

void
analysis_III(widget)
Widget widget;
{
    return;
}

void
analysis_IV(widget)
Widget widget;
{
    return;
}

void
set_color(widget)
Widget widget;
{
    return;
}

void
InitVars(widget)
Widget widget;
{
    return;
}


void
driver()
{
    char type[5];

    /* Seems type[5] = "s    "  does not work with comet. */

    type[0] = 's';
    type[1] = ' ';
    type[2] = ' ';
    type[3] = ' ';
    type[4] = ' ';


    analyze_(type, 5);

}

/* check_list is a utility to check the atom list input by the user. We
 * want to make show tthat the user only input digits.
 */
void
check_list(text_w, wich, cbs)
Widget     text_w;
int wich;   /* tell which text win calles */
XmTextVerifyCallbackStruct *cbs;
{
    char c;
    int len = XmTextGetLastPosition(text_w);
    int item_no;

    XtVaGetValues(text_w, XmNuserData, &item_no, NULL);
    fprintf(stderr, "item_no for this win is: %d \n", item_no);
    if (cbs->reason == XmCR_ACTIVATE) {
	write_buf(text_w, wich, item_no, UP);

        return;
    }

    if (cbs->reason == XmCR_VALUE_CHANGED) {
        XmTextSetInsertionPosition(text_w, len);
        return;
    }

    if (cbs->text->ptr == NULL) {/*  backspace */    
	return;
    }

    if (cbs->text->length > 1) { /* don't allow clipboard copies */
        cbs->doit = False;
        return;
    }

    /* no backspacing or typing in the middle of string */
    if (cbs->currInsert < len) {
        cbs->doit = False;
        return;
    }

    /* don't allow non-digits or let the input exceed 5 chars */
    if (!isdigit(c = cbs->text->ptr[0]) || len >= 5) {
        cbs->doit = False;
	return;
    }


}



/* We have to write different callbacks for toggles and for text windows,
 * because they require different callback structures. In particular, for
 * toggles, we have to use the 'set' field of the structure, while for
 * text input we need the 'doit' 'startPos' etc.
 *
 *
 * toggle_checked() update the key_buf array. i.e.
 * it is a tool to update the global buf we keep for the .key file. Each
 * time the user change a option, the corresponding entry in the buffer is
 * updated by write_buf accordingly. It is activated when the user click a
 * toggle button. 
 *
 * the actual updating is done by a call to the routine write_buf().
 */
void
toggle_checked(w, item_no, cbs)
Widget w;
int item_no;
XmToggleButtonCallbackStruct *cbs;
{
    if (cbs->set) {
	printf("we are in toggle_checked(), about to write_buf(), UP. \n");

	write_buf(w, 2, item_no, UP);

    }
    else if (cbs->set == FALSE) {
	printf("we are in toggle_checked(), about to write_buf(), DOWN. \n");
	write_buf(w, 2, item_no, DOWN);
    }
	return;
}

/* if the toggle is in radio_box mode and been toggled, we need to change
 * the label string to give the user a hint and pass focus to the from_w
 * text window. 
 *
 * we store the from_w widget as a userData in the parent, so that this call
 * can retrive it.
 * /



/* tw_write() is the callback for text windows to update the .key file
 * buffer. again, the actual updating is done by calling write_buf().
 */
void
tw_write(w, i, cbs)
Widget w;
int i; /* unused */
XmAnyCallbackStruct *cbs;
{
    int item_no;

    XtVaGetValues(w, XmNuserData, &item_no, NULL);
    write_buf(w, item_no);

}

/* write_buf() updates the .key file buffer. */
void
write_buf(w, wich, item_no, flag)
Widget w;
int wich;
int item_no;
Boolean flag;
{
    char *value;

    if (flag == UP) {
	key_buf[item_no].flag = UP;
	if (XmIsToggleButton(w)) {
	    strcpy(key_buf[item_no].key_value, "");
	}
	else if (XmIsText(w)) {
	    value = XmTextGetString(w);
	    switch (wich) {
	    case FROM:
		strcpy(key_buf[item_no].key_value, value);
		break;
	    case TO:
		strcat(key_buf[item_no].key_value, ",");
		strcat(key_buf[item_no].key_value, value);
		fprintf(stderr, "Look: %s \n", key_buf[item_no].key_value);
		break;
	    default:
		break;
	    }
	    XtFree(value);
	}
    }
    if (flag == DOWN) {
        key_buf[item_no].flag = DOWN;
	strcpy(key_buf[item_no].key_value, "");
    }

}


/* Initialize key_names[] */
void
InitKeyNames()
{
    int i;


    key_names[0] = "parameters";
    key_names[1] = "dielectric-chg";
    key_names[2] = "dielectric-dpl";
    key_names[3] = "vdw-cutoff";
    key_names[4] = "chg-cutoff";
    key_names[5] = "dpl-cutoff";
    key_names[6] = "steric";
    key_names[7] = "atom";
    key_names[8] = "large";
    key_names[9] = "dipole";
    key_names[10] = "param";
    key_names[11] = "savecycle";
    key_names[12] = "overwrite";
    key_names[13] = "verbose";
    key_names[14] = "debug";
    key_names[15] = "octahedron";
    key_names[16] = "water";

    for (i = 17; i < 300; i++) {
	key_names[i] = "";
    }
	
}

void
InitHint()
{
    int i;

    hint[0] = "This is a Hint!";
    hint[1] = "This is a Hint!";
    hint[2] = "This is a Hint!";
    hint[3] = "This is a Hint!";
    hint[4] = "This is a Hint!";
    hint[5] = "This is a Hint!";
    hint[6] = "This is a Hint!";
    hint[7] = "It's for atom range!";
    hint[8] = "It's for large range!";
    hint[9] = "This is a Hint!";
    hint[10] = "It's for param range!";
    hint[11] = "This is a Hint!";
    hint[12] = "This is a Hint!";
    hint[13] = "This is a Hint!";
    hint[14] = "This is a Hint!";
    hint[15] = "This is a Hint!";
    hint[16] = "This is a Hint!";

    for (i = 17; i < 300; i++) {
    hint[i] = "This is a Hint!";
    }
}
