c
c
c     ###################################################################
c     ##                                                               ##
c     ##  subroutine anlx  --  energy & gradient for path calculations ##
c     ##                                                               ##
c     ###################################################################
c
c
      subroutine anlx (p,energy,df)
      implicit none
      include 'sizes.i'
      include 'atoms.i'
      include 'pathsz.i'
      include 'pathdata.i'
      integer i
      real*8 p(nat3),df(nat3)
      real*8 energy,deriv(3,maxatm)
c
c
c     copy current coordinates to TINKER
c
      do i = 1, n
         x(i) = p(3*i-2)
         y(i) = p(3*i-1)
         z(i) = p(3*i)
      end do
c
c     compute TINKER energy and gradient
c
      call gradient (energy,deriv)
c
c     copy the values into path calculation vectors
c
      do i = 1, n
         df(3*i-2) = deriv(1,i)
         df(3*i-1) = deriv(2,i)
         df(3*i) = deriv(3,i)
      end do
      return
      end
