c
c
c     #######################################################################
c     ##                                                                   ##
c     ##  subroutine cmtest  --  get the relative center of mass positions ##
c     ##                                                                   ##
c     #######################################################################
c
c
      subroutine cmtest(point)
      implicit none
      include 'sizes.i'
      include 'pathsz.i'
      include 'pathdata.i'
      include 'spw.i'
      include 'pathatm.i'
      integer j,j1,j2,j3
      real*8 cmxfix,cmyfix,cmzfix,cmxp,cmyp,cmzp
      real*8 cmrotx,cmroty,cmrotz
      real*8 pointx,pointy,pointz
      real*8 point(nat3),p0x,p0y,p0z
c
c     obtain the relative translation
c
      cmxfix=0.0d0
      cmyfix=0.0d0
      cmzfix=0.0d0
      do j=1,natoms
         j1=3*(j-1)+1
         j2=j1+1
         j3=j2+1
         cmxfix=cmxfix+sysms(j)*pfix(j1)
         cmyfix=cmyfix+sysms(j)*pfix(j2)
         cmzfix=cmzfix+sysms(j)*pfix(j3)
      end do
      cmxp=0.0d0
      cmyp=0.0d0
      cmzp=0.0d0
      do j=1,natoms
         j1=3*(j-1)+1
         j2=j1+1
         j3=j2+1
         cmxp=cmxp+sysms(j)*point(j1)
         cmyp=cmyp+sysms(j)*point(j2)
         cmzp=cmzp+sysms(j)*point(j3)
      end do
      cmxfix=cmxfix/sum_mass
      cmyfix=cmyfix/sum_mass
      cmzfix=cmzfix/sum_mass
      cmxp=cmxp/sum_mass
      cmyp=cmyp/sum_mass
      cmzp=cmzp/sum_mass
      write(6,*) 'CM coords'
      write(6,*) cmxfix,cmyfix,cmzfix,cmxp,cmyp,cmzp
      write (6,*) 'CM coords diff '
      write (6,*) cmxp-cmxfix,cmyp-cmyfix,cmzp-cmzfix
c
c     obtain the relative orientation
c
      cmrotx=0.0d0
      cmroty=0.0d0
      cmrotz=0.0d0
      do j=1,natoms
         j1=3*(j-1)+1
         j2=j1+1
         j3=j2+1
         cmrotx=cmrotx+sysms(j)*(point(j2)*pfix(j3)-point(j3)*pfix(j2))
         cmroty=cmroty+sysms(j)*(point(j3)*pfix(j1)-point(j1)*pfix(j3))
         cmrotz=cmrotz+sysms(j)*(point(j1)*pfix(j2)-point(j2)*pfix(j1))
      end do
      cmrotx=cmrotx
      cmroty=cmroty
      cmrotz=cmrotz
      write (6,*) 'rot    ',cmrotx,cmroty,cmrotz
      return
      end
