      subroutine getgc
      implicit none
      include 'sizes.i'
      include 'pathsz.i'
      include 'pathdata.i'
      include 'lup.i'
      integer i,j,k
      real*8 ovlp,tmp(3*maxatm,ncmax)

c
c     reinitialize all constraint gradient vectors
c
      do i=1,ncmax
         do j=1,3*maxatm
            gc(j,i) = 0.0d0
         end do
      end do
      do i = 1, ncmax
         do j = 1, ncmax
            acoeff(j,i) = 0.0d0
         end do
      end do
      do i = 1, ncmax
         acoeff(i,i) = 1.0d0
      end do
c
c     construct the set of constraint gradients
c     and pvect for current IZET
c
c     do j=1,nat3
c        gc(j,1)=pvect(j,izet)
c     end do
c
c     project the path direction out of the
c     gradients of constraints
c
      do i=1,nsix
         ovlp = 0.0d0
c        do j = 1, nat3
c           ovlp = ovlp + sixfix(j,i)*pvect(j,izet)
c        end do
         do j=1,nat3
            gc(j,i)=sixfix(j,i) - ovlp*pvect(j,izet)
         end do
      end do
c
c     store these 'sixfix' vectors
c
      do  i = 1, nsix
         do j = 1, nat3
            tmp(j,i) = gc(j,i)
         end do
      end do
c
c     orthogonalize the gradients of constraints
c     with respect to each other.
c     they are already so wrt pvect.
c
      call gs(gc,nat3,nsix)
c
c     debug utility for checking overlap of results
c
      do i=1,nsix
c        write (6,*)
         do k=i,nsix
            ovlp=0.0d0
            do j=1,nat3
               ovlp=ovlp+gc(j,i)*gc(j,k)
            end do
c           write (6,*) i,k,ovlp
         end do
         ovlp=0.0d0
         do j=1,nat3
            ovlp=ovlp+gc(j,i)*pvect(j,izet)
         end do
c        write (6,*) i,'pvect',ovlp
      end do
c
c     get the rotation matrix for determining
c     the constraints appropriate for the
c     gradients of constraints that ARE used
c
      call rotmat(tmp)

      return
      end
