c
c
c     ########################################################
c     ##                                                    ##
c     ##  subroutine getpol -- set up the initial SPW path ##
c     ##                                                    ##
c     ########################################################
c
c
      subroutine getpol(pcrd)
      implicit none
      include 'sizes.i'
      include 'pathsz.i'
      include 'cntrl.i'
      include 'pathcoord.i'
      include 'pathdata.i'
      integer izet,j,j1,j2,j3
      real*8  zeta
      real*8 pcrd(nat3,0:lpath+1)
c
c     flinv is needed here, and in monmon
c
      flinv=1.0d0 / dfloat(LPATH+1)
c
c     the zeroeth and (lpath+1) element contain the fixed Endpoints
c
      do j=1,nat3
      pcrd(j,0)=p0(j)
      pcrd(j,lpath+1)=p1(j)
      end do
c
c     for resumed jobs, use the most recent intermediate
c     polymer coordinates
c
      if ( restart) then
         do izet = 1, lpath
            do j = 1, nat3
               pcrd(j,izet) = pathcrd(j,izet)
            end do
         end do
c
c        generate the inital path by linear
c        interpolation of the Endpoints for new jobs
c
      else
         do 10 izet=1,LPATH
            zeta=izet*flinv
            do j=1,natoms
               j1=3*(j-1)+1
               j2=j1+1
               j3=j2+1
               pcrd(j1,izet)=(1.0-zeta)*p0(j1) + zeta*p1(j1)
               pcrd(j2,izet)=(1.0-zeta)*p0(j2) + zeta*p1(j2)
               pcrd(j3,izet)=(1.0-zeta)*p0(j3) + zeta*p1(j3)
            end do
 10      continue
      end if
      return
      end
