c
c
c     ###################################################
c     ##  COPYRIGHT (C)  1990  by  Jay William Ponder  ##
c     ###################################################
c
c     ##############################################################
c     ##                                                          ##
c     ##  subroutine getprm  --  open the energy parameters file  ##
c     ##                                                          ##
c     ##############################################################
c
c
c     "getprm" finds the potential energy parameter file
c     and then opens and reads the parameters
c
c
      subroutine getprm
      implicit none
      include 'files.i'
      include 'iounit.i'
      integer ikey,iprm,next,freeunit
      character*20 keyword
      character*60 keyfile,prmfile
      character*80 record
      save done
      logical done,exist
      data done  / .false. /
c
c
c     only get the potential parameters once
c
      if (done)  return
      done = .true.
c
c     set default names for parameter and keyword files
c
      prmfile = filename(1:leng)//'.prm'
      keyfile = filename(1:leng)//'.key'
c
c     search the keyword file for the parameter filename
c
      inquire (file=keyfile,exist=exist)
      if (exist) then
         ikey = freeunit ()
         open (unit=ikey,file=keyfile,status='old')
         dowhile (.true.)
            read (ikey,10,end=20)  record
   10       format (a80)
            next = 1
            call gettext (record,keyword,next)
            call upcase (keyword)
            if (keyword(1:11) .eq. 'PARAMETERS ') then
               call gettext (record,prmfile,next)
            end if
         end do
   20    continue
         close (unit=ikey)
      end if
c
c     if necessary, ask for the parameter filename
c
      call suffix (prmfile,'prm')
      call version (prmfile,'old')
      inquire (file=prmfile,exist=exist)
      dowhile (.not. exist)
         write (iout,30)
   30    format (' Enter Potential Parameter File Name :  ',$)
         read (input,40)  prmfile
   40    format (a60)
         call suffix (prmfile,'prm')
         call version (prmfile,'old')
         inquire (file=prmfile,exist=exist)
      end do
c
c     open the parameter file, then read and close it
c
      iprm = freeunit ()
      open (unit=iprm,file=prmfile,status='old')
      call readprm (iprm)
      close (unit=iprm)
      end
