c
c
c     ##############################################################
c     ##                                                          ##
c     ##  subroutine grdnorm  -- get the various RMS gradients    ##
c     ##                                                          ##
c     ##############################################################
c
c
      subroutine grdnorm
      implicit none
      include 'sizes.i'
      include 'pathsz.i'
      include 'pathdata.i'
      include 'spw.i'
      integer j
c
c     calculate the RMS of the various gradients
c
      do izet=0,lpath+1
         gnorm1(izet)=0.0d0
         gnorm2(izet)=0.0d0
         do j=1,nat3
            gnorm1(izet)=gnorm1(izet)+grdchn(j,izet)*grdchn(j,izet)
         end do
         do j=1,nat3
            gnorm2(izet)=gnorm2(izet)+grdrep(j,izet)*grdrep(j,izet)
         end do
      end do
      do izet=1,lpath
         gnorm3(izet)=0.0d0
         do j=1,nat3
            gnorm3(izet)=gnorm3(izet)+df(j,izet)*df(j,izet)
         end do
      end do
      do izet=1,lpath
         gnorm4(izet)=0.0d0
         do j=1,nat3
            gnorm4(izet)=gnorm4(izet)+dtot(j,izet)*dtot(j,izet)
         end do
      end do
      gntot=0.0d0
      gnorm1(izet)=sqrt(gnorm1(izet)/dfloat(natoms))
      gnorm2(izet)=sqrt(gnorm2(izet)/dfloat(natoms))
      gnorm3(izet)=sqrt(gnorm3(izet)/dfloat(natoms))
      do izet=1,lpath
        gntot=gntot+gnorm4(izet)
        gnorm4(izet)=sqrt(gnorm4(izet)/dfloat(natoms))
      end do
      gntot=sqrt(gntot/dfloat(lpath*natoms))
      return
      end

