c
c
c     ##########################################################
c     ##                                                      ##
c     ##  subroutine gs  --  Gram-Schmidt orthonormalization  ##
c     ##                                                      ##
c     ##########################################################
c
c
      subroutine gs (v,n,m)
      implicit none
      include 'sizes.i'
      include 'pathsz.i'
      integer m,n,j,k,l
      real*8 ovlp,vmag
      real*8 v(3*maxatm,ncmax),e(3*maxatm,ncmax)
c
c
c     compute Gram-Schmidt orthogonalization of input vectors
c
      do l = 1, m
         do j = 1, n
            e(j,l) = v(j,l)
         end do
         do k = 1, l-1
            ovlp = 0.0d0
            do j = 1, n
               ovlp = ovlp + v(j,l)*v(j,k)
            end do
            do j = 1, n
               e(j,l) = e(j,l) - ovlp*v(j,k)
            end do
         end do
         vmag = 0.0d0
         do j = 1, n
            vmag = vmag+e(j,l) * e(j,l)
         end do
         vmag = sqrt(vmag)
         do j = 1, n
            v(j,l) = e(j,l) / vmag
         end do
      end do
      return
      end
