c
c
c     #################################################################
c     ##                                                             ##
c     ##  program jette  --  SPW/LUP conformational interconversion  ##
c     ##                                                             ##
c     #################################################################
c
c
c     "jette" determines conformational transition paths via the Self
c     Penalty Walk (SPW) and Locally Updated Planes (LUP) methods.
c
c     literature references:
c
c     operation flags
c
c     findpath       perform SPW path determination
c     relaxpath      perform LUP path refinement
c
c     condition flags
c
c     spw_okay       condition variable for Status of SPW Termination
c
c
      program jette
      implicit none
      include 'sizes.i'
      include 'pathsz.i'
      include 'cntrl.i'
      logical spw_okay
c
c     obtain selected operations and do initializations
c
      call startup
      spw_okay = .true.
c
c     calculate a first guess path if necessary
c
      if (findpath) call spwmain(spw_okay)
c
c     refine the path via the method of LUP if desired
c
      if ( (relaxpath) .and. (spw_okay) ) call lupmain

      end
