c
c
c     ###############################################################
c     ##                                                           ##
c     ##  lup.i  --  variables for LUP calculation  ##
c     ##                                                           ##
c     ###############################################################
c
c
c     izet            path point index
c     npass           number of passes through main loop for Intermediates
c
      integer izet,npass(maxpp)
c
c     target          target function to be optimized
c     potnrg          (monomer) potential energy returned from TINKER
c     ptnl            vector of individual monomer energies - Includes endpoints
c     tmnrg           TOTAL monomer energy
      real*8 tmnrg,potnrg,target,ptnl(0:maxpp+1)
c
c
c     df,dtot         gradient vectors
c     sixfix          gradients of the six center of mass constraints
c     gc              orthonormal gradients of constraints
c     cnst            constraints
c     vlam            Lagrange multipliers - ( size = nsix+1 )
c     pvect           unit vectors in path direction (array)
c     pdist           distances between adjacent path points
c     gnorm           RMS gradient
c     gntot           TOTAL RMS gradient
c     grdbig          true if path point gradients are too large
      real*8 df(3*maxatm,maxpp),dtot(3*maxatm,maxpp)
      real*8 gc(3*maxatm,ncmax),sixfix(3*maxatm,nsix)
      real*8 cnst(ncmax)
      real*8 vlam(ncmax+1)
      real*8 pvect(maxatm*3,maxpp)
      real*8 pdist(maxpp)
      real*8 gnorm(maxpp),gntot
      real*8 acoeff(ncmax,ncmax)
      logical grdbig
c
      common /lup_constraints/ sixfix,gc,cnst,vlam,acoeff
      common /lup_slope/ pvect
      common /lup_grad/ df,dtot,gnorm,gntot,grdbig
      common /lup_intermed/ potnrg,target,tmnrg,ptnl
      common /lup_pathzet/ izet,npass
