c
c
c     ######################################################################
c     ##                                                                  ##
c     ##     function lup1  --  value and gradient of target function     ##
c     ##                                                                  ##
c     ######################################################################
c
c
      function lup1(p,gt)
      implicit none
      include 'sizes.i'
      include 'pathsz.i'
      include 'pathdata.i'
      include 'lup.i'
      integer j,i
      real*8 lup1,dcterm,cterm
      real*8 gt(nat3),deriv(3*maxatm)
      real*8 p(nat3)
c
c     get potential energy and gradient vector for Intermediate
c
      call anlx(p,potnrg,deriv)
      ptnl(izet)=potnrg
      target=potnrg
c
c     get projection of the energy on constraint's subspace
c
      do i=1,nsix
         vlam(i)=0.0d0
         do j=1,nat3
            vlam(i)=vlam(i)-deriv(j)*gc(j,i)
         end do
      end do
      vlam(nsix+1) = 0.0d0
      do j=1,nat3
         vlam(nsix+1) = vlam(nsix+1)-deriv(j)*pvect(j,izet)
      end do
c
c     get the current values of the constraints
c
      call lupcc(p)
c
c     construct target function
c
      cterm=0.0d0
      do i=1,nsix
         cterm=cterm+vlam(i)*cnst(i)
      end do
      target=target+cterm
      lup1=target
c
c   construct gradient of target function (gt)
c
      do j = 1, nat3
         gt(j) = deriv(j)
      end do
      do j = 1, nat3
         dcterm=0.0d0
         do i = 1, nsix
            dcterm = dcterm + vlam(i)*gc(j,i)
         end do
         dcterm = dcterm + vlam(nsix+1)*pvect(j,izet)
         gt(j) = gt(j) + dcterm
      end do
c
c     now set dtot to the projected gradient
c     ( -  for availability in common )
c     and store the total gradient.
c
      do j = 1, nat3
         df(j,izet)=deriv(j)
         dtot(j,izet) = gt(j)
      end do
      return
      end
