c
c
c     ########################################################
c     ##                                                    ##
c     ##    subroutine lupcc  --  construct the constraints ##
c     ##                                                    ##
c     ########################################################
c
c
c     subroutine "lupcc" gets the constraints for the current
c     coordinates.
c
c     N.B. "cc.f" and "lupcc.f" are different ways of getting
c           the same numbers - could consolidate and use only
c           one way.  if we change 1)  pfix & p0 in  the used one
c                     2)  define ocnst  if spw.i not used
c                     3)  get rid of spw.i and lup.i in the
c                         new version
c
c
      subroutine lupcc(p)
      implicit none
      include 'sizes.i'
      include 'pathsz.i'
      include 'pathdata.i'
      include 'lup.i'
      integer i,j,k
      real*8 pdel,p(nat3)
      real*8 ocnst(ncmax)
c
c     initialize constraints
c
      do i=1,ncmax
         ocnst(i) = 0.0d0
         cnst(i) = 0.0d0
      end do
c
c     get the Original Constraints
c
      do i = 1, nc
         do j=1,nat3
            pdel=p(j)-p0(j)
            ocnst(i)=ocnst(i)+sixfix(j,i)*pdel
          end do
      end do
c
c     ... and rotate them to get those
c     corresponding to the orthonormal set used
c
      do i=1,nc
         cnst(i)=0.0d0
         do k=1,nc
            cnst(i)=cnst(i)+acoeff(i,k)*ocnst(k)
         end do
      end do

      return
      end
