c
c
c     ############################################################
c     ##                                                        ##
c     ##  subroutine lupmain  --  refine paths via LUP method   ##
c     ##                                                        ##
c     ############################################################
c
c
      subroutine lupmain
      implicit none
      include 'sizes.i'
      include 'pathsz.i'
      include 'pathdata.i'
      include 'lup.i'
      include 'pathtol.i'
      include 'output.i'
      include 'pathcoord.i'
      character*8 day,hour
      real*8 lup1,fctval
      real*8 ref_path(3*maxatm,0:maxpp+1)
      real*8 work(3*maxatm,0:maxpp+1)
      real*8 opt_path(3*maxatm,maxpp),dum(3*maxatm)
      real*8 dihedral,phi,psi
      real*4 tarray(2),utot,stot
      integer j
      external lup1,lupdbg
      external dihedral
      equivalence(  pathcrd(1,0), ref_path(1,0) )
c
      call dtime(tarray)
c
c     prepare output files if desired
c
      call outanf
c
c     construct the invariable constraint
c     gradients and do some initializations
c
      call lupsetup(work)
c
c     store intermediate path points in opt_path vector
c
      do izet = 1, lpath
         do j = 1, nat3
            opt_path(j,izet) = work(j,izet)
         end do
      end do

      do while (grdbig)
c
         grdbig=.false.
c
c        calculate the path direction at each path point
c
         call pathslope(opt_path)
c
c        perform partial optimization of path Intermediates
c
         do izet=1,lpath
c
c           calculate the orthonormal constraint gradients
c           using pathslope results
c
            if (gnorm(izet).gt.grdmin) then
               call getgc
c              write (6,*) 'call to GRDCHK'
c              if (npass(izet).eq.0)
c    :         call lupgrdchk(nat3,opt_path(1,izet),lup1)
               call mqn(nat3,opt_path(1,izet),fctval
     :                          ,grdmin,lup1,lupdbg)
               npass(izet)=npass(izet)+1
            endif
c
         end do
c
c        get the RMS gradients of resulting
c        Intermediates; determine GRDBIG
c
         call luprmsgrd
      end do
c
      call dtime(tarray)
      call date(day)
      call time(hour)
c
c     write coordinates of the optimized path
c
      savecycle = .true.
      do izet=1,lpath
         call writeout (opt_path(1,izet),izet)
      end do
c
c     get energy and angle data for LUP results
c
      write(6,*) 'FINAL values:   '
      do izet=1,lpath
         call anlx(opt_path(1,izet),potnrg,dum)
         write(2,80) izet,potnrg,0,0.0,0.0,npass(izet)
      end do
      call anlx(ref_path(1,0),potnrg,dum)
      write (2,70) 'Reactant ',potnrg
      call anlx(ref_path(1,lpath+1),potnrg,dum)
      write (2,70) 'Product ',potnrg
c
c     write to log file
c
      write(2,*)
      write(2,*) 'TOTAL USER TIME :',tarray(1),'RUN FINISHED ON '
     :           ,day, ' AT ',hour

      close(2)

      write(6,*)
      write(6,*) 'TOTAL USER TIME :',tarray(1)
      write(6,*) 'TOTAL SYS  TIME :',tarray(2)
c
   70 format (a,f8.3)
   80 format (i5,3x,2f8.3,3x,2f8.2,3x,i5)

      end
