c
c
c     ################################
c     ##                            ##
c     ##  subroutine lupsetup       ##
c     ##                            ##
c     ################################
c
c
      subroutine lupsetup(work)
      implicit none
      include 'sizes.i'
      include 'pathsz.i'
      include 'cntrl.i'
      include 'pathcoord.i'
      include 'pathdata.i'
      include 'pathatm.i'
      include 'pathtol.i'
      include 'lup.i'
      include 'lupgrdmin.i'
      include 'linmin.i'
      include 'minima.i'
      integer i,j,k,j1,j2,j3
      real*8 work(3*maxatm,0:maxpp+1)
c
c     set the initial optimal path equal to the reference path
c
      if ( (findpath) .or. (restart) ) then
         do izet=0,lpath+1
           do j=1,nat3
              work(j,izet)=pathcrd(j,izet)
           end do
         end do
      else
         call getpol(work)
      end if
c
c     specify optimization parameters for LUP calculation
c
      stpmax=1.0d0
      maxiter=20
c
c     default lupgrdmin is 0.5
c
      grdmin = lupgrdmin
c
c     set optimization control logical and
c     zero the number of refinement passes
c
      grdbig = .true.
      do izet=1,lpath
         gnorm(izet) = 1.0d0
         npass(izet)=0
      end do
c
c     initialize all gradient of constraint vectors
c
      do i = 1, nsix
         do j = 1, 3*maxatm
            sixfix(j,i) = 0.0d0
         end do
      end do
      do i = 1, ncmax
         do j = 1, 3*maxatm
            gc(j,i) = 0.0d0
         end do
      end do
c
c   construct gradients of rigid body motion constraints
c   ( this is "grad C" of Czerminski & Elber )
c
      do  2 j=1,natoms
      j1=3*(j-1)+1
      j2=j1+1
      j3=j2+1

      sixfix(j1,1)=sysms(j)
      sixfix(j2,1)=0.0d0
      sixfix(j3,1)=0.0d0

      sixfix(j1,2)=0.0d0
      sixfix(j2,2)=sysms(j)
      sixfix(j3,2)=0.0d0

      sixfix(j1,3)=0.0d0
      sixfix(j2,3)=0.0d0
      sixfix(j3,3)=sysms(j)

      sixfix(j1,4)=0.0d0
      sixfix(j2,4)=sysms(j)*p0(j3)
      sixfix(j3,4)=sysms(j)*(-p0(j2))

      sixfix(j1,5)=sysms(j)*(-p0(j3))
      sixfix(j2,5)=0.0d0
      sixfix(j3,5)=sysms(j)*(p0(j1))

      sixfix(j1,6)=sysms(j)*p0(j2)
      sixfix(j2,6)=sysms(j)*(-p0(j1))
      sixfix(j3,6)=0.0d0

 2    continue

      return
      end
