c
c
c     #########################################################
c     ##                                                       ##
c     ##  subroutine mincheck2  --  Hessian values for newton  ##
c     ##                                                       ##
c     #########################################################
c
c
      subroutine mincheck2 (mode,xx,h,h_init,h_stop,h_index,h_diag)
      implicit none
      include 'sizes.i'
      include 'activ.i'
      include 'atoms.i'
      integer maxvar
      parameter (maxvar=3*maxatm)
      integer i,nvar
      integer h_init(maxvar),h_stop(maxvar)
      integer h_index(maxhess)
      real*8 xx(maxvar),h_diag(maxvar),h(maxhess)
      character*4 mode
c
c
c     translate optimization parameters to atomic coordinates
c
      if (mode .eq. 'none')  return
      nvar = 0
      do i = 1, n
         if (use(i)) then
            nvar = nvar + 1
            x(i) = xx(nvar)
            nvar = nvar + 1
            y(i) = xx(nvar)
            nvar = nvar + 1
            z(i) = xx(nvar)
         end if
      end do
c
c     compute and store the Hessian elements
c
      call hessian (h,h_init,h_stop,h_index,h_diag)
c
c     translate the coordinates of each active atom;
c     this may be needed when using periodic boundaries
c
      nvar = 0
      do i = 1, n
         if (use(i)) then
            nvar = nvar + 1
            xx(nvar) = x(i)
            nvar = nvar + 1
            xx(nvar) = y(i)
            nvar = nvar + 1
            xx(nvar) = z(i)
         end if
      end do
      return
      end
