c    this routine fragment will find 3N orthogonal vectors
c    one of them ( the first) being the path vector.
c
c    the vectors can be used for taking STEPS in 3N space that
c    are perpendicular to the path vector.
c
c    this requires an array of size 3Nx3N so that N must be small.

      real*8 pbase(nn,nn)
c
c
c     form "3Nx3N" orthonormal basis
c     the first vector is the path vector
c     DON'T NEED _ JUST A QUICK WAY TO GET PVECT
c
      do i = 1, nn
         do j = 1, nn
            pbase(j,i) = 0.0d0
         end do
      end do
      call getbasis(nn,pbase)
      write(50,*) 'numerical grad    analytical grad'
c
c     compute numerical derivative of the energy
c     wrt the atomic coordinates using
c     (dV/dX) = (dV/dPBASE) * ( dPBASE/dX)
c
      do i = 1, 3*maxatm
         num_g(i) = 0.0d0
      end do
      do ibase=2,nn
         do j = 1, nn
            xtrial(j) = x(j) + h*pbase(j,ibase)
         end do
         fx1=lup1(xtrial,dum)
         do j = 1, nn
            xtrial(j) = x(j) - h*pbase(j,ibase)
         end do
         fx2=lup1(xtrial,dum)
         numderiv=(fx1-fx2)/two/h
         do j = 1, 1
            num_g(j) = num_g(j) + numderiv*pbase(j,ibase)
         end do
c
         do j=1,1
             write(50,'(2i,4(f12.8,2x))') ibase
     :              ,j,num_g(j),anal_g(j)
         end do
      end do
c
c     restore original quantities in common block arrays
c
      h=lup1(x,dum)
 999  continue
      stop
      return
      end
c
c
      subroutine getbasis(nn,pbase)
      implicit none
      include 'sizes.i'
      include 'pathsz.i'
      include 'pathdata.i'
      include 'lup.i'
      real*8 pbase(nn,nn)
      real*8 ovlp
      integer i,j,k,nn
c
c     make some diagonal array to start
c
      do i = 1, nn
         pbase(i,i) = 1.0d0
      end do
c
c     the first, and only meaningful vector is the
c     path vector
c
      do j = 1, nn
         pbase(j,1) = pvect(j,izet)
      end do
c
c     now get an orthonormal set of vectors
c
      call gslocal (pbase,nn,nn)
      return
      end

      subroutine gslocal (v,n,m)
      implicit none
      include 'sizes.i'
      include 'pathsz.i'
      integer m,n,j,k,l
      real*8 ovlp,vmag
      real*8 v(100,100),e(100,100)
c
c
c     compute Gram-Schmidt orthogonalization of input vectors
c
      do l = 1, m
         do j = 1, n
            e(j,l) = v(j,l)
         end do
         do k = 1, l-1
            ovlp = 0.0d0
            do j = 1, n
               ovlp = ovlp + v(j,l)*v(j,k)
            end do
            do j = 1, n
               e(j,l) = e(j,l) - ovlp*v(j,k)
            end do
         end do
         vmag = 0.0d0
         do j = 1, n
            vmag = vmag+e(j,l) * e(j,l)
         end do
         vmag = sqrt(vmag)
         do j = 1, n
            v(j,l) = e(j,l) / vmag
         end do
      end do
      return
      end
