c
c
c     ###################################################
c     ##  COPYRIGHT (C)  1990  by  Jay William Ponder  ##
c     ###################################################
c
c     ##############################################################
c     ##                                                          ##
c     ##  subroutine prtrst  --  output of Cartesian coordinates  ##
c     ##                                                          ##
c     ##############################################################
c
c
c     "prtrst" writes out a set of Cartesian coordinates
c     to an external disk file
c
c
      subroutine prtrst (ixyz)
      implicit none
      include 'sizes.i'
      include 'files.i'
      include 'pathsz.i'
      include 'pathcoord.i'
      include 'pathdata.i'
      include 'spwprm.i'
      include 'title.i'
      integer i,j,ixyz
      character*60 rstfile
      logical opened
c
c
c     open output unit if not already done
c
      inquire (unit=ixyz,opened=opened)
      if (.not. opened) then
         rstfile = filename(1:leng)//'.con'
         call version (rstfile,'new')
         open (unit=ixyz,file=rstfile,status='new')
      end if
c
c     write out the number of atoms and the title
c
      if (ltitle .eq. 0) then
         write (ixyz,10)  natoms
   10    format (i5)
      else
         write (ixyz,20)  natoms,title(1:ltitle)
   20    format (i5,2x,a)
      end if
c
c     write out the number of path points
c
      write (ixyz,15)  lpath,rlam,gamma,rho
  15  format (i5,3f8.2)
c
c    write the coordinates for  path points (1) through (lpath+1)
c
      write (ixyz,*) ( (pathcrd(j,i) ,j=1,nat3 ) ,i=1,lpath )
      write (ixyz,*) ( p1(j) ,j=1,nat3 )
      if (.not. opened)  close (unit=ixyz)
      return
      end
