c
c
c     ###################################################
c     ##  COPYRIGHT (C)  1990  by  Jay William Ponder  ##
c     ###################################################
c
c     ##############################################################
c     ##                                                          ##
c     ##  subroutine readrst  --  input of Restart Coordinates    ##
c     ##                                                          ##
c     ##############################################################
c
c
c     "readrst" gets the necessary restart
c     coordinates from an external disk file
c
c
      subroutine readrst (ixyz)
      implicit none
      include 'sizes.i'
      include 'files.i'
      include 'iounit.i'
      include 'title.i'
      include 'pathsz.i'
      include 'pathdata.i'
      include 'pathcoord.i'
      include 'spwprm.i'
      integer i,j,n,ixyz,next
      integer label,code
      character*60 rstfile
      character*80 record,substring
      logical opened,blank,full
c
c
c     open input unit if not already done
c
      inquire (unit=ixyz,opened=opened)
      if (.not. opened) then
         rstfile = filename(1:leng)//'.rst'
         open (unit=ixyz,file=rstfile,status='old')
      end if
c
c     read in the number of atoms
c
      i = 0
      read (ixyz,10)  record
   10 format (a80)
      read (record,*,err=80,end=80)  n
c
c     check for greement with Reactant structure
c
      if (n .ne. natoms) then
         write (iout,22)  n,natoms
   22    format (' READRST  --  disagreement in atoms number ',2i )
         stop
      end if
c
c     check for too many atoms
c
      if (n .gt. maxatm) then
         write (iout,20)  maxatm
   20    format (' READRST  --  The Maximum of',i6,' Atoms',
     &           ' has been Exceeded')
         stop
      end if
c
c     get the title and determine its length
c
      blank = .false.
      full = .false.
      do i = 1, 80
         code = ichar(record(i:i))
         if (code .ne. 32) then
            full = .true.
            if (blank) then
               j = i
               goto 30
            end if
         end if
         if (full .and. (code.eq.0.or.code.eq.32)) then
            blank = .true.
         end if
      end do
   30 continue
      title = ' '
      ltitle = 0
      do i = j+59, j, -1
         code = ichar(record(i:i))
         if (code.ne.0 .and. code.ne.32) then
            title = record(j:i)
            ltitle = i - j + 1
            goto 40
         end if
      end do
   40 continue
c
c     read in the number of path points
c
      read (ixyz,15)  record
   15 format (a80)
      read (record,*,err=80,end=80)  lpath,rlam,gamma,rho
c
c     get the Product and path coordinates
c
      do j = 1, maxatm
         p1(j) = 0.0d0
      end do
      read (ixyz,*) ( ( pathcrd(j,i) ,j=1,nat3 ) ,i=1,lpath )
      read (ixyz,*) ( p1(j) ,j=1,nat3 )
c
      if (.not. opened)  close (unit=ixyz)
      return
c
c     error in reading the restart file
c
   80 continue
      write (iout,90)
   90 format (' READRST  --  Error in Restart File ' )
      if (.not. opened)  close (unit=ixyz)
      return
      end
