c
c
c     ##########################
c     ##                      ##
c     ##  subroutine spw      ##
c     ##                      ##
c     ##########################
c
c
      subroutine spw(spwp,okay)
      implicit none
      include 'sizes.i'
      include 'pathsz.i'
      include 'pathdata.i'
      include 'pathcoord.i'
      include 'pathtol.i'
      include 'spw.i'
      include 'spwprm.i'
      integer i,j,k,l,j1,j2,j3
      integer nsteps,istep,iter
      character*8 day,hour
      real*4 tarray(2),utot,stot
      real*8 zeta,fctval,tnkgrd(3*maxatm)
      real*8 point(3*maxatm)
      real*8 spwp(nat3,0:lpath+1)
      real*8 spw1
      logical okay
      external spw1,dbgout
      call dtime(tarray)
c
c     the okay variable is now  always on
c
      okay = .true.
c
c     store the (variable part of) the current polymer coordinates
c
      do izet=1,lpath
         do j=1,nat3
            pinit(j,izet)=spwp(j,izet)
         end do
      end do
c
c     call optimizer to get the optimal path between the fixed Endpoints
c
      WRITE(6,18) '  GRDMIN  = ',grdmin
      WRITE(6,18) '  RHO,GAMMA,LAMBDA  = ',rho,gamma,rlam
  18  format (a,3f7.2)
      call mqn(lpath*nat3,spwp(1,1),fctval,grdmin,spw1,dbgout)
c
c     get timing information
c
      call dtime(tarray)
      call date(day)
      call time(hour)
c
c     get energy and angle data for FINAL necklace
c
      do izet=1,lpath
         call anlx(spwp(1,izet),potnrg,tnkgrd)
         write(2,80) izet,potnrg,dpath(izet),0.0,0.0,izet
      end do
c
c     calculate the RMS gradients
c
      call grdnorm
      write(6,*) 'FINAL polymer values:   '
      write (6,20) gnorm1(0),gnorm2(0)
      write (6,*) '***************************************************'
      write (6,22)
      write (6,24)
      write (6,*) '***************************************************'
      do izet=1,lpath
         write(6,26)
     :           gnorm1(izet),gnorm2(izet),gnorm3(izet)
     :          ,gnorm4(izet)
      end do
      write(6,*)  ' Product  :',gnorm1(lpath+1),gnorm2(lpath+1)
      write(6,*)  ' TARGET RMS G',gntot
c
c     write the results into pathcrd array
c
      do izet=0,lpath+1
         do j=1,nat3
           pathcrd(j,izet)=spwp(j,izet)
         end do
      end do
c
c     write to log file
c
      write(2,*)
      write(2,60) ' TOTAL MONOMER NRG :',tmnrg,'     CHAIN :',chain
     :           ,'     REPULS:',repuls
      write(2,*)
      write(2,70) ' gamma = ',gamma,' rho = ',rho,' lambda =',rlam
     :           ,'    NO. ITER :',nowiter
      write(2,*) 'TOTAL USER TIME :',tarray(1),'RUN FINISHED ON '
     :           ,day, ' AT ',hour
c

      write(6,*)
      write(6,*) 'TOTAL USER TIME :',tarray(1)
      write(6,*) 'TOTAL SYS  TIME :',tarray(2)

   20 format (/' Reactant :',f8.3,f8.3)
   22 format ('                 RMS gradient ')
   24 format (' chain          rep         monomer       TARGET')
   26 format (f7.3,5x,f7.3,5x,f7.3,5x,f7.3,5x)
   60 format (3(a,f5.0))
   70 format (a,f5.1,a,f4.1,a,f3.1,a,i5)
   80 format (i5,3x,2f8.3,3x,2f8.2,3x,i5)
      return
      end
