c
c
c     ##########################################################
c     ##                                                      ##
c     ##  spw.i  --  variables for SPW                        ##
c     ##                                                      ##
c     ##########################################################
c
c
c     izet            path point index
c     nowiter         iteration number to be written in log file
c
      integer izet,nowiter
c
c     target          target function to be optimized
c     potnrg          (monomer) potential energy returned from TINKER
c     ptnl            vector of individual monomer energies - Includes endpoints
c     tmnrg           TOTAL monomer energy
c     polymer         TOTAL potential energy of polymer
c     chain           inter-monomer potential term
c     repuls          inter-monomer potential term
c     drms            rms distance between adjacent path points
      real*8 tmnrg,potnrg,polymer,target,ptnl(0:maxpp+1)
      real*8 chain,repuls
      real*8 drms
c
c
c     pfix            reference coordinate vector (average of p0 and p1)
c     pinit           initial path between fixed end-points
c     df,dtot         gradient vectors
c     grdchn          gradient of chain term
c     grdrep          gradient of repuls term
c     gc              orthonormal gradients of constraints
c     cnst,ocnst      constraints
c     acoeff          transformation matrix between cnst and ocnst
c     vlam            Lagrange multipliers
c     pdiff           coordinate differences of nearest neighbor path points
c     pdtwo           coordinate differences of NEXT-nearest path points
c     dpath           distances between adjacent path points
c     dtwo            distances between next-nearest path points
c     gnorm1,gnorm2   RMS gradient
c     gnorm3,gnorm4   RMS gradient
c     gntot           TOTAL RMS gradient
      real*8 pfix(3*maxatm)
      real*8 pinit(3*maxatm,maxpp)
      real*8 df(3*maxatm,maxpp),dtot(3*maxatm,maxpp)
      real*8 gc(3*maxatm,ncmax)
      real*8 cnst(ncmax),ocnst(ncmax)
      real*8 acoeff(1:ncmax,1:ncmax)
      real*8 vlam(ncmax,maxpp)
      real*8 pdiff(maxatm*3,0:maxpp)
      real*8 pdtwo(maxatm*3,0:maxpp)
      real*8 dpath(0:maxpp)
      real*8 dtwo(0:maxpp-1)
      real*8 grdchn(3*maxatm,0:maxpp+1)
      real*8 grdrep(3*maxatm,0:maxpp+1)
      real*8 gnorm1(0:maxpp+1),gnorm2(0:maxpp+1),gnorm3(0:maxpp+1)
     :      ,gnorm4(0:maxpp+1),gntot
c
      common /fixed/ pfix
      common /constraints/ gc,ocnst,cnst,acoeff,vlam
      common /path/ pinit,dpath,drms
      common /grad/ df,dtot,grdchn,grdrep,gnorm1,gnorm2,gnorm3
     :             ,gnorm4,gntot
      common /intermed/ potnrg,polymer,target,tmnrg,ptnl,chain,repuls
      common /pathzet/ izet,nowiter
