c
c
c     ######################################################################
c     ##                                                                  ##
c     ##     function spw1  --  value and gradient of target function    ##
c     ##                                                                  ##
c     ######################################################################
c
c
      function spw1(p,gt)
      implicit none
      include 'sizes.i'
      include 'pathsz.i'
      include 'pathdata.i'
      include 'spw.i'
      integer j,i
      real*8 spw1,dcterm,cterm,cterm_izet
      real*8 gt(nat3,lpath),tnkgrd(3*maxatm)
c
c     construct a 2-D array here corresponding to the vector passed in
c
      real*8 p(nat3,lpath)
c
c     get potential energy and gradient vector for each 'monomer'
c
      tmnrg=0.0d0
      do izet=1,lpath
         call anlx(p(1,izet),potnrg,tnkgrd)
         ptnl(izet)=potnrg
         tmnrg=tmnrg+potnrg
         do j=1,nat3
            df(j,izet)=tnkgrd(j)
         end do
      end do
      polymer=tmnrg
c
c     get CHAIN and REPULSION terms and gradients
c
      call monmon(p)
      polymer=polymer+chain+repuls
      target=polymer
c
c     construct the TOTAL gradient
c
      do izet=1,lpath
         do j=1,nat3
            dtot(j,izet)=grdchn(j,izet)+grdrep(j,izet)
            dtot(j,izet)=dtot(j,izet)+df(j,izet)
         end do
      end do
c
c     get projection of polymer energy on constraints subspace
c
      cterm=0.0d0
      do izet=1,lpath
         do i=1,nc
         vlam(i,izet)=0.0d0
            do j=1,nat3
               vlam(i,izet)=vlam(i,izet)-dtot(j,izet)*gc(j,i)
            end do
         end do
c
c        get the values of the constraints for the izet'th monomer
c
         call cc(p(1,izet))
c
c        construct target function
c
         cterm_izet=0.0d0
         do i=1,nc
            cterm_izet=cterm_izet+vlam(i,izet)*cnst(i)
         end do
      cterm=cterm+cterm_izet
      end do
      target=target+cterm
      spw1=target
c
c   construct gradient of target function (gt)
c
      do izet=1,lpath
         do j = 1, nat3
            gt(j,izet) = dtot(j,izet)
         end do
      end do
      do izet = 1, lpath
         do j = 1, nat3
            dcterm=0.0d0
            do i = 1, nc
               dcterm = dcterm + vlam(i,izet)*gc(j,i)
            end do
            gt(j,izet) = gt(j,izet) + dcterm
         end do
      end do
c
c     now set dtot to the projected gradient  (for availability in common)
c
      do izet=1,lpath
         do j = 1, nat3
            dtot(j,izet) = gt(j,izet)
         end do
      end do
      return
      end
