c
c
c     ################################
c     ##                            ##
c     ##  subroutine spwsetup        ##
c     ##                            ##
c     ################################
c
c
c     subroutine "spwsetup" is called by SPWMAIN
c
c
      subroutine spwsetup(spwp)
      implicit none
      include 'sizes.i'
      include 'pathsz.i'
      include 'linmin.i'
      include 'pathdata.i'
      include 'pathatm.i'
      include 'pathtol.i'
      include 'spw.i'
      include 'spwprm.i'
      include 'spwgrdmin.i'
      integer i,j,k,j1,j2,j3
      real*8 tmp(3*maxatm,ncmax),tnkgrd(3*maxatm)
      real*8 spwp(nat3,0:lpath+1)
c
c     obtain the polymer coordinates
c
      call getpol(spwp)
c
      stpmax=1.0d0
c
c     set default value of spwgrdmin
c
      grdmin = spwgrdmin
c
c     get the total system mass
c
      sum_mass=0.0d0
      do i=1,natoms
         sum_mass=sum_mass+sysms(i)
      end do
c
c     initialize gradient of constraint vector
c
      do i = 1, nc
         do j = 1, 3*maxatm
            gc(j,i) = 0.0d0
         end do
      end do
c
c     set pfix=p0
c
      do j=1,nat3
      pfix(j)=p0(j)
      end do
c
c   construct gradient of constraint vectors
c
      do  2 j=1,natoms
      j1=3*(j-1)+1
      j2=j1+1
      j3=j2+1

      gc(j1,1)=sysms(j)
      gc(j2,1)=0.0d0
      gc(j3,1)=0.0d0

      gc(j1,2)=0.0d0
      gc(j2,2)=sysms(j)
      gc(j3,2)=0.0d0

      gc(j1,3)=0.0d0
      gc(j2,3)=0.0d0
      gc(j3,3)=sysms(j)

      gc(j1,4)=0.0d0
      gc(j2,4)=sysms(j)*pfix(j3)
      gc(j3,4)=sysms(j)*(-pfix(j2))

      gc(j1,5)=sysms(j)*(-pfix(j3))
      gc(j2,5)=0.0d0
      gc(j3,5)=sysms(j)*(pfix(j1))

      gc(j1,6)=sysms(j)*pfix(j2)
      gc(j2,6)=sysms(j)*(-pfix(j1))
      gc(j3,6)=0.0d0

 2    continue

      do 11 i=1,nc
      do 11 j=1,3*maxatm
      tmp(j,i)=gc(j,i)
 11   continue

      call gs(gc,nat3,nc)

      call rotmat(tmp)
c
c     get energy and geometry of initial structure
c
      call anlx(p0,potnrg,tnkgrd)
      ptnl(0)=potnrg
      write(6,*) 'R(0)   --->>    energy  = ',potnrg
      write(6,*)
c
c     get energy and geometry of final structure
c
      call anlx(p1,potnrg,tnkgrd)
      ptnl(lpath+1)=potnrg
      write(6,*) 'R(1)   --->>    energy  = ',potnrg
      write(6,*)

      write(6,*) 'END R(0) & R(1) stuff'
      write(6,*)
c
c     prepare output files if desired
c
      open(unit=2,file='spw.log',status='unknown')
c
      write(2,90) 'izet','potnrg','dpath ','phi','psi','izet'
      write(2,90) '----','------','------','---','---','----'
      write(2,*)
c
   90 format(2x,a4,2x,x,a8,x,a8,2x,2a8,3x,a4)
      return
      end
