c
c
c     ###################################################
c     ##  COPYRIGHT (C)  1990  by  Jay William Ponder  ##
c     ###################################################
c
c     #############################################################
c     ##                                                         ##
c     ##  function dbydl  --  evaluates Lambda derivative        ##
c     ##                                                         ##
c     #############################################################
c
c
c     "dbydl" calls the subroutines to calculate the Lambda
c      derivative of the potential energy terms and sums
c      up to form the total derivative
c
c
      function dbydl ()
      implicit none
      include 'sizes.i'
      include 'bound.i'
      include 'dlambda.i'
      include 'pistuf.i'
      include 'potent.i'
      real*8 dbydl
c
c
c     maintain any periodic boundary conditions
c
      if (use_box)  call bounds
c
c     call the energy component routines in order
c
      if (use_bond)    call ebond4
      if (use_angle)   call eangle4
      if (use_imptor)  call eimptor4
      if (use_tors)    call etors4
      if (use_lj)      call elj4
      if (use_charge)  call echarge4
c
c     sum up to give the total lambda derivative
c
      dbydl = ddlbond + ddlangle + ddlitors + ddltors
     :            + ddlvdw + ddlvdw14 + ddlcharge
      return
      end
