
c
c
c     ###################################################
c     ##  COPYRIGHT (C)  1990  by  Jay William Ponder  ##
c     ###################################################
c
c     #############################################################
c     ##                                                         ##
c     ##  subroutine eangle4  --  angle bend and str-bend energy  ##
c     ##                                                         ##
c     *************************************************************
c
c
c     "eangle4" calculates the angle bending derivative with respect to
c      lambda
c
c
      subroutine eangle4
      implicit none
      include 'sizes.i'
      include 'activ.i'
      include 'angle.i'
      include 'angpot.i'
      include 'atoms.i'
      include 'bond.i'
      include 'couple.i'
      include 'dlambda.i'
      include 'math.i'
      include 'mutant.i'
      include 'strbnd.i'
      integer i,j,k,ih,ia,ib,ic,id,nopb,nsb
      real*8 xia,yia,zia,xib,yib,zib
      real*8 xic,yic,zic,xid,yid,zid
      real*8 rab,xab,yab,zab,rap,xap,yap,zap
      real*8 rcb,xcb,ycb,zcb,rcp,xcp,ycp,zcp
      real*8 rdb,xdb,ydb,zdb,rdp,xdp,ydp,zdp
      real*8 xad,yad,zad,xcd,ycd,zcd
      real*8 xip,yip,zip,a,b,c,d
      real*8 de
      real*8 dt,dt2
      real*8 angle
      real*8 dot,cosine,doti,cosi,doto,coso
c
c
c     zero the angle derivative
c
      ddlangle = 0.0d0
c
c     loop over all hybrid angles
c
      do ih = 1, nhangle
         i = ihangle(ih)
         ia = iang(1,i)
         ib = iang(2,i)
         ic = iang(3,i)
         id = iang(4,i)
         nopb = iopb(i)
         nsb = isb(1,i)
         if (use(ia) .or. use(ib) .or. use(ic) .or. use(id)) then
            xia = x(ia)
            yia = y(ia)
            zia = z(ia)
            xib = x(ib)
            yib = y(ib)
            zib = z(ib)
            xic = x(ic)
            yic = y(ic)
            zic = z(ic)
c
c     compute the value of the bond angle
c
            if (nopb.eq.0 .or. nsb.ne.0) then
               xab = xia - xib
               yab = yia - yib
               zab = zia - zib
               rab = sqrt(xab*xab + yab*yab + zab*zab)
               xcb = xic - xib
               ycb = yic - yib
               zcb = zic - zib
               rcb = sqrt(xcb*xcb + ycb*ycb + zcb*zcb)
c
               dot = xab*xcb + yab*ycb + zab*zcb
               cosine = dot / (rab*rcb)
               cosine = min(1.0d0,max(-1.0d0,cosine))
               angle = radian * acos(cosine)
               dt = angle - anat(i)
            end if
c
c     bond angle bending energy derivative with respect to lambda
c
            if (nopb .eq. 0) then
               dt2 = dt * dt
               de = angunit * (hacon10(ih)*dt2 - 2.0d0*
     :             acon(i)*dt*hanat10(ih)  )
               ddlangle = ddlangle + de
            end if
         end if
      end do
      return
      end
