c
c
c     ###################################################
c     ##  COPYRIGHT (C)  1990  by  Jay William Ponder  ##
c     ###################################################
c
c     ###########################################################
c     ##                                                                ##
c     ##  subroutine ebond4  --  bond stretch derivative versus lambda  ##
c     ##                                                                ##
c     ###########################################################
c
c
c     "ebond4" calculates the bond stretching energy and
c
c
      subroutine ebond4
      implicit none
      include 'sizes.i'
      include 'activ.i'
      include 'atoms.i'
      include 'bndpot.i'
      include 'bond.i'
      include 'dlambda.i'
      include 'mutant.i'
      integer i,k,ih,ibond
      real*8 e,dt,dt2,de
      real*8 xr,yr,zr,rik,rik2
c
c
c     zero the bond derivative
c
      ddlbond = 0.0d0
c
c     calculate the bond stretch derivative
c
      do ih = 1, nhbond
         ibond = ihbond(ih)
         i = ibnd(1,ibond)
         k = ibnd(2,ibond)
         if (use(i) .or. use(k)) then
            xr = x(i) - x(k)
            yr = y(i) - y(k)
            zr = z(i) - z(k)
            rik2 = xr*xr + yr*yr + zr*zr
            rik = sqrt(rik2)
            dt = rik - bl(ibond)
c
            if (bndtyp .eq. 'MORSE') then
               de = 0.0d0
            else
               dt2 = dt * dt
               de = bndunit * ( hbk10(ih)*dt2 -
     :                2.0d0*bk(ibond)*dt*hbl10(ih) )
            end if
c
c     increment the total bond energy derivative
c
            ddlbond = ddlbond + de
         end if
      end do
      return
      end
