c
c
c     ###################################################
c     ##  COPYRIGHT (C)  1990  by  Jay William Ponder  ##
c     ###################################################
c
c     ##############################################################
c     ##                                                          ##
c     ##  subroutine echarge4  --  charge-charge lambda derivative  ##
c     ##                                                          ##
c     ##############################################################
c
c
c     "echarge4" calculates the charge-charge interaction energy
c      derivative with respect to lambda
c
c
      subroutine echarge4
      implicit none
      include 'sizes.i'
      include 'activ.i'
      include 'atoms.i'
      include 'bound.i'
      include 'charge.i'
      include 'couple.i'
      include 'electr.i'
      include 'dlambda.i'
      include 'latice.i'
      include 'mutant.i'
      include 'switch.i'
      integer i,j,k,ii,kk,ic,kc,skip(maxatm)
      real*8 de,f,fi,rik,rik2
      real*8 xi,yi,zi,xr,yr,zr
      real*8 xic,yic,zic,xc,yc,zc
      real*8 rc,rc2,rc3,rc4,rc5,taper
c
      if (nion .eq. 0)  return
c
c     zero out the charge interactionderivative
c
      ddlcharge = 0.0d0
c
c     set conversion factor and tapering function coefficients
c
      f = 332.05382d0 / dielec
      call smooth ('CHARGE')
c
c     zero out list of atoms to be skipped
c
      do i = 1, n
         skip(i) = 0
      end do
c
c     calculate charge interaction
c
      do ii = 1, nion-1
         i = iion(ii)
         ic = kion(ii)
         do k = 1, n12(i)
            skip(i12(k,i)) = i
         end do
         do k = 1, n13(i)
            skip(i13(k,i)) = i
         end do
         do k = 1, n14(i)
            skip(i14(k,i)) = -i
         end do
         xi = x(i)
         yi = y(i)
         zi = z(i)
         xic = x(ic)
         yic = y(ic)
         zic = z(ic)
         fi = pchg(ii)
         do kk = ii+1, nion
            k = iion(kk)
            kc = kion(kk)
            if (use(i) .or. use(k)) then
               if (skip(k) .ne. i) then
                  xr = xi - x(k)
                  yr = yi - y(k)
                  zr = zi - z(k)
                  xc = xic - x(kc)
                  yc = yic - y(kc)
                  zc = zic - z(kc)
                  if (use_images)  call images2 (xc,yc,zc,xr,yr,zr)
                  rc2 = xc*xc + yc*yc + zc*zc
                  if (rc2 .le. off2) then
                     rik2 = xr*xr + yr*yr + zr*zr
                     rik = sqrt(rik2)
                     de = pchg(kk)*hchg10(ii) + fi*hchg10(kk)
                     de = de * f
                     if (skip(k) .eq. -i)  de = de / chgscale
                     de = de / rik
                     if (rc2 .gt. cut2) then
                        rc = sqrt(rc2)
                        rc3 = rc2 * rc
                        rc4 = rc2 * rc2
                        rc5 = rc2 * rc3
                        taper = c5*rc5 + c4*rc4 + c3*rc3
     &                             + c2*rc2 + c1*rc + c0
                        de = de * taper
                     end if
                     ddlcharge = ddlcharge + de
                  end if
               end if
            end if
         end do
      end do
c
      return
      end
