c
c
c     ################################################################
c     ##                                                            ##
c     ##  subroutine switchsite  --  assign switching site          ##
c     ##                                                            ##
c     ################################################################
c
c
c
c
      subroutine switchsite
      implicit none
      include 'sizes.i'
      include 'atmtyp.i'
      include 'atoms.i'
      include 'charge.i'
      include 'couple.i'
      include 'files.i'
      include 'inform.i'
      include 'iounit.i'
      include 'molcul.i'
      include 'switch.i'
      integer i,ii,j,k,ikey,next,freeunit
      integer mcut_typ(10),mcut_site(10),nmctype,nmcsite,soltyp
      integer molsite
      character*20 keyword
      character*60 keyfile
      character*80 record,string
      logical exist,header,use_molcut
c
c
c     open the keyword file for the current computation
c
      keyfile = filename(1:leng)//'.key'
      inquire (file=keyfile,exist=exist)
      if (exist) then
         ikey = freeunit ()
         open (unit=ikey,file=keyfile,status='old')
      end if
c
c     store default switching sites for each atom
c
      do i = 1, n
         swsite(i) = i
      end do
c
c     molecule based cutoffs may be optionally used
c     Store in kion(nion), and swsite(n) arrays
c
      use_molcut = .false.
      nmctype = 0
      nmcsite = 0
      do i = 1, 10
         mcut_typ(i) = 0
         mcut_site(i) = 0
      end do
      if (exist) then
         rewind (unit=ikey)
         dowhile (.true.)
            read (ikey,140,end=150)  record
  140       format (a80)
            next = 1
            call gettext (record,keyword,next)
            call upcase (keyword)
c
c     use MOLCUT to specify molecular cutoff ( keep old keyword WATER)
c
            if ( (keyword(1:6) .eq. 'WATER ') .or.
     :           (keyword(1:7) .eq. 'MOLCUT ' ) ) then
               use_molcut = .true.
            end if
            if (keyword(1:10) .eq. 'MCUT_TYPE ') then
               nmctype = nmctype + 1
               string = record(next:80)
               read (string,*,err=150,end=150)  soltyp
               mcut_typ(nmctype) = soltyp
            end if
            if (keyword(1:10) .eq. 'MCUT_SITE ') then
               nmcsite = nmcsite + 1
               string = record(next:80)
               read (string,*,err=150,end=150)  soltyp
               mcut_site(nmcsite) = soltyp
            end if
         end do
  150    continue
      end if
      if (exist)  close (unit=ikey)
c
c     store molecular switching sites based on
c     switching site-type and switching site atom
c
      if (use_molcut) then
         do j = 1, nmctype
            do i = 1, nion
               k = i12(1,iion(i))
               if (itype(k) .eq. mcut_typ(j)) then
                  kion(i) = k
                  swsite(iion(i)) = k
               end if
            end do
         end do
         do j = 1, nmcsite
            molsite = mcut_site(j)
            k = molcule(molsite)
            do i = imol(1,k), imol(2,k)
               ii = nqloc(i)
               if (ii .ne. 0) kion(ii) = molsite
               swsite(i) = molsite
            end do
         end do
      end if
      return
      end
