c
c
c     ***************************************************
c     **  COPYRIGHT (C)  1990  by  Jay William Ponder  **
c     ***************************************************
c
c     *****************************************************************
c     **                                                             **
c     **  subroutine getxyz  --  get Cartesian Coordinate structure  **
c     **                                                             **
c     *****************************************************************
c
c
c     "getxyz" asks for a Cartesian coordinate file name,
c     then reads in the coordinates file
c
c
      subroutine getxyz
      implicit none
      include 'files.i'
      include 'iounit.i'
      include 'output.i'
	include 'sizes.i'
        include 'atoms.i'
	include 'mpole.i'

      integer i,ixyz,last
      integer freeunit,trimtext
      character*1 letter
      external freeunit,trimtext
c
c
c     get the user specified input structure
c
   10 continue
      write (iout,20)
   20 format (/,' Enter Cartesian Coordinate File Name :  ',$)
      read (input,30)  filename
   30 format (a60)
	oldname = filename
      call suffix (filename,'xyz')
      call version (filename,'old')
c
c     set coordinate type, then open and read coordinates
c
      coordtype = 'cartesian'
      ixyz = freeunit ()

      open (unit=ixyz,file=filename,status='old',err=10)
      rewind (unit=ixyz)
      call readxyz (ixyz)
      close (unit=ixyz)
c
c     remove any extension from the filename
c
      leng = trimtext (filename)
      last = leng
      do i = 1, leng
         letter = filename(i:i)
         if (letter .eq. '/')  last = leng
         if (letter .eq. ']')  last = leng
         if (letter .eq. ':')  last = leng
         if (letter .eq. '.')  last = i - 1
      end do
      leng = min(leng,last)
      return
      end
