c	Transform multipoles into new system.
c	Input file: ala.zxy
c	Output file: ala.mdq

	program	t16

	implicit none


        include 'sizes.i'
	include 'atmtyp.i'
        include 'atoms.i'
	include 'couple.i'
        include 'files.i'
        include 'iounit.i'
        include 'title.i'
	include 'mpole.i'

	integer	i,j,k,l 

	real*8	emdq,en
	integer	inew,imdq,freeunit
	character*80 string
	real*8	a0(100,3,3),a1(100,3,3)
	real*8	rm1(13),rm2(13)
	integer skip(maxatm)
	

	write(iout,12) 
 12 	format($'length: ')
	read(input,*) len
	write(iout,21) 
 21 	format($'1-4?: ')
	read(input,*) e14

	call coeffi(9,4)
	call maxind(2)
	call getpara
	
	inew = freeunit ()
        open (unit=inew,file='ala.zxy',status='old')
        rewind (unit=inew)

	read(inew,10) string
 10	format(a80)
	do i=1,n
		read(inew,10) string
		read(string,*) j,zaxis(i),xaxis(i)
	end do


	do i=1,n
		call getzxy(i)		
	end do
	do i=1,n
		do j=1,3
			do k=1,3
				a0(i,j,k) = a(i,j,k)
			end do
		end do
	end do


	do i=1,n
		zt(i) = zaxis(i)
		zb(i) = i
		z2t(i) = zaxis(i)
		z2b(i) = i
		xt(i) = xaxis(i)
		xb(i) = i
	end do
	
	do i=1,n
		call getzxy(i)		
	end do
	do i=1,n
		do j=1,3
			do k=1,3
				a1(i,j,k) = a(i,j,k)
			end do
		end do
	end do

	do i=1,n
		do j=1,3
			do k=1,3
			a(i,j,k) = 0.0d0
				do l=1,3
					a(i,j,k) = a(i,j,k) + 
     &					a1(i,l,j)*a0(i,l,k)
				end do
			end do
		end do
	end do

	imdq = freeunit ()
        open (unit=imdq,file='ala.mdq',status='unknown')
        rewind (unit=imdq)

	do i=1,n
		call rot(i)
		do j=1,13
			multip(i,j) = rmultip(i,j)
		end do
		write(imdq,360) i
 360		format(i6)
		write(imdq,370) multip(i,1)
 370		format(f10.5)
		write(imdq,380) (multip(i,j), j=2,4)
 380		format(3f10.5)
		write(imdq,383) multip(i,5)
 383		format(f10.5)
		write(imdq,386) (multip(i,j), j=8,9)
 386		format(2f10.5)
		write(imdq,390) (multip(i,j), j=11,13)
 390		format(3f10.5)

	end do
	close(inew)
	close(imdq)

	do i=1,n
		do j=1,3
			do k=1,3
				a(i,j,k) = a1(i,j,k)
			end do
		end do
	end do

	do i=1,n
		skip(i) = 0
		call rot(i)
	end do

 

	en = 0.0d0
	do i=1,n-1
		if(e14) then
	        	do k = 1, n12(i)
  		        	skip(i12(k,i)) = i
        		end do
   	    		do k = 1, n13(i)
   	    			skip(i13(k,i)) = i
   	    		end do
		end if
		do k=1,len
			rm1(k) = rmultip(i,k)
		end do
		do j=i+1,n
			if(skip(j) .ne. i) then	
				do k=1,len
					rm2(k) = rmultip(j,k)
				end do
				en = en + emdq(i,j,rm1,rm2)
				write(iout,100) en
 			end if
		end do
	end do

	en = en*627.445d0
	write(iout,100) en
 100	format('Energy: ',f12.6)

	end
