	integer maxrank, max, mcd1, mcd2

	parameter (maxrank=2)
	parameter (max=maxrank*maxrank)
	parameter (mcd2=(3**(maxrank+1)-1)/2)

	real*8	t2,a
	real*8	multip,rmultip
	integer c
	integer mindex,len,iaxes,idma
	integer	zt,zb,z2t,z2b,xt,xb
	character*60 oldname
	logical	use_mdq14
	common /mpole/  t2(mcd2,mcd2),a(maxatm,3,3),
     &		         multip(maxatm,mcd2),rmultip(maxatm,mcd2),
     &			 c(1:2*max+1,0:max,0:max),
     &		         mindex(mcd2,mcd2,4),len,iaxes,idma,
     &			 zt(maxatm),zb(maxatm),z2t(maxatm),z2b(maxatm),
     &			 xt(maxatm),xb(maxatm),
     &			 oldname,use_mdq14

	subroutine coeffi(nn,kk)
       

	implicit none

   	include 'sizes.i'
        include 'atoms.i'
	include 'mpole.i'

       	integer nn,kk,nnn,i,j

	do nnn=1, nn, 2
		c(nnn,0,0) = 1
		do j=1, kk
			c(nnn,j,j) = c(nnn,j-1,j-1)*(-nnn-(j-1)*2)
		end do
	end do

	do nnn=1, nn, 2
		do i=2, kk, 2
			c(nnn,i,0) = c(nnn,i-1,1)
			do j=1,kk-i
				c(nnn,j+i,j) = c(nnn,j+i-1,j-1)*
     &				(-nnn-i-(j-1)*2) + c(nnn,j+i-1,j+1)*(j+1)
			end do
		end do
	end do
	
	return
	end
	function der(di,dj,dk,dx,dy,dz)
       
	implicit none

   	include 'sizes.i'
        include 'atoms.i'
	include	'mpole.i'      

	integer*1 di,dj,dk
	integer	l,m,nn
	real*8 	der
	real*8	dx,dy,dz,r,xr,yr,zr
	real*8 	sumy,sumz
	

	r = sqrt(dx*dx+dy*dy+dz*dz)
	xr = dx/r
	yr = dy/r
	zr = dz/r

	der = 0
	do l=0,dk
		sumy = 0
		do m=0,dj
			sumz = 0
			do nn=0,di
				sumz = sumz + c(l+dk+m+dj+1,di,nn)*(zr**nn)
			end do
			sumy = sumy + c(l+dk+1,dj,m)*(yr**m)*sumz
		end do
		der = der + c(1,dk,l)*(xr**l)*sumy
	end do
	der = der/(r**(di+dj+dk+1))
	
	return
	end
	function digit(ind,ijk)
       
	implicit none
	
	integer	digit,ijk,dig
	integer	ind,dif

	dig = 0
	dif = ind
	
	do while(dif .ge. 0)
		dig = dig + 1
		dif = dif - 100		
	end do
	dif = dif + 100
	if(ijk .eq. 3) then
		digit = dig - 1
	else 
		dig = 0
		do while(dif .ge. 0)
			dig = dig + 1
			dif = dif - 10		
		end do
		dif = dif + 10
		if(ijk .eq. 2) then
			digit = dig - 1
		else 
			dig = 0
			do while(dif .ge. 0)
				dig = dig + 1
				dif = dif - 1		
			end do
			digit = dig - 1
		end if
	end if

	return
	end
		
	function emdqij(i1,i2,rm1,rm2)
       
	implicit none

        include 'sizes.i'
	include 'atmtyp.i'
        include 'atoms.i'
	include 'couple.i'
        include 'files.i'
	include 'mpole.i'
        include 'iounit.i'

	real*8	emdqij
	integer	i1,i2
	real*8	rm1(13),rm2(13)
	real*8	der
	integer	i,j
	real*8	inter(13)
	real*8	dx,dy,dz

	dx = x(i2) - x(i1)
	dy = y(i2) - y(i1)
	dz = z(i2) - z(i1)

	do i=1,len
		do j=1,len
			t2(i,j) =  der(mindex(i,j,1),
     &					mindex(i,j,2),mindex(i,j,3),dx,dy,dz)
			if(mindex(i,j,4) .eq. 1) then
				t2(i,j) = -t2(i,j)
			end if	
		end do
	end do

	do i=1,len
		inter(i) = 0
		do j=1,len	
			inter(i) = inter(i) + rm2(j)*t2(j,i)
		end do
	end do

	emdqij = 0.0d0
	do i=1,len
		emdqij = emdqij + inter(i)*rm1(i)
	end do	
	
	write(iout,10) i1,i2,emdqij
 10	format($'emdqij(',i5,',',i5,'):', f12.6,'   ')

	return
	end
	subroutine empole	

	implicit none


        include 'sizes.i'
	include 'atmtyp.i'
        include 'atoms.i'
	include 'couple.i'
        include 'files.i'
        include 'iounit.i'
        include 'title.i'
	include 'mpole.i'

	integer i,j,k
	real*8 	rm1(13),rm2(13)
	real*8 en,emdq
	integer skip(maxatm)

	do i=1,n
		skip(i) = 0
		call getzxy(i)
		call rot(i)
	end do

	do i=1,n-1
		if(e14) then
	        	do k = 1, n12(i)
  		        	skip(i12(k,i)) = i
        		end do
   	    		do k = 1, n13(i)
   	    			skip(i13(k,i)) = i
   	    		end do
		end if
		do k=1,len
			rm1(k) = rmultip(i,k)
		end do
		do j=i+1,n
			if(skip(j) .ne. i) then	
				do k=1,len
					rm2(k) = rmultip(j,k)
				end do
				en = en + emdq(i,j,rm1,rm2)
				write(iout,100) en
 			end if
		end do
	end do

	en = en*627.445d0
	write(iout,100) en
 100	format('Energy: ',f12.6)

	return
	end
c	Get (x,y,z); Get local frame;get multipoles.


	subroutine getpara

	implicit none


        include 'sizes.i'
	include 'atmtyp.i'
        include 'atoms.i'
	include 'couple.i'
        include 'files.i'
        include 'iounit.i'
        include 'title.i'
        include 'output.i'
	include 'mpole.i'

	integer	z0,z1,x0,x1
	integer freeunit,trimtext
        character*60 axesfile,dmafile
	character*80 string,string1,string2,string3,string4,string5,record
        logical opened,quit
	integer	number,next
	character*3 na,zzt,zzb,zz2t,zz2b,xxt,xxb
	integer	i,j
	real*8	q20,q21c,q21s,q22c,q22s

	call getxyz
	call attach

	filename = oldname
     	call suffix (oldname,'axe')
      	call version (oldname,'old')
     	call suffix (filename,'dma')
      	call version (filename,'old')

        coordtype = 'cartesian'
        iaxes = freeunit ()
        open (unit=iaxes,file=oldname,status='old')
        rewind (unit=iaxes)
        inquire (unit=iaxes,opened=opened)
	if (.not. opened) then
		axesfile = oldname(1:leng)//'.axe'
         	open (unit=iaxes,file=axesfile,status='old')
                rewind (unit=iaxes)
        end if

	idma = freeunit ()
        open (unit=idma,file=filename,status='old')
        rewind (unit=idma)
        inquire (unit=idma,opened=opened)
	if (.not. opened) then
		axesfile = oldname(1:leng)//'.axe'
         	open (unit=iaxes,file=dmafile,status='old')
                rewind (unit=idma)
        end if
	
	do i=1,n
		read(iaxes,200) record
 200		format(a80)

		read (record,*) number
		
		next = 1
                call getword (record,na,next)
	        string = record(next:80)

                next = 1
		call getword (string,zzt,next)
	        string1 = string(next:80)
		next = 1
                call getword (string1,zzb,next)
	        string2 = string1(next:80)

		next = 1
                call getword (string2,zz2t,next)
	        string3 = string2(next:80)
		next = 1
                call getword (string3,zz2b,next)
		string4 = string3(next:80)

		next = 1
                call getword (string4,xxt,next)
                string5 = string4(next:80)
		next = 1
		call getword (string5,xxb,next)

c		write(iout,111) zzt,zzb,zz2t,zz2b,xxt,xxb
c 111		format(6a10)	      

		j = i
		do while(zzt .ne. name(j))
			j = j + 1
			if(j .gt. n) then
				j = 1
			end if
		end do
		zt(i) = j

		j = i
		do while(zzb .ne. name(j))
			j = j + 1
			if(j .gt. n) then
				j = 1
			end if
		end do
		zb(i) = j

		j = i
		do while(zz2t .ne. name(j))
			j = j + 1
			if(j .gt. n) then
				j = 1
			end if
		end do
		z2t(i) = j

		j = i
		do while(zz2b .ne. name(j))
			j = j + 1
			if(j .gt. n) then
				j = 1
			end if
		end do
		z2b(i) = j

		j = i
		do while(xxt .ne. name(j))
			j = j + 1
			if(j .gt. n) then
				j = 1
			end if
		end do
		xt(i) = j

		j = i
		do while(xxb .ne. name(j))
			j = j + 1
			if(j .gt. n) then
				j = 1
			end if
		end do
		xb(i) = j
	end do
	close(iaxes)
		


	do i=1,26
		read(idma,200) record
	end do
	do i=1,n
		read(idma,200) record

		read(idma,200) record
		read(record,*) multip(i,1)
		read(idma,200) record
		read(record,*) multip(i,4),multip(i,2),multip(i,3)
		read(idma,200) record
		read(record,*) q20,q21c,q21s
		read(idma,200) record
		read(record,*) q22c,q22s
		multip(i,13) = q20/3.0d0
		multip(i,7) = q21c*0.866025404d0/3.0d0
		multip(i,10) = q21s*0.866025404d0/3.0d0
		multip(i,5) = (q22c*0.866025404d0 - q20*0.5d0)/3.0d0 
		multip(i,6) = q22s*0.866025404d0/3.0d0
		multip(i,8) = multip(i,6)
		multip(i,9) = -(multip(i,5) + multip(i,13)) 
		multip(i,11) = multip(i,7)
		multip(i,12) = multip(i,10)
		
		do j=1,25
			read(idma,200) record
		end do		
	end do
	close(idma)

	end

c
c
c     ***************************************************
c     **  COPYRIGHT (C)  1990  by  Jay William Ponder  **
c     ***************************************************
c
c     *****************************************************************
c     **                                                             **
c     **  subroutine getxyz  --  get Cartesian Coordinate structure  **
c     **                                                             **
c     *****************************************************************
c
c
c     "getxyz" asks for a Cartesian coordinate file name,
c     then reads in the coordinates file
c
c
      subroutine getxyz
      implicit none
      include 'files.i'
      include 'iounit.i'
      include 'output.i'
	include 'sizes.i'
        include 'atoms.i'
	include 'mpole.i'

      integer i,ixyz,last
      integer freeunit,trimtext
      character*1 letter
      external freeunit,trimtext
c
c
c     get the user specified input structure
c
   10 continue
      write (iout,20)
   20 format (/,' Enter Cartesian Coordinate File Name :  ',$)
      read (input,30)  filename
   30 format (a60)
	oldname = filename
      call suffix (filename,'xyz')
      call version (filename,'old')
c
c     set coordinate type, then open and read coordinates
c
      coordtype = 'cartesian'
      ixyz = freeunit ()

      open (unit=ixyz,file=filename,status='old',err=10)
      rewind (unit=ixyz)
      call readxyz (ixyz)
      close (unit=ixyz)
c
c     remove any extension from the filename
c
      leng = trimtext (filename)
      last = leng
      do i = 1, leng
         letter = filename(i:i)
         if (letter .eq. '/')  last = leng
         if (letter .eq. ']')  last = leng
         if (letter .eq. ':')  last = leng
         if (letter .eq. '.')  last = i - 1
      end do
      leng = min(leng,last)
      return
      end
	subroutine getzxy(i)
       
	implicit none

   	include 'sizes.i'
        include 'atoms.i'
	include	'mpole.i'      

	integer	i
	real*8	dx,dy,dz
	real*8	zi,zj,zk
	real*8	z2i,z2j,z2k
	real*8	xi,xj,xk
	real*8	dotxz,r

	dx = x(zt(i)) - x(zb(i))	
	dy = y(zt(i)) - y(zb(i))	
	dz = z(zt(i)) - z(zb(i))	
	r = sqrt(dx*dx + dy*dy + dz*dz)
	zi = dx/r
	zj = dy/r
	zk = dz/r

	dx = x(z2t(i)) - x(z2b(i))	
	dy = y(z2t(i)) - y(z2b(i))	
	dz = z(z2t(i)) - z(z2b(i))	
	r = sqrt(dx*dx + dy*dy + dz*dz)
	z2i = dx/r
	z2j = dy/r
	z2k = dz/r

	dx = zi + z2i
	dy = zj + z2j
	dz = zk + z2k
	r = sqrt(dx*dx + dy*dy + dz*dz)
	a(i,1,3) = dx/r
	a(i,2,3) = dy/r
	a(i,3,3) = dz/r

	dx = x(xt(i)) - x(xb(i))	
	dy = y(xt(i)) - y(xb(i))	
	dz = z(xt(i)) - z(xb(i))	
	dotxz = dx*a(i,1,3) + dy*a(i,2,3) + dz*a(i,3,3)
	xi = dx - dotxz*a(i,1,3)
	xj = dy - dotxz*a(i,2,3)
	xk = dz - dotxz*a(i,3,3)
	r = sqrt(xi*xi + xj*xj +xk*xk)
	a(i,1,1) = xi/r
	a(i,2,1) = xj/r
	a(i,3,1) = xk/r

	a(i,1,2) = a(i,3,1)*a(i,2,3) - a(i,2,1)*a(i,3,3)
	a(i,2,2) = a(i,1,1)*a(i,3,3) - a(i,3,1)*a(i,1,3) 
	a(i,3,2) = a(i,2,1)*a(i,1,3) - a(i,1,1)*a(i,2,3) 

	return
	end
	subroutine kmpole

	implicit none


        include 'sizes.i'
	include 'atmtyp.i'
        include 'atoms.i'
	include 'couple.i'
        include 'files.i'
        include 'iounit.i'
        include 'title.i'
	include 'mpole.i'

	integer	i

	write(iout,12) 
 12 	format($'length: ')
	read(input,*) len
	write(iout,21) 
 21 	format($'1-4?: ')
	read(input,*) use_mdq14

	call coeffi(9,4)
	call maxind(2)
	call getpara
		
	do i=1,n
		call getzxy(i)
		call rot(i)
	end do
	
	call empole	

	return
	end
	subroutine maxind(order)

	implicit none

   	include 'sizes.i'
        include 'atoms.i'
	include 'mpole.i'

	integer order
	integer	mlen,i,j
	integer	i1,j1,k1,i2,j2,k2
	integer digit
	integer	index(13)
	data index /000,001,010,100,002,011,101,
     &			011,020,110,101,110,200/

	mlen = (3**(order+1)-1)/2

	do i=1,mlen
		i1 = digit(index(i),3)
		j1 = digit(index(i),2)
		k1 = digit(index(i),1)
		do j=1,mlen
			i2 = digit(index(j),3)
			j2 = digit(index(j),2)
			k2 = digit(index(j),1)
			mindex(i,j,4) = i2 + j2 + k2
			mindex(i,j,1) = i1 + i2
			mindex(i,j,2) = j1 + j2
			mindex(i,j,3) = k1 + k2
		end do
	end do

	return
	end
	
	subroutine rot(iatom)

	implicit none

   	include 'sizes.i'
        include 'atoms.i'
	include	'mpole.i'      

	integer	iatom	
	real*8	m2(3,3),r2(3,3)
	integer	i,j,k,l,nn

	rmultip(iatom,1) = multip(iatom,1)

	do i=2,4
		rmultip(iatom,i) = 0
	end do

	do i=2,4
		do j=2,4
			rmultip(iatom,i) = rmultip(iatom,i) + 
     &				multip(iatom,j)*a(iatom,i-1,j-1)
		end do
	end do
	
	nn = 5
	do i=1,3
		do j=1,3
			m2(i,j) = multip(iatom,nn)
			r2(i,j) = 0
			nn = nn + 1
		end do
	end do

	do i=1,3
		do j=1,3
			if(j .lt. i) then
				r2(i,j) = r2(j,i)
			else
			do k=1,3
				do l=1,3
					r2(i,j) = r2(i,j) + 
     &       				   a(iatom,i,k)*a(iatom,j,l)*m2(k,l)
				end do
			end do
			end if
		end do
	end do

	nn = 5
	do i=1,3
		do j=1,3
			rmultip(iatom,nn) = r2(i,j)
			nn = nn + 1
		end do
	end do

	return
	end
