	function emdqij2new(i1,i2,r,rm1,rm2,mjdtmi,mjtdmi,dmjtmi,
     &			mjd2tmi,mjdtdmi,dmjdtmi,dmjtdmi,mjtd2mi,d2mjtmi)
       
	implicit none

	include 'sizes.i'
	include 'atmtyp.i'
	include 'atoms.i'
	include 'couple.i'
	include 'files.i'

	include 'iounit.i'
	include 'mpole.i'
	include 'mpole1.i'
	include 'mpole2.i'
	include 'newco.i'

	real*8	emdqij2new
	integer	i1,i2
	real*8	r,rm1(13),rm2(13)
	real*8	mjdtmi(3),mjtdmi(3,3),dmjtmi(3,3)
	real*8	mjd2tmi(3,3),mjdtdmi(3,3,3),dmjdtmi(3,3,3),dmjtdmi(3,3,3,3)
	real*8	mjtd2mi(3,3,3,3),d2mjtmi(3,3,3,3)
	real*8	t2m
	integer	i,j,k,l,p
	real*8	m2t2(13),t2m1(13),m2dt2(13,3),dt2m1(13,3)
	real*8	t2dm1(13,3,3),inter(13)
	integer	xyz,deri
	real*8	dx,dy,dz
	real*8	dzz1,dzz2,dzz3,dzz4,dzz5,dzz6
	real*8	dyy1,dyy2,dyy3,dyy4,dyy5,dyy6
	real*8	dxx1,dxx2,dxx3,dxx4,dxx5,dxx6
		
	dx = (x(i2) - x(i1))/r
	dy = (y(i2) - y(i1))/r
	dz = (z(i2) - z(i1))/r

	dzz1 = dz
	dzz2 = dzz1*dzz1	
	do i=1,13,2
		bz(i,0) = c(i,0,0)
		bz(i,1) = c(i,1,1)*dzz1
	end do

	dyy1 = dy
	dyy2 = dyy1*dyy1	
	dyy3 = dyy1*dyy2	
	dyy4 = dyy2*dyy2	
	dyy5 = dyy3*dyy2	
	dyy6 = dyy3*dyy3	
	do j=0,1
		do i=1,13,2
			by(i,0,j) = c(i,0,0)*bz(i,j)
			by(i,1,j) = c(i,1,1)*dyy1*bz(i+2,j)
			by(i,2,j) = c(i,2,0)*bz(i+2,j) + c(i,2,2)*dyy2*bz(i+4,j)
			by(i,3,j) = c(i,3,1)*dyy1*bz(i+4,j) + c(i,3,3)*dyy3*bz(i+6,j)
			by(i,4,j) = c(i,4,0)*bz(i+4,j) + c(i,4,2)*dyy2*bz(i+6,j)
     &			+ c(i,4,4)*dyy4*bz(i+8,j)
		end do		
	end do
	by(1,5,0) = c(1,5,1)*dyy1*bz(7,0) + c(1,5,3)*dyy3*bz(9,0)
     &			+ c(1,5,5)*dyy5*bz(11,0)
	by(1,5,1) = c(1,5,1)*dyy1*bz(7,1) + c(1,5,3)*dyy3*bz(9,1)
     &			+ c(1,5,5)*dyy5*bz(11,1)
	by(3,5,0) = c(3,5,1)*dyy1*bz(9,0) + c(3,5,3)*dyy3*bz(11,0)
     &			+ c(3,5,5)*dyy5*bz(13,0)
	by(1,6,0) = c(1,6,0)*bz(7,0) + c(1,6,2)*dyy2*bz(9,0)
     &					+ c(1,6,4)*dyy4*bz(11,0) + c(1,6,6)*dyy6*bz(13,0)

	dxx1 = dx
	dxx2 = dxx1*dxx1	
	dxx3 = dxx1*dxx2	
	dxx4 = dxx2*dxx2	
	dxx5 = dxx3*dxx2	
	dxx6 = dxx3*dxx3	
	bx(0,0) = c(1,0,0)
	bx(1,1) = c(1,1,1)*dxx1
	bx(2,0) = c(1,2,0)
	bx(2,2) = c(1,2,2)*dxx2
	bx(3,1) = c(1,3,1)*dxx1
	bx(3,3) = c(1,3,3)*dxx3
	bx(4,0) = c(1,4,0)
	bx(4,2) = c(1,4,2)*dxx2
	bx(4,4) = c(1,4,4)*dxx4
	bx(5,1) = c(1,5,1)*dxx1
	bx(5,3) = c(1,5,3)*dxx3
	bx(5,5) = c(1,5,5)*dxx5
	bx(6,0) = c(1,6,0)
	bx(6,2) = c(1,6,2)*dxx2
	bx(6,4) = c(1,6,4)*dxx4
	bx(6,6) = c(1,6,6)*dxx6

c	do i=1,3*(3*len+1)+1
c		do j=1,len
c			t2(i,j) =  t2m(mindex(i,j,1),
c     &   	mindex(i,j,2),mindex(i,j,3),dx,dy,dz)
c			if(mindex(i,j,4) .eq. 1) then
c				t2(i,j) = -t2(i,j)
c			end if
c		end do
c	end do

c
c	zeroth order
c
	t2(1,1) = rpower(1)

c
c	first order
c
c	do j = 2, 4
c		t2(j,1) = t2m (mindex(j,1,1),mindex(j,1,2),
c     &                            mindex(j,1,3))
c	end do
	t2(2,1) = t2m (0,0,1)
	t2(3,1) = t2m (0,1,0)
	t2(4,1) = t2m (1,0,0)
	do i = 2, 4
		t2(1,i) = -t2(i,1)
	end do

c
c	second order
c
c	do i = 2, 3
c		do j = i, 4
c			t2(j,i) = -t2m (mindex(j,i,1),mindex(j,i,2),
c     &                            mindex(j,i,3))
c		end do
c	end do
	t2(2,2) = -t2m (0,0,2)
	t2(3,2) = -t2m (0,1,1)
	t2(4,2) = -t2m (1,0,1)
	t2(3,3) = -t2m (0,2,0)
	t2(4,3) = -t2m (1,1,0)
	t2(4,4) = - t2(2,2) - t2(3,3)
	t2(2,3) = t2(3,2)
	t2(2,4) = t2(4,2)
	t2(3,4) = t2(4,3)

	k = 5
	do i = 2, 4
		do j = 2, 4
			t2(1,k) = -t2(i,j)
			t2(k,1) = t2(1,k)
			k = k + 1
		end do
	end do

c
c	third order
c

c	do i = 5, 6
c		do j = i-3, 4
c			t2(j,i) = t2m (mindex(j,i,1),mindex(j,i,2),
c     &                            mindex(j,i,3))
c		end do
c	end do
	t2(2,5) = t2m (0,0,3)
	t2(3,5) = t2m (0,1,2)
	t2(4,5) = t2m (1,0,2)
	t2(3,6) = t2m (0,2,1)
	t2(4,6) = t2m (1,1,1)
	t2(4,7) = - t2(2,5) - t2(3,6)
	t2(2,6) = t2(3,5)
	t2(2,7) = t2(4,5)
	t2(3,7) = t2(4,6)

	t2(2,8) = t2(2,6)
	t2(2,9) = t2(3,6)
	t2(2,10) = t2(4,6)
	t2(3,9) = t2m (0,3,0)						
	t2(3,10) = t2m (1,2,0)
	t2(4,10) = - t2(2,8) - t2(3,9)
	t2(3,8) = t2(2,9)
	t2(4,8) = t2(2,10)
	t2(4,9) = t2(3,10)

	t2(2,11) = t2(2,7)
	t2(2,12) = t2(3,7)
	t2(2,13) = t2(4,7)
	t2(3,12) = t2(3,10)
	t2(3,13) = t2(4,10)
	t2(4,13) = - t2(2,11) - t2(3,12)
	t2(3,11) = t2(2,12)
	t2(4,11) = t2(2,13)
	t2(4,12) = t2(3,13)

	do j = 2, 4
		do i = 5, 13
			t2(i,j) = -t2(j,i)
		end do
	end do

	k = 14
	do j = 5,13
		do i = 2, 4
			t2(k,1) = t2(i,j)
			k = k + 1
		end do
	end do
 
c
c	fourth order
c
c	do i = 5, 6
c		do j = i, 7
c			t2(j,i) = t2m (mindex(j,i,1),mindex(j,i,2),
c     &                            mindex(j,i,3))
c		end do
c	end do
	t2(5,5) = t2m ( 0,0,4)
	t2(6,5) = t2m ( 0,1,3)
	t2(7,5) = t2m ( 1,0,3)
	t2(6,6) = t2m ( 0,2,2)
	t2(7,6) = t2m ( 1,1,2)
	t2(7,7) = - t2(5,5) - t2(6,6)

	t2(8,5) = t2(6,5)
	t2(9,5) = t2(6,6)
	t2(10,5) = t2(7,6)
	t2(9,6) = t2m (0,3,1)	
	t2(10,6) = t2m (1,2,1)
	t2(10,7) = - t2(8,5) - t2(9,6)
	t2(8,6) = t2(9,5)
	t2(8,7) = t2(10,5)
	t2(9,7) = t2(10,6)
	
	t2(11,5) = t2(7,5)
	t2(12,5) = t2(7,6)
	t2(13,5) = t2(7,7)
	t2(12,6) = t2(10,6)
	t2(13,6) = t2(10,7)
	t2(13,7) = - t2(11,5) - t2(12,6)
	t2(11,6) = t2(12,5)
	t2(11,7) = t2(13,5)
	t2(12,7) = t2(13,6)

	t2(8,8) = t2(8,6)
	t2(9,8) = t2(9,6)
	t2(10,8) = t2(10,6)
	t2(9,9) = t2m (0,4,0)
	t2(10,9) = t2m (1,3,0)
	t2(10,10) = -t2(8,8) - t2(9,9)

	t2(11,8) = t2(11,6)
	t2(12,8) = t2(12,6)
	t2(13,8) = t2(13,6)
	t2(12,9) = t2(10,9)
	t2(13,9) = t2(10,10)
	t2(13,10) = -t2(11,8) -t2(12,9)
	t2(11,9) = t2(12,8)
	t2(11,10) = t2(13,8)
	t2(12,10) = t2(13,9)

	t2(11,11) = t2(11,7)
	t2(12,11) = t2(12,7)
	t2(13,11) = t2(13,7)
	t2(12,12) = t2(12,10)
	t2(13,12) = t2(13,10)
	t2(13,13) = -t2(11,11) -t2(12,12)
	do i = 5, 12
		do j = i+1, 13 
			t2(i,j) = t2(j,i)
		end do
	end do

	k = 14
	do j = 5, 13
		do i = 5, 13 ,3
			t2(k,2) = -t2(i,j)
			t2(k,3) = -t2(i+1,j)
			t2(k,4) = -t2(i+2,j)
			k = k + 1
		end do
	end do

	k = 41
	do j=5,13
		do i=5,13
			t2(k,1) = t2(i,j)
			k = k + 1
		end do
	end do

c
c	Fifth order
c
c
c	First Block of Fifth order
c
c	do i = 5, 6
c		do j = i+9, 16
c			t2(j,i) = t2m (mindex(j,i,1),mindex(j,i,2),
c     &                            mindex(j,i,3))
c		end do
c	end do
	t2(14,5) = t2m ( 0,0,5)
	t2(15,5) = t2m ( 0,1,4)
	t2(16,5) = t2m ( 1,0,4)
	t2(15,6) = t2m ( 0,2,3)
	t2(16,6) = t2m ( 1,1,3)
	t2(16,7) = - t2(14,5) - t2(15,6)
	
	t2(17,5) = t2(15,5)
	t2(18,5) = t2(15,6)
	t2(19,5) = t2(16,6)
	t2(18,6) = t2m (0,3,2)
	t2(19,6) = t2m (1,2,2)
	t2(19,7) = - t2(17,5) - t2(18,6)
	t2(17,6) = t2(18,5)
	t2(17,7) = t2(19,5)
	t2(18,7) = t2(19,6)

	t2(17,8) = t2(17,6)
	t2(18,8) = t2(18,6)
	t2(19,8) = t2(19,6)
	t2(18,9) = t2m (0,4,1)
	t2(19,9) = t2m (1,3,1)
	t2(19,10) = -t2(17,8) - t2(18,9)

	t2(20,5) = t2(16,5)
	t2(21,5) = t2(16,6)
	t2(22,5) = t2(16,7)
	t2(21,6) = t2(19,6)
	t2(22,6) = t2(19,7)
	t2(22,7) = -t2(20,5) - t2(21,6)
	t2(20,6) = t2(21,5)
	t2(20,7) = t2(22,5)
	t2(21,7) = t2(22,6)

	t2(20,8) = t2(17,7)
	t2(21,8) = t2(18,7)
	t2(22,8) = t2(19,7)
	t2(21,9) = t2(19,9)
	t2(22,9) = t2(19,10)
	t2(22,10) = -t2(20,8) -t2(21,9)
	t2(20,9) = t2(21,8)
	t2(20,10) = t2(22,8)
	t2(21,10) = t2(22,9)

	t2(20,11) = t2(20,7)
	t2(21,11) = t2(21,7)
	t2(22,11) = t2(22,7)
	t2(21,12) = t2(19,10)
	t2(22,12) = t2(22,10)
	t2(22,13) = -t2(20,11) -t2(21,12)

	do i = 14, 21
		do j = i-8, 13 
			t2(i,j) = t2(j + 9,i - 9)
		end do
	end do

c
c	Second Block of Fifth order
c
	t2(23,5) = t2(17,5)
	t2(24,5) = t2(18,5)
	t2(25,5) = t2(19,5)
	t2(24,6) = t2(18,6)
	t2(25,6) = t2(19,6)
	t2(25,7) = t2(19,7)

	do i = 8, 13
		do j= 17, 19
			t2(j + 12,i - 18) = t2(i,j)
		end do
	end do
	
	t2(26,5) = t2(24,5)
	t2(27,5) = t2(24,6)
	t2(28,5) = t2(25,6)
	t2(27,6) = t2(18,9)
	t2(28,6) = t2(19,9)
	t2(28,7) = -t2(26,5) -t2(27,6)
	t2(26,6) = t2(27,5)
	t2(26,7) = t2(28,5)
	t2(27,7) = t2(28,6)

	t2(26,8) = t2(26,6)
	t2(27,8) = t2(27,6)
	t2(28,8) = t2(28,6)
	t2(27,9) = t2m (0,5,0)
	t2(28,9) = t2m (1,4,0)
	t2(28,10) = -t2(26,8) -t2(27,9)

	t2(29,5) = t2(25,5)
	t2(30,5) = t2(25,6)
	t2(31,5) = t2(25,7)
	t2(30,6) = t2(28,6)
	t2(31,6) = t2(28,7)
	t2(31,7) = -t2(29,5) -t2(30,6)
	t2(29,6) = t2(30,5)
	t2(29,7) = t2(31,5)
	t2(30,7) = t2(31,6)

	t2(29,8) = t2(26,7)
	t2(30,8) = t2(27,7)
	t2(31,8) = t2(28,7)
	t2(30,9) = t2(28,9)
	t2(31,9) = t2(28,10)
	t2(31,10) = -t2(29,8) -t2(30,9) 
	t2(29,9) = t2(30,8)
	t2(29,10) = t2(31,8)
	t2(30,10) = t2(31,9)

	t2(29,11) = t2(29,7)
	t2(30,11) = t2(30,7)
	t2(31,11) = t2(31,7)
	t2(30,12) = t2(30,10)
	t2(31,12) = t2(31,10)
	t2(31,13) = -t2(29,11) -t2(30,12)
	
	do i = 23, 30
		do j = i-17, 13 
			t2(i,j) = t2(j + 18,i - 18)
		end do
	end do

c
c	Third Block of Fifth order
c
	do j = 5, 7
		do i = 32, 40
			t2(i,j) = t2(i - 18,j + 6)
		end do
	end do

	do j = 8, 10
		do i = 32, 40
			t2(i,j) = t2(i - 9,j + 3)
		end do
	end do
	
	do j = 11, 13
		do i = 32, 34
			t2(i,j) = t2(i - 12,j)
		end do
	end do
	
	do j = 11, 13
		do i = 35, 37
			t2(i,j) = t2(i - 6,j)
		end do
	end do

	t2(38,11) = t2(20,13)
	t2(39,11) = t2(21,13)
	t2(40,11) = t2(22,13)
	t2(39,12) = t2(39,10)
	t2(40,12) = t2(40,10)
	t2(40,13) = -t2(38,11) -t2(39,12)
	t2(38,12) = t2(39,11)
	t2(38,13) = t2(40,11)
	t2(39,13) = t2(40,12)

	do j=2,4
		do i=41,67
			t2(i,j) = -t2(i-27,j+3)
		end do
	end do

	do j=2,4
		do i=68,94
			t2(i,j) = -t2(i-54,j+6)
		end do
	end do

	do j=2,4
		do i=95,121
			t2(i,j) = -t2(i-81,j+9)
		end do
	end do

c
c	Sixth order
c

c
c	First block of sixth order
c

	t2(41,5) = t2m(0,0,6)
	t2(42,5) = t2m(0,1,5)
	t2(43,5) = t2m(1,0,5)
	t2(42,6) = t2m(0,2,4)
	t2(43,6) = t2m(1,1,4)
	t2(43,7) = -t2(41,5) -t2(42,6)

	t2(44,5) = t2(42,5)
	t2(45,5) = t2(42,6)
	t2(46,5) = t2(43,6)
	t2(45,6) = t2m(0,3,3)
	t2(46,6) = t2m(1,2,3)
	t2(46,7) = -t2(44,5) -t2(45,6)
	t2(44,6) = t2(45,5)
	t2(44,7) = t2(46,5)
	t2(45,7) = t2(46,6)
	
	t2(44,8) = t2(44,6)
	t2(45,8) = t2(45,6)
	t2(46,8) = t2(46,6)
	t2(45,9) = t2m(0,4,2)
	t2(46,9) = t2m(1,3,2)
	t2(46,10) = -t2(44,8) -t2(45,9)

	t2(47,5) = t2(43,5)
	t2(48,5) = t2(43,6)
	t2(49,5) = t2(43,7)
	t2(48,6) = t2(46,6)
	t2(49,6) = t2(46,7)
	t2(49,7) = -t2(47,5) -t2(48,6)
	t2(47,6) = t2(48,5)
	t2(47,7) = t2(49,5)
	t2(48,7) = t2(49,6)

	t2(47,8) = t2(47,6)
	t2(48,8) = t2(48,6)
	t2(49,8) = t2(49,6)
	t2(48,9) = t2(46,9)
	t2(49,9) = t2(46,10)
	t2(49,10) = -t2(47,8) -t2(48,9)
	t2(47,9) = t2(48,8)
	t2(47,10) = t2(49,8)
	t2(48,10) = t2(49,9)

	t2(47,11) = t2(47,7)
	t2(48,11) = t2(48,7)
	t2(49,11) = t2(49,7)
	t2(48,12) = t2(48,10)
	t2(49,12) = t2(49,10)
	t2(49,13) = -t2(47,11) -t2(48,12)

	do i = 41, 48
		do j = i-35, 13 
			t2(i,j) = t2(j + 36,i - 36)
		end do
	end do

c
c	Second block of sixth order
c
	t2(50,5) = t2(44,5)
	t2(51,5) = t2(45,5)
	t2(52,5) = t2(46,5)
	t2(51,6) = t2(45,6)
	t2(52,6) = t2(46,6)
	t2(52,7) = t2(46,7)

	do j=5,7
		do i=53,55
			t2(i,j) = t2(i-9,j+3)
		end do
	end do
	
	t2(53,8) = t2(53,6)
	t2(54,8) = t2(54,6)
	t2(55,8) = t2(55,6)
	t2(54,9) = t2m(0,5,1)
	t2(55,9) = t2m(1,4,1)
	t2(55,10) = -t2(53,8) - t2(54,9)

	do j=5,7
		do i=56,58
			t2(i,j) = t2(i-12,j+6)
		end do
	end do

	t2(56,8) = t2(56,6)
	t2(57,8) = t2(57,6)
	t2(58,8) = t2(58,6)
	t2(57,9) = t2(55,9)
	t2(58,9) = t2(55,10)
	t2(58,10) = -t2(56,8) -t2(57,9)
	t2(56,9) = t2(57,8)
	t2(56,10) = t2(58,8)
	t2(57,10) = t2(58,9)

	t2(56,11) = t2(56,7)
	t2(57,11) = t2(57,7)
	t2(58,11) = t2(58,7)
	t2(57,12) = t2(57,10)
	t2(58,12) = t2(58,10)
	t2(58,13) = -t2(56,11) - t2(57,12)

	do i = 50, 57
		do j = i-44, 13
			t2(i,j) = t2(j + 45,i - 45)
		end do
	end do		

c
c	Third block of sixth order
c

	do i=5,7
		do j=59,67
			t2(j,i) = t2(j-18,i+6)
		end do
	end do

	do i=8,11
		do j=59,67
			t2(j,i) = t2(j-9,i+3)
		end do
	end do

	do i=11,13
		do j=59,61
			t2(j,i) = t2(j+6,i-6)
		end do
	end do

	do i=11,13
		do j=62,64
			t2(j,i) = t2(j+3,i-3)
		end do
	end do

	t2(65,11) = t2(65,7)
	t2(66,11) = t2(66,7)
	t2(67,11) = t2(67,7)
	t2(66,12) = t2(66,10)
	t2(67,12) = t2(67,10)
	t2(67,13) = -t2(65,11) -t2(66,12)
	t2(65,12) = t2(66,11)
	t2(65,13) = t2(67,11)
	t2(66,13) = t2(67,12)

c
c	Fourth block of sixth order
c

	do i=5,13
		do j=68,76
			t2(j,i) = t2(j-18,i)
		end do
	end do

c
c	Fifth block of sixth order
c

	t2(77,5) = t2(50,8)
	t2(78,5) = t2(51,8)
	t2(79,5) = t2(52,8)
	t2(78,6) = t2(51,9)
	t2(79,6) = t2(52,9)
	t2(79,7) = t2(52,10)

	do i=5,7
		do j=80,85
			t2(j,i) = t2(j-27,i+3)
		end do
	end do

	t2(80,8) = t2(80,6)
	t2(81,8) = t2(81,6)
	t2(82,8) = t2(82,6)
	t2(81,9) = t2m(0,6,0)
	t2(82,9) = t2m(1,5,0)
	t2(82,10) = -t2(80,8) - t2(81,9)

	t2(83,8) = t2(83,6)
	t2(84,8) = t2(84,6)
	t2(85,8) = t2(85,6)
	t2(84,9) = t2(82,9)
	t2(85,9) = t2(82,10)
	t2(85,10) = -t2(83,8) -t2(84,9)
	t2(83,9) = t2(84,8)
	t2(83,10) = t2(85,8)
	t2(84,10) = t2(85,9)

	t2(83,11) = t2(83,7)
	t2(84,11) = t2(84,7)
	t2(85,11) = t2(85,7)
	t2(84,12) = t2(84,10)
	t2(85,12) = t2(85,10)
	t2(85,13) = -t2(83,11) -t2(84,12)

	do i = 77, 84
		do j = i-71, 13
			t2(i,j) = t2(j + 72,i - 72)
		end do
	end do		

c
c	Sixth block of sixth order
c
	do i=5,7
		do j=86,94
			t2(j,i) = t2(j-18,i+6)
		end do
	end do

	do i=8,11
		do j=86,94
			t2(j,i) = t2(j-9,i+3)
		end do
	end do

	do i=11,13
		do j=86,88
			t2(j,i) = t2(j+6,i-6)
		end do
	end do

	do i=11,13
		do j=89,91
			t2(j,i) = t2(j+3,i-3)
		end do
	end do

	t2(92,11) = t2(92,7)
	t2(93,11) = t2(93,7)
	t2(94,11) = t2(94,7)
	t2(93,12) = t2(93,10)
	t2(94,12) = t2(94,10)
	t2(94,13) = -t2(92,11) -t2(93,12)
	t2(92,12) = t2(93,11)
	t2(92,13) = t2(94,11)
	t2(93,13) = t2(94,12)

c
c	Seventh block of sixth order
c
	do i=5,13
		do j=95,103
			t2(j,i) = t2(j-36,i)
		end do
	end do

c
c	Eighth block of sixth order
c
	do i=5,13
		do j=104,112
			t2(j,i) = t2(j-18,i)
		end do
	end do

c
c	Ninth block of sixth order
c
	do i=5,7
		do j=113,121
			t2(j,i) = t2(j-18,i+6)
		end do
	end do

	do i=8,11
		do j=113,121
			t2(j,i) = t2(j-9,i+3)
		end do
	end do

	do i=11,13
		do j=113,115
			t2(j,i) = t2(j+6,i-6)
		end do
	end do

	do i=11,13
		do j=116,118
			t2(j,i) = t2(j+3,i-3)
		end do
	end do

	t2(119,11) = t2(119,7)
	t2(120,11) = t2(120,7)
	t2(121,11) = t2(121,7)
	t2(120,12) = t2(120,10)
	t2(121,12) = t2(121,11)
	t2(121,13) = -t2(119,11) -t2(120,12)
	t2(119,12) = t2(120,11)
	t2(119,13) = t2(121,11)
	t2(120,13) = t2(121,12)


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c	get some matrix products that are needed in the calculations     c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c	get Mj*T2
	do i=1,len
		m2t2(i) = 0
		do j=1,len
			m2t2(i) = m2t2(i) + rm2(j)*t2(j,i)
		end do
	end do

c	get T2*Mi
	do i=1,len
		t2m1(i) = 0.0d0
		do j=1,len	
			t2m1(i) = t2m1(i) + t2(i,j)*rm1(j)
		end do
	end do		

c	get Mj*(dT2/dx),etc.
	do i=1,3
		do j=1,len
			m2dt2(j,i) = 0.0d0
			do k=0,len-1
				m2dt2(j,i) = m2dt2(j,i) + rm2(k+1)*t2(i+1+3*k,j)
			end do
		end do
	end do

c	get (dT2/dx)*Mi,etc.
	do i=1,3
		do j=1,len
			dt2m1(j,i) = 0.0d0
			do k=1,len
				dt2m1(j,i) = dt2m1(j,i) + t2(i+1+3*(j-1),k)*rm1(k)
			end do
		end do
	end do

c	get T2*dMi/dx,etc
	do i=1,2
		do j=1,3
			do k=1,len
				t2dm1(k,i,j) = 0.0d0
				do l=2,len
					t2dm1(k,i,j) = t2dm1(k,i,j) + t2(k,l)*demultip(l,i,j,i1)
				end do
			end do
		end do
	end do
	do j=1,3
		do k=1,len
			t2dm1(k,3,j) = -t2dm1(k,1,j) -t2dm1(k,2,j)
		end do
	end do

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c	caculate the terms for chain rules
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c
c	get energy                      
c
	emdqij2new = 0.0d0
	do i=1,len
		emdqij2new = emdqij2new +rm2(i)*t2m1(i)
	end do

c
c	get Mj*(dT/dx)*Mi,etc
c
	do i=1,3
		mjdtmi(i) = 0.0d0
		do j=1,len
			mjdtmi(i) = mjdtmi(i) + m2dt2(j,i)*rm1(j)
		end do
	end do

c
c	get Mj*(d2T/dxdx)*Mi,etc
c
	do i=1,len
		inter(i) = 0.0d0
		do j=0,len-1
			inter(i) = inter(i) + rm2(j+1)*t2(5+9*j,i)
		end do
	end do
	mjd2tmi(1,1) = 0.0d0
	do i=1,len
		mjd2tmi(1,1) = mjd2tmi(1,1) + inter(i)*rm1(i)
	end do

	do i=1,len
		inter(i) = 0.0d0
		do j=0,len-1
			inter(i) = inter(i) + rm2(j+1)*t2(6+9*j,i)
		end do
	end do
	mjd2tmi(1,2) = 0.0d0
	do i=1,len
		mjd2tmi(1,2) = mjd2tmi(1,2) + inter(i)*rm1(i)
	end do
	mjd2tmi(2,1) = mjd2tmi(1,2)

	do i=1,len
		inter(i) = 0.0d0
		do j=0,len-1
			inter(i) = inter(i) + rm2(j+1)*t2(7+9*j,i)
		end do
	end do
	mjd2tmi(1,3) = 0.0d0
	do i=1,len
		mjd2tmi(1,3) = mjd2tmi(1,3) + inter(i)*rm1(i)
	end do
	mjd2tmi(3,1) = mjd2tmi(1,3)

	do i=1,len
		inter(i) = 0.0d0
		do j=1,len
			inter(i) = inter(i) + rm2(j)*t2(9*j,i)
		end do
	end do
	mjd2tmi(2,2) = 0.0d0
	do i=1,len
		mjd2tmi(2,2) = mjd2tmi(2,2) + inter(i)*rm1(i)
	end do

	do i=1,len
		inter(i) = 0.0d0
		do j=1,len
			inter(i) = inter(i) + rm2(j)*t2(1+9*j,i)
		end do
	end do
	mjd2tmi(2,3) = 0.0d0
	do i=1,len
		mjd2tmi(2,3) = mjd2tmi(2,3)  + inter(i)*rm1(i)
	end do
	mjd2tmi(3,2) = mjd2tmi(2,3)
	mjd2tmi(3,3) = -mjd2tmi(1,1) -mjd2tmi(2,2)

c
c	get (dMj/dx)*T*Mi,Mj*T*(dMi/dx),etc.
c
	do j=1,3
		do i=1,2
			mjtdmi(i,j) = 0.0d0
			dmjtmi(i,j) = 0.0d0
			do k=2,len			
				mjtdmi(i,j) = mjtdmi(i,j) + m2t2(k)*demultip(k,i,j,i1)
				dmjtmi(i,j) = dmjtmi(i,j) + demultip(k,i,j,i2)*t2m1(k)
			end do
		end do
c		mjtdmi(3,j) = -mjtdmi(1,j) -mjtdmi(2,j)
c		dmjtmi(3,j) = -dmjtmi(1,j) -dmjtmi(2,j)
	end do
	do j=1,3
		mjtdmi(3,j) = -mjtdmi(1,j) -mjtdmi(2,j)
		dmjtmi(3,j) = -dmjtmi(1,j) -dmjtmi(2,j)
	end do
c
c	get Mj*(dT2/dx)*(dMi/dx), (dMj/dx)*(dT2/dx)*Mi,etc.
c
	do j=1,3
		do i=1,2
			do k=1,3
				mjdtdmi(k,i,j) = 0.0d0
				dmjdtmi(k,i,j) = 0.0d0
				do l=2,len
					mjdtdmi(k,i,j) = mjdtdmi(k,i,j) + 
     &									m2dt2(l,k)*demultip(l,i,j,i1)
					dmjdtmi(k,i,j) = dmjdtmi(k,i,j) + 
     &									demultip(l,i,j,i2)*dt2m1(l,k)
				end do
			end do
		end do
	end do
	do j=1,3
		do k=1,3
			mjdtdmi(k,3,j) = -mjdtdmi(k,1,j)-mjdtdmi(k,2,j)
			dmjdtmi(k,3,j) = -dmjdtmi(k,1,j)-dmjdtmi(k,2,j)  
		end do
	end do

c
c	get (dMj/dx)*T2*(dMi/dx),etc.
c
	do l=1,3
		do j=1,3
			do k=1,2
				do i=1,3
					dmjtdmi(i,j,k,l) = 0.0d0
					do p=2,len
						dmjtdmi(i,j,k,l) = dmjtdmi(i,j,k,l)
     &				 + demultip(p,i,j,i2)*t2dm1(p,k,l)
					end do
				end do
			end do
		end do
	end do
	do l=1,3
		do j=1,3
			do i=1,3
				dmjtdmi(i,j,3,l) = -dmjtdmi(i,j,1,l)-dmjtdmi(i,j,2,l)
			end do
		end do
	end do

c
c	get Mj*T2*(d2Mi/dxdx),(d2Mj/dxdx)*T2*Mi, etc.
c
	do j=1,3
		do i=1,3
			mjtd2mi(1,i,1,j) = 0.0d0
			mjtd2mi(1,i,3,j) = 0.0d0
			mjtd2mi(3,i,3,j) = 0.0d0
			d2mjtmi(1,i,1,j) = 0.0d0
			d2mjtmi(1,i,3,j) = 0.0d0
			d2mjtmi(3,i,3,j) = 0.0d0
			do k=2,len
				mjtd2mi(1,i,1,j) = mjtd2mi(1,i,1,j) +m2t2(k)*d2m11(k,i,j,i1)
				mjtd2mi(1,i,3,j) = mjtd2mi(1,i,3,j) +m2t2(k)*d2m13(k,i,j,i1)
				mjtd2mi(3,i,3,j) = mjtd2mi(3,i,3,j) +m2t2(k)*d2m33(k,i,j,i1)
				
				d2mjtmi(1,i,1,j) = d2mjtmi(1,i,1,j) +d2m11(k,i,j,i2)*t2m1(k)
				d2mjtmi(1,i,3,j) = d2mjtmi(1,i,3,j) +d2m13(k,i,j,i2)*t2m1(k)
				d2mjtmi(3,i,3,j) = d2mjtmi(3,i,3,j) +d2m33(k,i,j,i2)*t2m1(k)
			end do
		end do
	end do
	do j=1,3
		do i=1,3
			mjtd2mi(1,i,2,j) = -mjtd2mi(1,i,1,j) -mjtd2mi(1,i,3,j)
			mjtd2mi(2,i,3,j) = -mjtd2mi(1,i,3,j) -mjtd2mi(3,i,3,j)
			mjtd2mi(2,j,1,i) = mjtd2mi(1,i,2,j)
			mjtd2mi(3,j,1,i) = mjtd2mi(1,i,3,j)
			mjtd2mi(3,j,2,i) = mjtd2mi(2,i,3,j)

			d2mjtmi(1,i,2,j) = -d2mjtmi(1,i,1,j) -d2mjtmi(1,i,3,j)
			d2mjtmi(2,i,3,j) = -d2mjtmi(1,i,3,j) -d2mjtmi(3,i,3,j)
			d2mjtmi(2,j,1,i) = d2mjtmi(1,i,2,j)
			d2mjtmi(3,j,1,i) = d2mjtmi(1,i,3,j)
			d2mjtmi(3,j,2,i) = d2mjtmi(2,i,3,j)
		end do
	end do		
	do j=1,3
		do i=1,3
			mjtd2mi(2,i,2,j) = -mjtd2mi(1,i,2,j) -mjtd2mi(3,i,2,j)
			d2mjtmi(2,i,2,j) = -d2mjtmi(1,i,2,j) -d2mjtmi(3,i,2,j)
		end do
	end do		
					
	return
	end
