	subroutine d2mpole(ia)

	implicit none

	include 'sizes.i'
	include 'atoms.i'
	include	'mpole.i'      
	include	'mpole1.i'
	include	'mpole2.i'

	integer	ia
	real*8	m2(3,3),dm11(3,3),dm13(3,3),dm33(3,3)
	integer	i,j,k,l,p,q,nn

	call da2(x(ia),y(ia),z(ia),x(zaxis(ia)),y(zaxis(ia)),z(zaxis(ia)),
     &			x(xaxis(ia)),y(xaxis(ia)),z(xaxis(ia)) )

	do p=1,3
		do q=1,3
			do i=2,4
				d2m11(i,p,q,ia) = 0.0d0
				d2m13(i,p,q,ia) = 0.0d0
				d2m33(i,p,q,ia) = 0.0d0
			end do
		end do
	end do
	
	do p=1,3
		do q=1,3
			do i=2,4
				do j=2,4
					d2m11(i,p,q,ia) = d2m11(i,p,q,ia) 
     &				+ multip(ia,j)*d2(i-1,j-1,1,p,1,q)
					d2m13(i,p,q,ia) = d2m13(i,p,q,ia) 
     &			+ multip(ia,j)*d2(i-1,j-1,1,p,3,q)
					d2m33(i,p,q,ia) = d2m33(i,p,q,ia) 
     &				+ multip(ia,j)*d2(i-1,j-1,3,p,3,q)
				end do
			end do
		end do
	end do

	nn = 5
	do i=1,3
		do j=1,3
			m2(i,j) = multip(ia,nn)
			nn = nn + 1
		end do
	end do

	do p=1,3
		do q=1,3
			do i=1,3
				do j=1,3
					dm11(i,j) = 0.0d0
					dm13(i,j) = 0.0d0
					dm33(i,j) = 0.0d0
					do k=1,3
						do l=1,3
							dm11(i,j) = dm11(i,j) + 
     &( d2(i,k,1,p,1,q)*a(ia,j,l) + d(i,k,1,p)*d(j,l,1,q)
     &  + d(i,k,1,q)*d(j,l,1,p) + a(ia,i,k)*d2(j,l,1,p,1,q) )*m2(k,l)

							dm13(i,j) = dm13(i,j) + 
     &( d2(i,k,1,p,3,q)*a(ia,j,l) + d(i,k,1,p)*d(j,l,3,q)
     &  + d(i,k,3,q)*d(j,l,1,p) + a(ia,i,k)*d2(j,l,1,p,3,q) )*m2(k,l)

							dm33(i,j) = dm33(i,j) + 
     &( d2(i,k,3,p,3,q)*a(ia,j,l) + d(i,k,3,p)*d(j,l,3,q)
     &  + d(i,k,3,q)*d(j,l,3,p) + a(ia,i,k)*d2(j,l,3,p,3,q) )*m2(k,l)
						end do
					end do
				end do
			end do

			nn = 5
			do i=1,3
				do j=1,3
					d2m11(nn,p,q,ia) = dm11(i,j)
					d2m13(nn,p,q,ia) = dm13(i,j)
					d2m33(nn,p,q,ia) = dm33(i,j)
					nn = nn + 1
				end do
			end do
		end do
	end do

	return
	end
