c
c
c     ###################################################
c     ##  COPYRIGHT (C)  1993  by  Jay William Ponder  ##
c     ###################################################
c
c     ###############################################################
c     ##                                                           ##
c     ##  program move  --  dimer interaction energy vs. distance  ##
c     ##                                                           ##
c     ###############################################################
c
c
      program move
      implicit none
      include 'sizes.i'
      include 'atoms.i'
      include 'cutoff.i'
      include 'iounit.i'
      integer i,k
      real*8 energy,roff,ron
      real*8 dist,z0(maxatm),y0(maxatm)
      real*8 ztrue0,zcut0,ytrue0,ycut0
      real*8 eztrue,ezcut,eytrue,eycut
c
c
c     set up the structure and mechanics calculation
c
      call initial
      call getxyz
      call mechanic
c
c     store the user supplied electrostatic cutoffs
c
      roff = chgcut
      ron = chgtaper
c     roff = dplcut
c     ron = dpltaper
c
c     use vdw interactions without any cutoff
c
      vdwcut = 1000000.0d0
      vdwtaper = 999999.0d0
c
c     store the coordinate values for the second molecule
c
      do k = n/2+1, n
         z0(k) = z(k)
         y0(k) = y(k)
      end do
c
c     find the energy at large separation without cutoff
c
      chgcut = 1000000.0d0
      chgtaper = 999999.0d0
      dplcut = 1000000.0d0
      dpltaper = 999999.0d0
      do k = n/2+1, n
         dist = 100000.0d0
         z(k) = z0(k) + dist
      end do
      ztrue0 = energy ()
      do k = n/2+1, n
         z(k) = z0(k)
      end do
      do k = n/2+1, n
         dist = 100000.0d0
         y(k) = y0(k) + dist
      end do
      ytrue0 = energy ()
      do k = n/2+1, n
         y(k) = y0(k)
      end do
c
c     find the energy at large separation with cutoff
c
      chgcut = roff
      chgtaper = ron
      dplcut = roff
      dpltaper = ron
      do k = n/2+1, n
         dist = 100000.0d0
         z(k) = z0(k) + dist
      end do
      zcut0 = energy ()
      do k = n/2+1, n
         z(k) = z0(k)
      end do
      do k = n/2+1, n
         dist = 100000.0d0
         y(k) = y0(k) + dist
      end do
      ycut0 = energy ()
      do k = n/2+1, n
         y(k) = y0(k)
      end do
c
c     compute the energy for successive N-O separations
c
      do i = 0, 1500
         do k = n/2+1, n
            dist = 2.0d0 + 0.01d0*dble(i)
            z(k) = z0(k) + dist
         end do
         chgcut = 1000000.0d0
         chgtaper = 999999.0d0
         dplcut = 1000000.0d0
         dpltaper = 999999.0d0
         eztrue = energy ()
         chgcut = roff
         chgtaper = ron
         dplcut = roff
         dpltaper = ron
         ezcut = energy ()
         do k = n/2+1, n
            z(k) = z0(k)
         end do
         do k = n/2+1, n
            dist = 2.0d0 + 0.01d0*dble(i)
            y(k) = y0(k) + dist
         end do
         chgcut = 1000000.0d0
         chgtaper = 999999.0d0
         dplcut = 1000000.0d0
         dpltaper = 999999.0d0
         eytrue = energy ()
         chgcut = roff
         chgtaper = ron
         dplcut = roff
         dpltaper = ron
         eycut = energy ()
         do k = n/2+1, n
            y(k) = y0(k)
         end do
         write (iout,10)  dist,eztrue-ztrue0,ezcut-zcut0,
     &                    eytrue-ytrue0,eycut-ycut0
   10    format (5f12.6)
      end do
      end
