c
c
c     ###################################################
c     ##  COPYRIGHT (C)  1993  by  Jay William Ponder  ##
c     ###################################################
c
c     #################################################################
c     ##                                                             ##
c     ##  program single  --  cutoffs for single charge interaction  ##
c     ##                                                             ##
c     #################################################################
c
c
      program single
      implicit none
      integer i
      real*8 rik,fik,off,cut
      real*8 off2,off3,off4,off5,off6,off7
      real*8 cut2,cut3,cut4,cut5,cut6,cut7
      real*8 etrue,ftrue,htrue
      real*8 ees5,fes5,efsw,ffsw,efsw2,ffsw2
      real*8 eses3t5,fses3t5,eses5t7,fses5t7
      real*8 efsh1,ffsh1,efsh0,ffsh0,efsh4,ffsh4
      real*8 elin,flin,eoff,foff,emid,fmid
      real*8 beta,gamma,a,b,c,d,dv1,k,dv2
      real*8 shift,denom,term
      real*8 taper,dtaper,trans,dtrans
      real*8 c0,c1,c2,c3
      real*8 f0,f1,f2,f3,f4,f5
      real*8 g0,g1,g2,g3,g4,g5
      real*8 k0,k1,k2,k3,k4,k5,k6,k7
c
c
c     set the charge and cutoff values for the interaction
c
      fik = -332.05382d0
      off = 12.0d0
      cut = 8.0d0
c
c     compute powers of the Rcut and Roff distances
c
      off2 = off * off
      off3 = off * off2
      off4 = off2 * off2
      off5 = off2 * off3
      off6 = off3 * off3
      off7 = off3 * off4
      cut2 = cut * cut
      cut3 = cut * cut2
      cut4 = cut2 * cut2
      cut5 = cut2 * cut3
      cut6 = cut3 * cut3
      cut7 = cut3 * cut4
c
c     coefficients for 3rd degree switching polynomial
c
      denom = (cut-off)**3
      c0 = off2 * (3.0d0*cut-off) / denom
      c1 = -6.0d0 * off*cut / denom
      c2 = 3.0d0 * (off+cut) / denom
      c3 = -2.0d0 / denom
c
c     coefficients for 5th degree translation polynomial
c
      term = 9.0d0 * cut*off / (off-cut)
      denom = off5 - 5.0d0*off4*cut + 10.0d0*off3*cut2
     &           - 10.0d0*off2*cut3 + 5.0d0*off*cut4 - cut5
      denom = term * denom
      f0 = off2*cut2 * (18.0d0*off-13.0d0*cut) / denom
      f1 = off*cut
     &        * (-36.0d0*off2-15.0d0*off*cut+26.0d0*cut2) / denom
      f2 = (18.0d0*off3+69.0d0*off2*cut
     &      -24.0d0*off*cut2-13.0d0*cut3) / denom
      f3 = (-41.0d0*off2-30.0d0*off*cut+21.0d0*cut2) / denom
      f4 = (28.0d0*off-3.0d0*cut) / denom
      f5 = -5.0d0 / denom
c
c     coefficients for 5th degree switching polynomial
c
      denom = (off-cut)**5
      g0 = off3 * (off2-5.0d0*off*cut+10.0d0*cut2) / denom
      g1 = -30.0d0 * off2*cut2 / denom
      g2 = 30.0d0 * (off2*cut+off*cut2) / denom
      g3 = -10.0d0 * (off2+4.0d0*off*cut+cut2) / denom
      g4 = 15.0d0 * (off+cut) / denom
      g5 = -6.0d0 / denom
c
c     coefficients for 7th degree translation polynomial
c
      term = 9.3d0 * cut*off / (off-cut)
      denom = cut7 - 7.0d0*cut6*off + 21.0d0*cut5*off2
     &           - 35.0d0*cut4*off3 + 35.0d0*cut3*off4
     &           - 21.0d0*cut2*off5 + 7.0d0*cut*off6 - off7
      denom = term * denom
      k0 = cut3*off3 * (-39.0d0*cut+64.0d0*off) / denom
      k1 = cut2*off2
     &        * (117.0d0*cut2-100.0d0*cut*off-192.0d0*off2) / denom
      k2 = cut*off * (-117.0d0*cut3-84.0d0*cut2*off
     &                +534.0d0*cut*off2+192.0d0*off3) / denom
      k3 = (39.0d0*cut4+212.0d0*cut3*off-450.0d0*cut2*off2
     &         -612.0d0*cut*off3-64.0d0*off4) / denom
      k4 = (-92.0d0*cut3+66.0d0*cut2*off
     &         +684.0d0*cut*off2+217.0d0*off3) / denom
      k5 = (42.0d0*cut2-300.0d0*cut*off-267.0d0*off2) / denom
      k6 = (36.0d0*cut+139.0d0*off) / denom
      k7 = -25.0d0 / denom
c
c     terms used in the force switching (fsw) method
c
      gamma = (off**2 - cut**2)**3
      a = off**4 * (off**2-3.0d0*cut**2) / gamma
      b = 6.0d0 * (cut*off)**2 / gamma
      c = -(cut**2+off**2) / gamma
      d = 2.0d0 / (5.0d0 * gamma)
      dv1 = 8.0d0 * fik *
     &         ((cut*off)**2*(off-cut)-(off**5-cut**5)/5.0d0) / gamma
c
c     terms used in the alternate force switching (fsw2) method
c
      k = fik * sqrt(off) / (sqrt(off)-sqrt(cut))
      dv2 = -fik / sqrt(cut*off)
c
c     compute the energy and force values as a function of distance
c
      do i = 0, 1200
         rik = 3.0d0 + 0.01d0*dble(i)
c
c     no cutoff energy, force and hessian values
c
         etrue = fik / rik
         ftrue = -fik / rik**2
         htrue = 2.0d0 * fik / rik**3
c
c     original 5-th degree energy switch (es5)
c
         if (rik .lt. cut) then
            ees5 = etrue
            fes5 = ftrue
         else if (rik .le. off) then
            ees5 = etrue
            taper = g5*rik**5 + g4*rik**4 + g3*rik**3
     &                  + g2*rik**2 + g1*rik + g0
            dtaper = 5.0d0*g5*rik**4 + 4.0d0*g4*rik**3
     &                  + 3.0d0*g3*rik**2 + 2.0d0*g2*rik + g1
            fes5 = ees5 * dtaper + ftrue * taper
            ees5 = ees5 * taper
         else
            ees5 = 0.0d0
            fes5 = 0.0d0
         end if
c
c     Brooks' force switch (fsw)
c
         if (rik .lt. cut) then
            efsw = etrue + dv1
            ffsw = ftrue
         else if (rik .le. off) then
            efsw = fik * (a*(1.0d0/rik-1.0d0/off) + b*(off-rik)
     &                    + c*(off**3-rik**3) + d*(off**5-rik**5))
            ffsw = ftrue * (off**2-rik**2)**2 *
     &                (off**2+2.0d0*rik**2-3.0d0*cut**2)
     &                      / (off**2-cut**2)**3
         else
            efsw = 0.0d0
            ffsw = 0.0d0
         end if
c
c     Brooks' alternate force switch (fsw2)
c
         if (rik .lt. cut) then
            efsw2 = etrue + dv2
            ffsw2 = ftrue
         else if (rik .le. off) then
            efsw2 = k * (1.0d0/sqrt(rik) - 1.0d0/sqrt(off))**2
            ffsw2 = -k * (1.0d0/sqrt(rik) - 1.0d0/sqrt(off))
     &                       * (1.0d0 / (sqrt(rik))**3)
         else
            efsw2 = 0.0d0
            ffsw2 = 0.0d0
         end if
c
c     Charlie Brooks' MEI4 force shift (fsh or fsh1)
c
         if (rik .le. off) then
            taper = (1.0d0 - (rik/off))**2
            dtaper = -2.0d0 * (1.0d0 - (rik/off)) / off
            efsh1 = etrue * taper
            ffsh1 = etrue*dtaper + ftrue*taper
         else
            efsh1 = 0.0d0
            ffsh1 = 0.0d0
         end if
c
c     Brooks' modified force shift (fsh0)
c
         if (rik .le. off) then
            beta = 0.000001d0
            taper = 1.0d0 + (rik/off) *
     &                 (rik**beta-(beta+1.0d0)*off**beta)
     &                          / (beta * off**beta)
            dtaper = (beta+1.0d0) * (rik**beta - off**beta)
     &                  / (beta * off**(beta+1))
            efsh0 = etrue * taper
            ffsh0 = etrue*dtaper + ftrue*taper
         else
            efsh0 = 0.0d0
            ffsh0 = 0.0d0
         end if
c
c     Brooks' modified force shift (fsh4)
c
         if (rik .le. off) then
            beta = 4.0d0
            taper = 1.0d0 + (rik/off) *
     &                 (rik**beta-(beta+1.0d0)*off**beta)
     &                          / (beta * off**beta)
            dtaper = (beta+1.0d0) * (rik**beta - off**beta)
     &                  / (beta * off**(beta+1))
            efsh4 = etrue * taper
            ffsh4 = etrue*dtaper + ftrue*taper
         else
            efsh4 = 0.0d0
            ffsh4 = 0.0d0
         end if
c
c     linear force over the switching region (lin)
c
         if (rik .lt. cut) then
            shift = -fik/cut - 0.5d0*(off-cut)*(-fik/cut2)
            elin = etrue + shift
            flin = ftrue
         else if (rik .le. off) then
            flin = ((off-rik)/(off-cut)) * (-fik/cut2)
            elin = -0.5d0 * (off-rik) * flin
         else
            elin = 0.0d0
            flin = 0.0d0
         end if
c
c     corrected 3-rd degree shifted energy switch (ses3t5)
c
         if (rik .lt. cut) then
            shift = -fik / (0.5d0*(off+cut))
            eses3t5 = etrue + shift
            fses3t5 = ftrue
         else if (rik .le. off) then
            shift = -fik / (0.5d0*(off+cut))
            taper = c3*rik**3 + c2*rik**2 + c1*rik + c0
            dtaper = 3.0d0*c3*rik**2 + 2.0d0*c2*rik + c1
            trans = fik * (f5*rik**5 + f4*rik**4 + f3*rik**3
     &                        + f2*rik**2 + f1*rik + f0)
            dtrans = fik * (5.0d0*f5*rik**4 + 4.0d0*f4*rik**3
     &                        + 3.0d0*f3*rik**2 + 2.0d0*f2*rik + f1)
            eses3t5 = etrue + shift
            fses3t5 = eses3t5*dtaper + ftrue*taper + dtrans
            eses3t5 = eses3t5*taper + trans
         else
            eses3t5 = 0.0d0
            fses3t5 = 0.0d0
         end if
c
c     corrected 5-th degree shifted energy switch (ses5t7)
c
         if (rik .lt. cut) then
            shift = -fik / (0.5d0*(off+cut))
            eses5t7 = etrue + shift
            fses5t7 = ftrue
         else if (rik .le. off) then
            shift = -fik / (0.5d0*(off+cut))
            taper = g5*rik**5 + g4*rik**4 + g3*rik**3
     &                  + g2*rik**2 + g1*rik + g0
            dtaper = 5.0d0*g5*rik**4 + 4.0d0*g4*rik**3
     &                  + 3.0d0*g3*rik**2 + 2.0d0*g2*rik + g1
            trans = fik * (k7*rik**7 + k6*rik**6 + k5*rik**5
     &                       + k4*rik**4 + k3*rik**3
     &                       + k2*rik**2 + k1*rik + k0)
            dtrans = fik * (7.0d0*k7*rik**6 + 6.0d0*k6*rik**5
     &                      + 5.0d0*k5*rik**4 + 4.0d0*k4*rik**3
     &                      + 3.0d0*k3*rik**2 + 2.0d0*k2*rik + k1)
            eses5t7 = etrue + shift
            fses5t7 = eses5t7*dtaper + ftrue*taper + dtrans
            eses5t7 = eses5t7*taper + trans
         else
            eses5t7 = 0.0d0
            fses5t7 = 0.0d0
         end if
c
c     5-th degree shifted energy switch, shift from off (ses5-off)
c
         if (rik .lt. cut) then
            shift = -fik / off
            eoff = etrue + shift
            foff = ftrue
         else if (rik .le. off) then
            shift = -fik / off
            eoff = etrue + shift
            taper = g5*rik**5 + g4*rik**4 + g3*rik**3
     &                  + g2*rik**2 + g1*rik + g0
            dtaper = 5.0d0*g5*rik**4 + 4.0d0*g4*rik**3
     &                  + 3.0d0*g3*rik**2 + 2.0d0*g2*rik + g1
            eoff = etrue + shift
            foff = eoff*dtaper + ftrue*taper
            eoff = eoff*taper
         else
            eoff = 0.0d0
            foff = 0.0d0
         end if
c
c     5-th degree shifted energy switch, shift from midpoint (ses5)
c
         if (rik .lt. cut) then
c           shift = -fik / (0.5d0*(off+cut))
            shift = -fik / (0.52d0*off+0.48d0*cut)
            emid = etrue + shift
            fmid = ftrue
         else if (rik .le. off) then
c           shift = -fik / (0.5d0*(off+cut))
            shift = -fik / (0.52d0*off+0.48d0*cut)
            emid = etrue + shift
            taper = g5*rik**5 + g4*rik**4 + g3*rik**3
     &                  + g2*rik**2 + g1*rik + g0
            dtaper = 5.0d0*g5*rik**4 + 4.0d0*g4*rik**3
     &                  + 3.0d0*g3*rik**2 + 2.0d0*g2*rik + g1
            emid = etrue + shift
            fmid = emid*dtaper + ftrue*taper
            emid = emid*taper
         else
            emid = 0.0d0
            fmid = 0.0d0
         end if
c
c     write the output file
c
         write (*,10)  rik,etrue,ftrue,htrue,
     &                 ees5,fes5,efsw,ffsw,efsw2,ffsw2,
     &                 efsh1,ffsh1,efsh4,ffsh4,efsh0,ffsh0,
     &                 elin,flin,eoff,foff,emid,fmid,
     &                 eses3t5,fses3t5,eses5t7,fses5t7,
     &                 fes5-ftrue,ffsw-ftrue,ffsw2-ftrue,
     &                 ffsh1-ftrue,ffsh4-ftrue,ffsh0-ftrue,
     &                 flin-ftrue,foff-ftrue,fmid-ftrue,
     &                 fses3t5-ftrue,fses5t7-ftrue,
     &                 fes5/ftrue,ffsw/ftrue,ffsw2/ftrue,
     &                 ffsh1/ftrue,ffsh4/ftrue,ffsh0/ftrue,
     &                 flin/ftrue,foff/ftrue,fmid/ftrue,
     &                 fses3t5/ftrue,fses5t7/ftrue,
     &                 ees5-efsw,emid-efsw,fes5-ffsw,fmid-ffsw
   10    format (52f10.4)
      end do
      end
