c
c     ##############################################################
c     ##                                                          ##
c     ##  subroutine cellatom  --  add new atom to the unit cell  ##
c     ##                                                          ##
c     ##############################################################
c
c
c     "cellatom" completes the addition of a symmetry
c     related atom to a unit cell by updating the atom
c     type and attachment arrays
c
c
      subroutine cellatom (jj,j)
      implicit none
      include 'sizes.i'
      include 'atmtyp.i'
      include 'atoms.i'
      include 'couple.i'
      integer i,j,jj,delta
c
c
c     attachments to atom "jj" are analogous to
c     those of atom "j" in the base molecule
c
      delta = jj - j
      n12(jj) = n12(j)
      do i = 1, n12(j)
         i12(i,jj) = i12(i,j) + delta
      end do
      do i = n12(j)+1,maxval
         i12(i,jj) = 0
      end do
      type(jj) = type(j)
      name(jj) = name(j)
      return
      end
c
