c
c
c     ###################################################
c     ##  Wijnand Mooij    march 1997                  ##
c     ##                                               ##
c     ###################################################
c
c     #################################################################
c     ##                                                             ##
c     ##  subroutine getcssr  --  get CSSR coordinate file           ##
c     ##  in which the charge flag is used as the atom type flag     ##
c     ##                                                             ##
c     #################################################################
c
c
c     "getcssr" asks for a CSSR coordinate file name,
c     then reads in the coordinates file
c
c
      subroutine getcssr
      implicit none
      include 'iounit.i'
      include 'output.i'
      include 'spgr.i'
      include 'files.i'

      integer ixyz,icon
      integer freeunit
      character*60 cssrfile,confile
      logical exist
c
c
c     try to get a filename from the command line arguments
c
      call nextarg (cssrfile,exist)
      if (exist) then
         call basefile (cssrfile)
         call suffix (cssrfile,'cssr')
         call version (cssrfile,'old')
         inquire (file=cssrfile,exist=exist)
      end if
c
c     ask for the user specified input structure filename
c
      dowhile (.not. exist)
         write (iout,10)
 10      format (/,' Enter coordinate (.cssr) File Name :  ',$ 
     +        )
         read (input,20)  cssrfile
   20    format (a60)
         call basefile (cssrfile)
         call suffix (cssrfile,'cssr')
         call version (cssrfile,'old')
         inquire (file=cssrfile,exist=exist)
      end do
      
c
c     first open and then read the Cartesian coordinates file
c
      ixyz = freeunit ()
      open (unit=ixyz,file=cssrfile,status='old')
      rewind (unit=ixyz)
      call readcssr (ixyz)
      close (unit=ixyz)
      return
      end







