c
c
c     ###################################################
c     ##  Wijnand Mooij    march 1997                  ##
c     ##                                               ##
c     ###################################################
c
c     #################################################################
c     ##                                                             ##
c     ##  subroutine getspf  --  get pluton spf xtal-coordinate file ##
c     ##    + an atomtype and connecttivity file                     ##
c     #################################################################
c
c
c     "getspf" asks for a Cartesian coordinate file name,
c     then reads in the coordinates file
c
c
      subroutine getspf
      implicit none
      include 'iounit.i'
      include 'output.i'
      include 'spgr.i'
      include 'files.i'

      integer ixyz,icon
      integer freeunit
      character*60 spffile,confile
      logical exist
c
c
c     try to get a filename from the command line arguments
c
      call nextarg (spffile,exist)
      if (exist) then
         call basefile (spffile)
         call suffix (spffile,'spf')
         call version (spffile,'old')
         inquire (file=spffile,exist=exist)
      end if
c
c     ask for the user specified input structure filename
c
      dowhile (.not. exist)
         write (iout,10)
 10      format (/,' Enter fractional coordinate (.spf) File Name :  ',$ 
     +        )
         read (input,20)  spffile
   20    format (a60)
         call basefile (spffile)
         call suffix (spffile,'spf')
         call version (spffile,'old')
         inquire (file=spffile,exist=exist)
      end do
      
c     Try to get a connectivity file from basename  
      confile = filename(1:leng)//'.con'
      inquire (file=confile,exist=exist)

      dowhile (.not. exist)
         write (iout,11)
 11      format (/,' Enter connectivity (.con) File Name :  ',$ 
     +        )
         read (input,20)  confile
         call suffix (confile,'con')
         call version (confile,'old')
         inquire (file=confile,exist=exist)
      end do
     

c
c     first open and then read the Cartesian coordinates file
c
      ixyz = freeunit ()
      open (unit=ixyz,file=spffile,status='old')
      rewind (unit=ixyz)
      icon = freeunit()
      open (unit=icon,file=confile,status='old')
      rewind (unit=icon)
      call readspf (ixyz,icon)
      close (unit=ixyz)
      close (unit=icon)
      return
      end





