c
c
c     ###################################################
c     ##  COPYRIGHT (C)  1990  by  Jay William Ponder  ##
c     ##              All Rights Reserved              ##
c     ###################################################
c
c     ###############################################################
c     ##                                                           ##
c     ##  subroutine kaniso  --  anisotropic repulsion ##
c     ##  parameter assignment                                     ##
c     ##                                                           ##
c     ###############################################################
c
c Wijand Mooij, july 1997

c     "kaniso" assigns parameters to be used in computing the
c     anisotropic repulsion, processes any new or
c changed values for these parameters. 
c VDW-type WIlliams
c ANISO  atomtype   A
c
      subroutine kaniso
      implicit none
      include 'sizes.i'
      include 'atmtyp.i'
      include 'atoms.i'
      include 'inform.i'
      include 'iounit.i'
      include 'keys.i'
      include 'math.i'
      include 'aniso.i'
      integer i,k,ia,ib,next,l,j
      integer size,number
      real*8 A
      character*6 pt
      character*20 keyword
      character*80 record,string
      logical header
c
c
c     process keywords containing van der Waals parameters
c
      
      do i = 1, maxclass
         aniso(i)=0.0d0
      end do
      
      header = .true.
      do i = 1, nkey
         next = 1
         record = keyline(i)
         call gettext (record,keyword,next)
         call upcase (keyword)
         if (keyword(1:6) .eq. 'ANISO ') then
            k = 0
            A = 0.0d0
            string = record(next:80)
            read (string,*,err=10,end=10)  k,A
   10       continue
            if (k.ge.1 .and. k.le.maxtyp) then
               if (header) then
                  header = .false.
                  write (iout,20)
 20               format (/,' Additional Anisotropic Repulsion',
     &                          ' Parameters :',
     &                       //,6x,'Class      A')
               end if
               write (iout,30)  k,A
 30            format (4x,i6,1x,3f12.4,f11.3)
               aniso(k) = A
            else if (k .gt. maxclass) then
               write (iout,40)  maxclass
   40          format (/,' KVDW  --  Only Atom Classes through',i4,
     &                       ' are Allowed')
               abort = .true.
            end if
         end if
      end  do
      
c
c     remove zero-sized atoms from the list of vdw sites
c
      naniso = 0
      do i = 1, n
         nraniso(i) = 0
         if (aniso(class(i)) .ne. 0.0d0) then
            naniso = naniso + 1
            nraniso(i) = naniso
            ianiso(naniso) = i
         end if
      end do
      return
      end
