c
c
c     ###################################################
c     ##  COPYRIGHT (C)  1990  by  Jay William Ponder  ##
c     ##              All Rights Reserved              ##
c     ###################################################
c
c     ###############################################################
c     ##                                                           ##
c     ##  subroutine khbond  --  MM3-hydrogen bond parameter         ##
c     ##                                                           ##
c     ###############################################################
c
c
c     "khbond" assigns the parameters to be used in computing the
c     MM3-hydrogen bond interactions and processes any new or changed
c     values for these parameters
c     Wijnand Mooij, october 1997, based on kvdwpr
c
      subroutine khbondintra
      implicit none
      include 'sizes.i'
      include 'atmtyp.i'
      include 'atoms.i'
      include 'couple.i'
      include 'inform.i'
      include 'iounit.i'
      include 'keys.i'
      include 'khbintra.i'
      include 'math.i'
      include 'kbonds.i'
      include 'hbondintra.i'
      include 'bond.i'
      
      integer i,k,ia,ib,next,ibond
      integer size,number
      real*8 rd,ep
      real*8 srad(maxtyp),seps(maxtyp)
      character*3 pa,pb
      character*6 pt
      character*20 keyword
      character*80 record,string
      logical header
c
c     process keywords containing H-bond parameters
c
      header = .true.
      do i = 1, nkey
         next = 1
         record = keyline(i)
         call gettext (record,keyword,next)
         call upcase (keyword)
         if (keyword(1:12) .eq. 'HBOND-INTRA ') then
            ia = 0
            ib = 0
            rd = 0.0d0
            ep = 0.0d0
            string = record(next:80)
            read (string,*,err=80,end=80)  ia,ib,rd,ep
            if (header) then
               header = .false.
               write (iout,50)
 50            format (/,' User Hydrogen Bpnd Parameters for:',
     &              //,6x,'Classes',5x,'Radii Sum',3x,'Epsilon',
     +              3x,'Bondlength'/)
            end if
            write (iout,60)  ia,ib,rd,ep
   60       format (3x,2i4,2x,3f12.4)
            size = 3
            call numeral (ia,pa,size)
            call numeral (ib,pb,size)
            if (ia .le. ib) then
               pt = pa//pb
            else
               pt = pb//pa
            end if
            do k = 1, maxnhb
               if (khb(k).eq.'      ' .or. khb(k).eq.pt) then
                  khb(k) = pt
                  radhb(k) = rd
                  epshb(k) = ep
                  goto 80
               end if
            end do
            write (iout,70)
   70       format (/,' KVDW  --  Too many Special Hbond',
     &                 ' Parameters')
            abort = .true.
   80       continue
         end if
      end do
      
c
c     radii and well depths for Hbond class pairs
c
c First set everything to zero:
      do i = 1, maxclass
         do k = i, maxclass
            radminhb(i,k)=0.0d0
            radminhb(k,i)=0.0d0
            epsilonhb(i,k)=0.0d0
            epsilonhb(k,i)=0.0d0
            bondlength(i,k)=0.0d0
            bondlength(k,i)=0.0d0
         enddo
      enddo

      do i = 1, maxnhb
         if (khb(i) .eq. '      ')  goto 90
         ia = number (khb(i)(1:3))
         ib = number (khb(i)(4:6))
         radminhb(ia,ib) = radhb(i)
         radminhb(ib,ia) = radhb(i)
         epsilonhb(ia,ib) = abs(epshb(i))
         epsilonhb(ib,ia) = abs(epshb(i))
      end do
 90   continue
      
c Put the natural bondlengths in a matrix
      do ibond = 1, nbond
         i = ibnd(1,ibond)
         k = ibnd(2,ibond)
         ia = class (i)
         ib = class (k)
         bondlength(ia,ib) = bl(ibond)
         bondlength(ib,ia) = bl(ibond)
      enddo

         

      return
      end

