c
c
c     ###################################################
c     ##  COPYRIGHT (C)  1990  by  Jay William Ponder  ##
c     ##              All Rights Reserved              ##
c     ###################################################
c
c     ##############################################################
c     ##                                                          ##
c     ##  subroutine prtgamess -- utput of Gamess input file      ##
c     ##                                                          ##
c     ##############################################################
c
c
c     "prtgamess" writes out a set of coordinates and some default things 
c     to an external disk file for a subsequent Gamess DMA calculation
c
c
      subroutine prtgamess(fine)
      implicit none
      include 'sizes.i'
      include 'atmtyp.i'
      include 'atoms.i'
      include 'couple.i'
      include 'files.i'
      include 'titles.i'
      include 'spgr.i'
      include 'math.i'
      include 'boxes.i'
      include 'molcul.i'

      integer i,k,igamess,j,freeunit
      character*60 coordfile,gamessoutfile,gamessdir,ed3file,string
      character*8 naam
      logical opened,fine
      character*1 digit(1:9)
      data digit / '1','2','3','4','5','6','7','8','9' /
      
c
c
c     open output unit if not already done
c
      igamess = freeunit ()

      do j=1,nmol 
         if (nmol.eq.1) then
            coordfile = filename(1:leng)//'.gamess'
         else
            coordfile = filename(1:leng)//'-m'//digit(j)
     +           //'.gamess'
         endif
      
c     string = '../'//filename(1:leng)//'.ed3'
c      call gettext(string,ed3file,1)
         call version (coordfile,'new')
         open (unit=igamess,file=coordfile,status='new')     
c
c     write out the number of atoms and the title
c
         write (igamess,'(a11)') '#!/sbin/csh'
         write (igamess,'(a7)') 'scratch'
c     write (igamess,14) ed3file
c14   format('setenv ed3',1x,a60)
         write (igamess,12)
 12      format ('gamess6 << EOF ') 
         write (igamess,'(a5)') 'TITLE'
c         if (fine) then
         if (nmol.eq.1) then
            write (igamess,13) filename(1:leng)
         else
            write (igamess,14) filename(1:leng),j
         endif


c         else
c            write (igamess,15) filename(1:leng)
c         endif
         write (igamess,'(a6)') 'NOSYMM'
         write (igamess,'(a18)') 'GEOMETRY  ANGSTROM'
c 13      format('nr',1x,a20,1x,'6-31G + 1d berekening')
 13      format('nr',1x,a20,1x,'DZPP/DZ/DZ berekening')
 14      format('nr',1x,a20,1x,'DZPP/DZ/DZ berekening, molecule ',i4)
c 15   format('nr',1x,a20,1x,'3-21G + 1d berekening')
         do k = imol(1,j),imol(2,j)
            i = kmol(k)
            naam=name(i)
c         if (name(i).eq.'H') then
c            if (name(i12(1,i)).eq.'O') naam='H1'
c            if (name(i12(1,i)).eq.'C') naam='H2'
c         endif
            write (igamess,17) x(i),y(i),z(i),real(atomic(i)),naam
         enddo
 17      format(3f13.7,2x,f6.1,1x,a8)
         write (igamess,'(a3)') 'END'
c         write (igamess,'(a8)') 'HARMONIC'
         write (igamess,'(a5)') 'BASIS'
c         if (fine) then
c            write (igamess,'(a10)') 'SV C 6-31G'
c           write (igamess,'(a10)') 'SV O 6-31G'
c           write (igamess,'(a10)') 'SV H 6-31G'
c        else
c            write (igamess,'(a10)') 'SV C 3-21G'
c            write (igamess,'(a10)') 'SV O 3-21G'
c            write (igamess,'(a10)') 'SV H 3-21G'
c         endif
c      write (igamess,*) 'd   o'
c      write (igamess,*) '1.0            0.5'
c      write (igamess,'(a3)') 'END'

         write (igamess,*) 's   c'
         write (igamess,*) '1.0           0.156590'
         write (igamess,*) 's   c'
         write (igamess,*) '1.0            0.511900'
         write (igamess,*) 's   c'
         write (igamess,*) '0.214974      2.418049'
         write (igamess,*) '0.438742      6.175776'
         write (igamess,*) 's   c'
         write (igamess,*) '0.318931     16.823562'
         write (igamess,*) '0.130600     50.815942'
         write (igamess,*) '0.036344    178.350830'
         write (igamess,*) '0.007228    782.204795'
         write (igamess,*) '0.000937   5240.635258'
         write (igamess,*) 'p   c'
         write (igamess,*) '1.0            0.121940'
         write (igamess,*) 'p   c'
         write (igamess,*) '0.499411      0.385540'
         write (igamess,*) '0.288744      1.206710'
         write (igamess,*) '0.086279      4.159240'
         write (igamess,*) '0.013887     18.841800'
         write (igamess,*) 's   o'
         write (igamess,*) '1.0            0.300686'
         write (igamess,*) 's   o'
         write (igamess,*) '1.0            1.004271'
         write (igamess,*) 's   o'
         write (igamess,*) '0.243172      4.756803'
         write (igamess,*) '0.444870     12.287469'
         write (igamess,*) 's   o'
         write (igamess,*) '0.301552     33.905805'
         write (igamess,*) '0.115596    103.651793'
         write (igamess,*) '0.031157    364.725257'
         write (igamess,*) '0.006153   1599.709689'
         write (igamess,*) '0.000799  10662.284940'
         write (igamess,*) 'p   o'
         write (igamess,*) '1.0            0.214882'
         write (igamess,*) 'p   o'
         write (igamess,*) '0.492470      0.723164'
         write (igamess,*) '0.307748      2.308269'
         write (igamess,*) '0.098197      7.843131'
         write (igamess,*) '0.015648     34.856463'
         write (igamess,*) 'd   o'
         write (igamess,*) '1.0            0.25'
         write (igamess,*) 'd   o'
         write (igamess,*) '1.0            1.0'
         write (igamess,*) 's   h'
         write (igamess,*) '1.0            0.175612'
         write (igamess,*) 's   h'
         write (igamess,*) '0.478313      0.640179'
         write (igamess,*) '0.137952      2.825994'
         write (igamess,*) '0.019678     18.739256'
         write (igamess,'(a3)') 'END'
         write (igamess,'(a5)') 'ENTER'
         write (igamess,'(a15)') 'RUNTYPE ANALYZE'
         write (igamess,'(a3)') 'DMA'
         write (igamess,'(a9)') 'LIMIT H 1'
         write (igamess,'(a5)') 'ENTER'
         write (igamess,'(a3)') 'EOF'
         write (igamess,'(a5)') 'clean'
         close (unit=igamess)
         
      enddo
      return
      end

