c
c
c     ###################################################
c     ##  Wijnand Mooij     march 1997                 ##
c     ##                                               ##
c     ###################################################
c
c     #################################################################
c     ##                                                             ##
c     ##  subroutine readcssr  --  input of (fractional) coordinates ##
c     ##  from cssr format, extended wtih atomtype on extra column   ##
c     ##                                                             ##
c     #################################################################
c
c
c     "readcssr gets a set of fractional coordinates in cssr format
c     from an external disk file
c
c
      subroutine readcssr (ixyz)
      implicit none
      include 'sizes.i'
      include 'atmtyp.i'
      include 'atoms.i'
      include 'couple.i'
      include 'files.i'
      include 'iounit.i'
      include 'titles.i'
      include 'boxes.i'
      include 'spgr.i'
      include 'math.i'
      include 'keys.i'

      integer i,j,k,m,ixyz
      integer list(maxatm)
      character*60 spffile,confile
      character*60 record,string
      character*4 code
      character*7 flag
      logical opened,quit,reorder,exist,readline

      real*8 cosa,cosb,cosc,bb,cc,bx,by,cx,cy,cz,frac(3*maxatm)
      real*8 sinc,vabc,cccs
      real  charge

      integer nword,icon,freeunit,nop,nop3,idum
      character*1 answer
      character*11 tempspgr

      integer next
      character*20 keyword
      character*80 record2
      logical p1_expand
 


      quit=.true.
      i = 0
      spgr =' '
      
c Read the cell:
      read (ixyz,*,err=50,end=50) xbox,ybox,zbox
      readline=.false.
      read (ixyz,11,err=52)  alpha,beta,gamma,ispgr,spgr
 11   format(21x,3f8.3,9x,i3,1x,a11)
      readline=.true.
 52   if (.not.readline) then
c Try cerius 3.x version
         spgr=' '
         rewind (unit=ixyz)
         read(ixyz,*) 
         read (ixyz,101)  alpha,beta,gamma,ispgr
 101     format(21x,3f8.3,10x,i3,1x,a11)
      endif
c
c     read the number of atoms, coordinate flag, title
c
      read (ixyz,12) n,csf,title
      ltitle=60
 12   format (2i4,1x,a60)
      read (ixyz,14) record
 14   format(a60)
      print *,record
c
c     check for too many total atoms in the file
c
      if (n .gt. maxatm) then
         write (iout,20)  maxatm
   20    format (/,' READXYZ  --  The Maximum of',i6,' Atoms',
     &        ' has been Exceeded')
         call fatal
      end if
      

      do i=1,n
         read (ixyz,13,err=50,end=50) tag(i),name(i),
     +        x(i),y(i),z(i),(i12(j,i),j=1,4),idum,idum,idum,idum,
     +        charge,type(i)
c Write the charge to the keyfile list, for further processing:
         if (charge.ne.0.d0) then
            nkey=nkey+1
            write(keyline(nkey),44) -i,charge
         endif
      enddo
 13   format(i4,1x,a4,2x,f9.5,1x,f9.5,1x,f9.5,1x,8i4,1x,f7.3,1x,i3)
 44         format('CHARGE',x,i6,x,f6.3)      


c
c     for each atom, count and sort its attached atoms
c
         do i = 1, n
            n12(i) = 0
            do j = maxval, 1, -1
               if (i12(j,i) .ne. 0) then
                  n12(i) = j
                  goto 70
               end if
            end do
 70         continue
            call sort (n12(i),i12(1,i))
         end do
      
c Convert fractional coordinates to cartesian
      
      if (csf.eq.0) then
c Check  the keyfile for expansion to P1
c (mechanic is only called after this readcssr, so keyfile has not been read
c yet )
         p1_expand=.false.
         use_inner=.true.
         do i = 1, nkey
            next = 1
            record2 = keyline(i)
            call gettext (record2,keyword,next)
            call upcase (keyword)
            if (keyword(1:10) .eq. 'P1-EXPAND ') p1_expand=.true.
         enddo
         flag='NUMBER '
         call xleesr(flag)
         call upcase (answer)
         if (p1_expand)  then
            do nop=1,nspgr
               nop3 = 3*nop-3
c               print *,(msp(nop3+m),tsp(nop3+m),m=1,3)
               do  i = 1, n
                  j=3*i-3
                  k=i+nop*n
                  x(k)=msp(nop3+1)*x(i) + tsp(nop3+1)
                  y(k)=msp(nop3+2)*y(i) + tsp(nop3+2)
                  z(k)=msp(nop3+3)*z(i) + tsp(nop3+3)
               enddo
            enddo

c        Expand connectivities to P1        
            do i=1,n
               do nop=1,nspgr
                  k=i + nop*n
                  tag(k)=  tag(i) + nop * n
                  call cellatom(k,i)
               enddo
            enddo
c       Set number of atoms to atoms in unit cell and symmetry to P1         
            n=n * (nspgr + 1)
            ispgr=1
            spgr='P1'
C*****Set  P1 ymmetry for dipole moment in Uinner calculation
            k=0
            do m = 1,3
               msom(m)=1
            enddo
            use_inner=.true.
            
c Keep the number of symmetry operations for the moment
c It is needed to expand multipoles to unit cell:

c           Set optimization of all cell-parameters on and disable
c optimization of first coordinate (origin is free to choose in P1)
c 
            do i=1,6
               iref(i)=1
            enddo
            do i=7,9
               iref(i)=0
            enddo
         endif
         
 81      format(i5,3f15.5)
          
         bb=ybox
         cc=zbox
         cosa=cos(alpha/radian)
         cosb=cos(beta/radian)
         cosc=cos(gamma/radian)
         cx=cc*cosb
         bx=bb*cosc
         by=sqrt(bb*bb-bx*bx)
         cy=(bb*cc*cosa-bx*cx)/by
         cz=sqrt(cc*cc-cx*cx-cy*cy)
         box(1)=xbox
         box(2)=by
         box(3)=cz
         box(4)=bx
         box(5)=cx
         box(6)=cy

c Convert coordinates to cartesian
         do i=1,n
            x(i)=x(i)*xbox
            y(i)=y(i)*ybox
            z(i)=z(i)*zbox
         enddo
         
         sinc=sqrt(1-cosc**2)
         vabc=sqrt(1-cosa**2-cosb**2-cosc**2+2*cosa*cosb*cosc)
         cccs=(cosa-cosb*cosc)/sinc
      
         do i = 1, n
            x(i)=x(i)+cosc*y(i)+cosb*z(i)
            y(i)=sinc*y(i)+cccs*z(i)
            z(i)=(vabc/sinc)*z(i)
         enddo

      endif
      
      
      quit =.false.

 50   continue


c
c     an error occurred in reading the CSSR file
c
      if (quit) then
         write (iout,60)  i
   60    format (/,' READXYZ  -- Error in CSSR File at Atom',i6)
         call fatal
      end if
c
c     check for scrambled atom order and attempt to renumber
c
      reorder = .false.
      do i = 1, n  
         list(tag(i)) = i
         if (tag(i) .ne. i)  reorder = .true.
      end do
      if (reorder) then
         write (iout,80)
   80    format (/,' READXYZ  --  Atom Labels not Sequential,',
     &              ' Attempting to Renumber')
         do i = 1, n
            tag(i) = i
            do j = 1, n12(i)
               i12(j,i) = list(i12(j,i))
            end do
            call sort (n12(i),i12(1,i))
         end do
      end if
c
c     make sure that all connectivities are bidirectional
c
      do i = 1, n
         do j = 1, n12(i)
            k = i12(j,i)
            do m = 1, n12(k)
               if (i12(m,k) .eq. i)  goto 100
            end do
            write (iout,90)  k,i
   90       format (/,' READXYZ  --  Check Connection of Atom',
     &           i6,' to Atom',i6)
            call fatal
  100       continue
         end do
      end do
      return
      end









