      function rotation(phi1,theta1,psi1,phi2,theta2,psi2)

cc
c Routine to determine the net rotation between to orientations given by the
c euler angles (phi1,theta1,psi1), and (phi2,theta2,psi2)
cc
      implicit none
      integer i,j,m
      real*8 rotation
      real*8 phi1,theta1,psi1,phi2,theta2,psi2
      real*8 euler1(3,3),euler2(3,3),cphi,sphi,ctheta,
     +     stheta,cpsi,spsi,euler(3,3),offd
      include 'math.i'

C Determine rotation-matrix of first orientation
      cphi=cos(phi1/radian)
      sphi=sin(phi1/radian)
      ctheta=cos(theta1/radian)
      stheta=sin(theta1/radian)
      cpsi=cos(psi1/radian)
      spsi=sin(psi1/radian)
      euler1(1,1)= cpsi*cphi-spsi*sphi*ctheta
      euler1(1,2)= cpsi*sphi+spsi*cphi*ctheta
      euler1(1,3)= spsi*stheta
      euler1(2,1)=-spsi*cphi-cpsi*sphi*ctheta
      euler1(2,2)=-spsi*sphi+cpsi*cphi*ctheta
      euler1(2,3)= cpsi*stheta
      euler1(3,1)= sphi*stheta
      euler1(3,2)=-cphi*stheta
      euler1(3,3)= ctheta
C Determine rotation-matrix of second orientation
      cphi=cos(phi2/radian)
      sphi=sin(phi2/radian)
      ctheta=cos(theta2/radian)
      stheta=sin(theta2/radian)
      cpsi=cos(psi2/radian)
      spsi=sin(psi2/radian)
      euler2(1,1)= cpsi*cphi-spsi*sphi*ctheta
      euler2(1,2)= cpsi*sphi+spsi*cphi*ctheta
      euler2(1,3)= spsi*stheta
      euler2(2,1)=-spsi*cphi-cpsi*sphi*ctheta
      euler2(2,2)=-spsi*sphi+cpsi*cphi*ctheta
      euler2(2,3)= cpsi*stheta
      euler2(3,1)= sphi*stheta
      euler2(3,2)=-cphi*stheta
      euler2(3,3)= ctheta

c Determine rotation of geometry-1 to geometry-2 

c      trace=0.0d0
c      do i=1,3
c         do j=1,3
c            trace=trace+euler1(i,j)*euler2(i,j)
c         enddo
c      enddo
c      rot=radian*acos((trace-1.0)/2.0)
C           This is numerically rather bad because TRACE is very near to 3
      
c     Better:
c   This is the rotation of geometry-1 to geometry-2
      do i=1,3
         do j=1,3
            euler(i,j)=0.0d0
            do m=1,3
               euler(i,j)=euler(i,j)+euler1(i,m)*euler2(j,m)
            enddo
         enddo
      enddo
      offd=(euler(2,1)-euler(1,2))**2 + (euler(3,1)-euler(1,3))**2
     +     + (euler(2,3)-euler(3,2))**2
      rotation=radian*asin(sqrt(offd)/2.0)
c      rotation=rot2

      return

      end

    


