c
c
c     ###################################################
c     ##  COPYRIGHT (C)  1992  by  Jay William Ponder  ##
c     ##              All Rights Reserved              ##
c     ###################################################
c
c     ################################################################
c     ##                                                            ##
c     ##  vdwpot.i  --  specifics of van der Waals functional form  ##
c     ##                                                            ##
c     ################################################################
c
c
c     aterm     value of the "A" constant in exponential potential
c     bterm     value of the "B" constant in exponential potential
c     cterm     value of the "C" constant in exponential potential
c     vdwscale  factor by which 1-4 vdw interactions are scaled
c     igauss    coefficients of 2- or 4-Gaussian fit to L-J
c     ngauss    number of Gaussians used in fit to L-J potential
c     vdw12use  usage of 1-2 vdw terms (0=use, 1=omit, -1=scale)
c     vdw13use  usage of 1-3 vdw terms (0=use, 1=omit, -1=scale)
c     vdw14use  usage of 1-4 vdw terms (0=use, 1=omit, -1=scale)
c     vdwtyp    type of van der Waals potential energy function
c     radtyp    type of parameter (sigma or r-min) for atomic size
c     radsiz    atomic size provided as radius or diameter
c     radrule   combining rule for atomic size parameters
c     epsrule   combining rule for vdw well depth parameters
c
c
      real*8 aterm,bterm,cterm,vdwscale,igauss
      integer ngauss,vdw12use,vdw13use,vdw14use
      character*5 radtyp
      character*8 radsiz
      character*13 vdwtyp
      character*10 radrule,epsrule
      common /vdwpotintra/ aterm,bterm,cterm,vdwscale,igauss(2,4),
     +   ngauss,vdw12use,vdw13use,vdw14use,vdwtyp,radtyp,radsiz,
     &                radrule,epsrule
