c
c
c     ###################################################
c     ##  Wijnand Mooij  may 1997
c     ##             
c     ###################################################
c
c     ################################################################
c     ##                                                                    ##
c     ##  subroutine vdwtail  - Vandwerwaals tail correction for dispersion ##
c     ##                                                                    ##
c     ################################################################
c
c
      function vdwtail()
      implicit none
      include 'sizes.i'
      include 'atmtyp.i'
      include 'atoms.i'
      include 'vdw.i'
      include 'vdw2.i'
      include 'vdwpot.i'
      include 'cutoff.i'
      include 'potent.i'
      include 'potentxtra.i'
      include 'spgr.i'
      include 'math.i'

c      include 'kvdws.i'

      integer i,j
      integer it,kt
      real*8 rv,eps
      real*8 sigma,kappa,kappa7,rho,tau
      real*8 rcut2,rv7
      
      real*8 v,vdwtail,c,nspgr2,rcut,rcut3

      v = 4.0d0 * pi / (3.0*box(1)*box(2)*box(3))
      nspgr2=(nspgr+1)
      rcut = max(chgcut,vdwcut)
      rcut3 = rcut**3
      vdwtail=0.0d0

      if (vdwtyp.eq.'WILLIAMS') then
         do i=1,n
            do j=i,n
               kt=class(j)
               it=class(i)
               C=Cuse(kt,it)
               if (i.eq.j) c=c/2.0d0
               vdwtail=vdwtail-v*C*nspgr2/rcut3
            enddo
         enddo
      else  if (vdwtyp .eq. 'LENNARD-JONES') then
         do i=1,n
            do j=i,n
               kt=class(j)
               it=class(i)
               rv = radmin(kt,it)
               eps = epsilon(kt,it)
               C=eps*2.0*rv**6
               if (i.eq.j) c=c/2.0d0
               vdwtail=vdwtail-nspgr2*v*C/rcut3
            enddo
         enddo
      else  if (vdwtyp .eq. 'BUFFERED-14-7') then
         print *,'No tail correction for Buf14-7'
      else  if (vdwtyp .eq. 'BUCKINGHAM') then
         do i=1,n
            do j=i,n
               kt=class(j)
               it=class(i)
               rv = radmin(kt,it)
               eps = epsilon(kt,it)
               C=eps*cterm*rv**6
               if (i.eq.j) c=c/2.0d0
               vdwtail=vdwtail-nspgr2*v*C/rcut3
            enddo
         enddo
      endif
      return
      end


