c
c
c     ###################################################
c     ##  COPYRIGHT (C)  1990  by  Jay William Ponder  ##
c     ##              All Rights Reserved              ##
c     ###################################################
c
c     ##############################################################
c     ##                                                          ##
c     ##  subroutine writeout2  --  update the output coordinates  ##
c     ##                                                          ##
c     ##############################################################
c
c
c     "writeout2" is used by xxtalmin to save the current atomic 
C     coordinates to a disk file.
c     Wijnand Mooij, may 1997
c
      subroutine writeout2 (xx,ncycle,enb)
      implicit none
      include 'sizes.i'
      include 'atoms.i'
      include 'files.i'
      include 'math.i'
      include 'output.i'
      include 'scales.i'
      include 'usage.i'
      include 'spgr.i'
      integer i,iwrt,freeunit
      integer nvar,ncycle,lext
      real*8 xx(*),enb
      character*3 status
      character*7 ext
      character*60 coordfile,string
c
c
c     transform optimization parameters back to coordinates
c
      nvar = 0
      do i = 1, 6
         if (iref(i).gt.0) then
            nvar = nvar + 1
            box(i) = xx(nvar)
         endif
      enddo
      if (iref(7).gt.0) then
         nvar = nvar + 1 
         x(1) = xx(nvar)
      endif
      if (iref(8).gt.0) then
         nvar = nvar + 1
         y(1) = xx(nvar)
      endif
      if (iref(9).gt.0) then
         nvar = nvar + 1
         z(1) = xx(nvar)
      endif

      do i = 2, n
         nvar = nvar + 1
         x(i) = xx(nvar)
         nvar = nvar + 1
         y(i) = xx(nvar)
         nvar = nvar + 1
         z(i) = xx(nvar)
      end do

c
c     get the name to be used for the coordinates file
c
      if (savecycle) then
         lext = 3
         call numeral (ncycle,ext,lext)
         coordfile = filename(1:leng)//'.'//ext(1:lext)
         status = 'new'
      else
         coordfile = outfile
         status = 'old'
      end if
c
c     open and then update the coordinates file
c
      iwrt = freeunit ()
      call version (coordfile,status)
      open (unit=iwrt,file=coordfile,status=status)
      if (status .eq. 'old')  rewind (unit=iwrt)
      write(string,11) ncycle,enb
 11   format('XXTALMIN, niter:',i4,' Energy:',f7.3)
      if (coordtype.eq.'frac-cssr') call prtcssr(iwrt,string)
      if (coordtype.eq.'frac-spf ') call prtspf(iwrt,string)
      close (unit=iwrt)
      return
      end



