      subroutine tri(nr,npa,x,it,cosa,cosb,cosc)
 
c B.P. van Eijck, 1998
C     Transformeert Cartesische naar trikliene coordinaten. Is een
C     adaptatie van TRACO (W.F. VAN GUNSTEREN, GRONINGEN, DEC. 1985).

C     NR    aantal te transformeren atomen
C     NPA   aantal daarvoor te skippen atomen
C     X     bevat de coordinaten
C     IT    regelt richting van de transformatie:
C        IT > 0: Cartesisch naar triklien
C        IT < 0: triklien naar Cartesisch
C     COSA, COSB, COSC geven de cosinus van de celhoeken alpha, beta, gamma.

C     De a-as valt samen met de X-as, de b-as ligt in het X-Y vlak.

      real x(*)
      i3=3*npa+1
      sinc=sqrt(1-cosc**2)
      vabc=sqrt(1-cosa**2-cosb**2-cosc**2+2*cosa*cosb*cosc)
      cccs=(cosa-cosb*cosc)/sinc

C     Cartesisch naar triklien
      if (it.gt.0) then
        do 40 j=1,nr
          x(i3)=x(i3)-(cosc/sinc)*x(i3+1)+
     1       (cosc*cccs-sinc*cosb)*x(i3+2)/vabc
          x(i3+1)=x(i3+1)/sinc-(cccs/vabc)*x(i3+2)
          x(i3+2)=(sinc/vabc)*x(i3+2)
          i3=i3+3 
   40   continue
      endif

C     Triklien naar Cartesisch
      if (it.lt.0) then
        do 50 j=1,nr
          x(i3)=x(i3)+cosc*x(i3+1)+cosb*x(i3+2)
          x(i3+1)=sinc*x(i3+1)+cccs*x(i3+2)
          x(i3+2)=(vabc/sinc)*x(i3+2)
          i3=i3+3 
   50   continue
      endif
      end 
