c
c     original Kirkwood formula
c

      subroutine ekirkwood

      implicit none
      include 'sizes.i'
      include 'atoms.i'
      include 'energi.i'
      include 'charge.i'

      real*8 xi,yi,zi,xk,yk,zk
      real*8 risq, ri, rksq, rk,r(maxatm)
      real*8 rin,rkn,rn(maxatm)
      real*8 ccosik(maxatm,maxatm)
      real*8 plm,legendre
      real*8 qi,qk
      real*8 qn,en
      integer i,k,ii,kk
      integer iii
     

      do ii=1,nion-1
         i = iion(ii)
         xi = x(i)
         yi = y(i)
         zi = z(i)
         risq = xi*xi + yi*yi + zi*zi
         ri = dsqrt(risq)         
         r(i) = ri

         do kk = ii+1, nion
            k = iion(kk)
            xk = x(k)
            yk = y(k)
            zk = z(k)
            rksq = xk*xk + yk*yk + zk*zk
            rk = dsqrt(rksq)         
         
            ccosik(i,k) = (xi*xk + yi*yk + zi*zk)/(ri*rk)
            ccosik(k,i) = ccosik(i,k)
         end do
      end do
      r(n) = rk

      do i=1,nion
         rn(i) = 1.0d0
      end do

      do iii=0, upper_n
         qn = 0.0d0
         do ii=1,nion-1
            i = iion(ii)
            qi = pchg(ii)
            rin = rn(i)
            do kk=1,n
               k = iion(kk)
               qk = pchg(kk)
               rkn = rn(k)
               plm = legendre(iii,0,ccosik(i,k))
               qn = qn + qi*qk*rin*rkn*plm
            end do
         end do
         en = qn*h(iii)
         er = er + en
         write(*,11) iii, en, er
   11    format(i5,2f65.55)
         do i=1,nion
            rn(i) = rn(i)*r(i)
         end do        
      end do

      write(*,10) er
   10 format(f80.60)

      return
      end
