c
c
c     ###############################################################
c     ##  COPYRIGHT (C) 1996 by Yong Kong & Jay William Ponder     ##
c     ##                  All Rights Reserved                      ##
c     ##                                                           ##
c     ##  subroutine elinear  --  Mike's fast linear method        ##
c     ##                                                           ##
c     ###############################################################
c
c
      subroutine elinear

      implicit none
      include 'sizes.i'
      include 'atoms.i'
      include 'energi.i'
      include 'charge.i'


      integer UPN,SIZEMY
      parameter (UPN = 30)
      parameter (SIZEMY = (UPN+1)*(UPN+2)/2 )
      real*8 qn,mn(SIZEMY),yn(SIZEMY),deg(SIZEMY)
      real*8 xi,yi,zi
      real*8 en
      real*8 xip,yip,z_power(0:UPN)
      integer trace_num,count_t1,count_t2,count_t3
      integer iii,ii
      integer i,j,k

      do iii=0, upper_n

         call tr_trless_index(iii,deg)
         trace_num = (iii+1)*(iii+2)/2

         do i=1,trace_num
            mn(i) = 0.0d0
         end do
         do ii=1,nion
            i = iion(ii)
            xi = x(i)
            yi = y(i)
            zi = z(i)
            z_power(0) = 1.0d0
            do j=1,iii
               z_power(j) = z_power(j-1)*zi
            end do

            count_t1 = 1
            xip = pchg(ii)
            do j=0,iii
               yip = 1.0d0
               do k=0,iii-j
                  mn(count_t1) = mn(count_t1) 
     &                           + xip*yip*z_power(iii-j-k)
                  yip = yip*yi
                  count_t1 = count_t1 + 1
               end do
               xip = xip*xi
            end do
         end do

         if(iii .eq. 0) then
            yn(1) = mn(1)
         else if(iii .eq. 1) then
            call mtoy_1(3, mn, yn)
         else if(iii .eq. 2) then
            call mtoy_2(5, mn, yn)
         else if(iii .eq. 3) then
            call mtoy_3(7, mn, yn)
         else if(iii .eq. 4) then
            call mtoy_4(9, mn, yn)
         else if(iii .eq. 5) then
            call mtoy_5(11, mn, yn)
         else if(iii .eq. 6) then
            call mtoy_6(13, mn, yn)
         else if(iii .eq. 7) then
            call mtoy_7(15, mn, yn)
         else if(iii .eq. 8) then
            call mtoy_8(17, mn, yn)
         else if(iii .eq. 9) then
            call mtoy_9(19, mn, yn)
         else if(iii .eq. 10) then
            call mtoy_10(21, mn, yn)
         else if(iii .eq. 11) then
            call mtoy_11(23, mn, yn)
         else if(iii. eq. 12) then
            call mtoy_12(25, mn, yn)
         else if(iii .eq. 13) then
            call mtoy_13(27, mn, yn)
         else if(iii .eq. 14) then
            call mtoy_14(29, mn, yn)
         else if(iii .eq. 15) then
            call mtoy_15(31, mn, yn)
         else if(iii .eq. 16) then
            call mtoy_16(33, mn, yn)
         else if(iii .eq. 17) then
            call mtoy_17(35, mn, yn)
         else if(iii .eq. 18) then
            call mtoy_18(37, mn, yn)
         else if(iii .eq. 19) then
            call mtoy_19(39, mn, yn)
         else if(iii .eq. 20) then
            call mtoy_20(41, mn, yn)
         else if(iii .eq. 21) then
            call mtoy_21(43, mn, yn)
         else if(iii .eq. 22) then
            call mtoy_22(45, mn, yn)
         else if(iii .eq. 23) then
            call mtoy_23(47, mn, yn)
         else if(iii .eq. 24) then
            call mtoy_24(49, mn, yn)
         else if(iii .eq. 25) then
            call mtoy_25(51, mn, yn)
         else if(iii .eq. 26) then
            call mtoy_26(53, mn, yn)
         else if(iii .eq. 27) then
            call mtoy_27(55, mn, yn)
         else if(iii .eq. 28) then
            call mtoy_28(57, mn, yn)
         else if(iii .eq. 29) then
            call mtoy_29(59, mn, yn)
         else if(iii .eq. 30) then
            call mtoy_30(61, mn, yn)
         end if
         count_t1 = 2*iii+2
         count_t2 = iii - 1
         count_t3 = 1
 17      if(count_t1 .le. trace_num) then
            do i=1,count_t2
               yn(count_t1) = -yn(count_t3)-yn(count_t3+2)
               count_t1 = count_t1 + 1
               count_t3 = count_t3 + 1
            end do
            count_t3 = count_t3 + 2
            count_t2 = count_t2 - 1
            go to 17
         end if

         en = 0.0d0
         do i=1,trace_num
            en = en + yn(i)*mn(i)*deg(i)
         end do
         en = en * h(iii)
         er = er + en
c         write(*,11) iii, en, er
c   11    format(i5,2f65.55)

      end do

      return
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     index for the trace and traceless multipoles
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine tr_trless_index(upper_n,dege)

      implicit none

      real*8 frac(0:100),dege(1000)
      integer upper_n
      integer i,j,k,trace_c
      
      frac(0) = 1.0d0
      do i=1,upper_n
         frac(i) = i*frac(i-1)
      end do

      trace_c = 1
      do i=0,upper_n
         do j=0,upper_n-i
            k = upper_n-i-j
            dege(trace_c) = frac(upper_n)/(frac(i)*frac(j)*frac(k))
            trace_c = trace_c + 1
         end do
      end do

      return
      end
