c
c
c     ############################################################
c     ##  COPYRIGHT (C) 1996 by Yong Kong & Jay William Ponder  ##
c     ##                  All Rights Reserved                   ##
c     ############################################################
c
c     ###############################################################
c     ##                                                           ##
c     ##  subroutine elinear  --  Mike's fast linear method  ##
c     ##                                                           ##
c     ###############################################################
c
c
      subroutine elinear1

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     fast algorithm                                      c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      energy = 0.0d0
      do i=1,n
         dx(i) = 0.0d0
         dy(i) = 0.0d0
         dz(i) = 0.0d0
      end do
      do ii=0, upper_n
         call tr_trless_index(ii,deg)
         trace_num = (ii+1)*(ii+2)/2
ccccccccccccccccccccccccccccccccccccccccccccccc
c     trace multipoles (Notice the order: first
c        looping over a given site)
ccccccccccccccccccccccccccccccccccccccccccccccc
         do j=1,trace_num
            mn(j) = 0.0d0
         end do
         do i=1,n
            xi = x(i)
            yi = y(i)
            zi = z(i)
            z_power(0) = 1.0d0
            do j=1,ii
               z_power(j) = z_power(j-1)*zi
            end do

            count_t1 = 1
            xip = q(i)
            do j=0,ii
               yip = 1.0d0
               do k=0,ii-j
                  mn(count_t1) = mn(count_t1) 
     &                           + xip*yip*z_power(ii-j-k)
                  yip = yip*yi
                  count_t1 = count_t1 + 1
               end do
               xip = xip*xi
            end do
         end do

         if(ii .eq. 0) then
            yn(1) = mn(1)
         else if(ii .eq. 1) then
            call mtoy_1(3, mn, yn)
         else if(ii .eq. 2) then
            call mtoy_2(5, mn, yn)
         else if(ii .eq. 3) then
            call mtoy_3(7, mn, yn)
         else if(ii .eq. 4) then
            call mtoy_4(9, mn, yn)
         else if(ii .eq. 5) then
            call mtoy_5(11, mn, yn)
         else if(ii .eq. 6) then
            call mtoy_6(13, mn, yn)
         else if(ii .eq. 7) then
            call mtoy_7(15, mn, yn)
         else if(ii .eq. 8) then
            call mtoy_8(17, mn, yn)
         else if(ii .eq. 9) then
            call mtoy_9(19, mn, yn)
         else if(ii .eq. 10) then
            call mtoy_10(21, mn, yn)
         else if(ii .eq. 11) then
            call mtoy_11(23, mn, yn)
         else if(ii. eq. 12) then
            call mtoy_12(25, mn, yn)
         else if(ii .eq. 13) then
            call mtoy_13(27, mn, yn)
         else if(ii .eq. 14) then
            call mtoy_14(29, mn, yn)
         else if(ii .eq. 15) then
            call mtoy_15(31, mn, yn)
         else if(ii .eq. 16) then
            call mtoy_16(33, mn, yn)
         else if(ii .eq. 17) then
            call mtoy_17(35, mn, yn)
         else if(ii .eq. 18) then
            call mtoy_18(37, mn, yn)
         else if(ii .eq. 19) then
            call mtoy_19(39, mn, yn)
         else if(ii .eq. 20) then
            call mtoy_20(41, mn, yn)
         else if(ii .eq. 21) then
            call mtoy_21(43, mn, yn)
         else if(ii .eq. 22) then
            call mtoy_22(45, mn, yn)
         else if(ii .eq. 23) then
            call mtoy_23(47, mn, yn)
         else if(ii .eq. 24) then
            call mtoy_24(49, mn, yn)
         else if(ii .eq. 25) then
            call mtoy_25(51, mn, yn)
         else if(ii .eq. 26) then
            call mtoy_26(53, mn, yn)
         else if(ii .eq. 27) then
            call mtoy_27(55, mn, yn)
         else if(ii .eq. 28) then
            call mtoy_28(57, mn, yn)
         else if(ii .eq. 29) then
            call mtoy_29(59, mn, yn)
         else if(ii .eq. 30) then
            call mtoy_30(61, mn, yn)
         end if
         count_t1 = 2*ii+2
         count_t2 = ii - 1
         count_t3 = 1
 17      if(count_t1 .le. trace_num) then
            do i=1,count_t2
               yn(count_t1) = -yn(count_t3)-yn(count_t3+2)
               count_t1 = count_t1 + 1
               count_t3 = count_t3 + 1
            end do
            count_t3 = count_t3 + 2
            count_t2 = count_t2 - 1
            go to 17
         end if

         en = 0.0d0
         do i=1,trace_num
            en = en + yn(i)*mn(i)*deg(i)
         end do
         en = en * h(ii)
         energy = energy + en
         write(*,11) ii, en, energy

         if(ddd_a .ne. 0) then
         do i=1,n
            xi = x(i)
            yi = y(i)
            zi = z(i)
            do j=1,trace_num
               dxmn(j) = 0.0d0
               dymn(j) = 0.0d0
               dzmn(j) = 0.0d0         
            end do

            z_power(0) = 1.0d0
            do j=1,ii
               z_power(j) = z_power(j-1)*zi
            end do

            count_t1 = 1
            xip = q(i)
            do j=0,ii
               yip = 1.0d0
               do k=0,ii-j
                  dxmn(count_t1) = j*dxip*yip*z_power(ii-j-k)
                  dymn(count_t1) = k*xip*dyip*z_power(ii-j-k)
                  dzmn(count_t1) = (ii-j-k)*xip*yip
     &                                   *z_power(ii-j-k-1)
                  dyip = yip
                  yip = yip*yi
c                  write(*,789) i,ii,count_t1,dxmn(count_t1),
c     &                        dymn(count_t1),dzmn(count_t1)
c 789              format(3i5,3f25.20)
                  count_t1 = count_t1 + 1
               end do
               dxip = xip
               xip = xip*xi
            end do
            if(ii .eq. 0) then
               dxyn(1) = dxmn(1)
               dyyn(1) = dymn(1)
               dzyn(1) = dzmn(1)
            else if(ii .eq. 1) then
               call mtoy_1(3, dxmn, dxyn)
               call mtoy_1(3, dymn, dyyn)
               call mtoy_1(3, dzmn, dzyn)
            else if(ii .eq. 2) then
               call mtoy_2(5, dxmn, dxyn)
               call mtoy_2(5, dymn, dyyn)
               call mtoy_2(5, dzmn, dzyn)
            else if(ii .eq. 3) then
               call mtoy_3(7, dxmn, dxyn)
               call mtoy_3(7, dymn, dyyn)
               call mtoy_3(7, dzmn, dzyn)
            else if(ii .eq. 4) then
               call mtoy_4(9, dxmn, dxyn)
               call mtoy_4(9, dymn, dyyn)
               call mtoy_4(9, dzmn, dzyn)
            else if(ii .eq. 5) then
               call mtoy_5(11, dxmn, dxyn)
               call mtoy_5(11, dymn, dyyn)
               call mtoy_5(11, dzmn, dzyn)
            else if(ii .eq. 6) then
               call mtoy_6(13, dxmn, dxyn)
               call mtoy_6(13, dymn, dyyn)
               call mtoy_6(13, dzmn, dzyn)
            else if(ii .eq. 7) then
               call mtoy_7(15, dxmn, dxyn)
               call mtoy_7(15, dymn, dyyn)
               call mtoy_7(15, dzmn, dzyn)
            else if(ii .eq. 8) then
               call mtoy_8(17, dxmn, dxyn)
               call mtoy_8(17, dymn, dyyn)
               call mtoy_8(17, dzmn, dzyn)
            else if(ii .eq. 9) then
               call mtoy_9(19, dxmn, dxyn)
               call mtoy_9(19, dymn, dyyn)
               call mtoy_9(19, dzmn, dzyn)
            else if(ii .eq. 10) then
               call mtoy_10(21, dxmn, dxyn)
               call mtoy_10(21, dymn, dyyn)
               call mtoy_10(21, dzmn, dzyn)
            else if(ii .eq. 11) then
               call mtoy_11(23, dxmn, dxyn)
               call mtoy_11(23, dymn, dyyn)
               call mtoy_11(23, dzmn, dzyn)
            else if(ii. eq. 12) then
               call mtoy_12(25, dxmn, dxyn)
               call mtoy_12(25, dymn, dyyn)
               call mtoy_12(25, dzmn, dzyn)
            else if(ii .eq. 13) then
               call mtoy_13(27, dxmn, dxyn)
               call mtoy_13(27, dymn, dyyn)
               call mtoy_13(27, dzmn, dzyn) 
            else if(ii .eq. 14) then
               call mtoy_14(29, dxmn, dxyn)
               call mtoy_14(29, dymn, dyyn)
               call mtoy_14(29, dzmn, dzyn) 
            else if(ii .eq. 15) then
               call mtoy_15(31, dxmn, dxyn)
               call mtoy_15(31, dymn, dyyn)
               call mtoy_15(31, dzmn, dzyn) 
            else if(ii .eq. 16) then
               call mtoy_16(33, dxmn, dxyn)
               call mtoy_16(33, dymn, dyyn)
               call mtoy_16(33, dzmn, dzyn) 
            else if(ii .eq. 17) then
               call mtoy_17(35, dxmn, dxyn)
               call mtoy_17(35, dymn, dyyn)
               call mtoy_17(35, dzmn, dzyn) 
            else if(ii .eq. 18) then
               call mtoy_18(37, dxmn, dxyn)
               call mtoy_18(37, dymn, dyyn)
               call mtoy_18(37, dzmn, dzyn) 
            else if(ii .eq. 19) then
               call mtoy_19(39, dxmn, dxyn)
               call mtoy_19(39, dymn, dyyn)
               call mtoy_19(39, dzmn, dzyn) 
            else if(ii .eq. 20) then
               call mtoy_20(41, dxmn, dxyn)
               call mtoy_20(41, dymn, dyyn)
               call mtoy_20(41, dzmn, dzyn) 
            end if
            count_t1 = 2*ii+2
            count_t2 = ii - 1
            count_t3 = 1
 18         if(count_t1 .le. trace_num) then
               do j=1,count_t2
                  dxyn(count_t1) = -dxyn(count_t3)-dxyn(count_t3+2)
                  dyyn(count_t1) = -dyyn(count_t3)-dyyn(count_t3+2)
                  dzyn(count_t1) = -dzyn(count_t3)-dzyn(count_t3+2)
                  count_t1 = count_t1 + 1
                  count_t3 = count_t3 + 1
               end do
               count_t3 = count_t3 + 2
               count_t2 = count_t2 - 1
               go to 18
            end if

            dxen = 0.0d0
            dyen = 0.0d0
            dzen = 0.0d0
            do di=1,trace_num
               degi = deg(di)
               mni = mn(di)
               yni = yn(di)
               en = en + yni*mni*degi
               dxen = dxen + (dxyn(di)*mni+yni*dxmn(di))*degi
               dyen = dyen + (dyyn(di)*mni+yni*dymn(di))*degi
               dzen = dzen + (dzyn(di)*mni+yni*dzmn(di))*degi
            end do
            dxen = dxen * h(ii)
            dyen = dyen * h(ii)
            dzen = dzen * h(ii)
            dx(i) = dx(i) + dxen
            dy(i) = dy(i) + dyen
            dz(i) = dz(i) + dzen
 15         format(2i5,2f50.40)
         end do
         end if
      end do


      end do
      delta_t = secnds(t1)

c      write(*,10) energy,delta_t
      write(*,1000) energy,delta_t
 1000 format(2f65.50)
      if(ddd_a .ne. 0) then
      write(*,*)
      dx_count = 0.0d0
      dy_count = 0.0d0
      dz_count = 0.0d0
      do i=1,n
         dx_count = dx_count + dx(i)
         dy_count = dy_count + dy(i)
         dz_count = dz_count + dz(i)
         write(*,22) i,dx(i),dy(i),dz(i)
 22      format(i5,3f40.30)
      end do
      write(*,*)
      write(*,*) dx_count,dy_count,dz_count
      end if

      return
      end
