c
c
c     ############################################################
c     ##  COPYRIGHT (C) 1996 by Yong Kong & Jay William Ponder  ##
c     ##                  All Rights Reserved                   ##
c     ############################################################
c
c     ###############################################################
c     ##                                                           ##
c     ##  subroutine erxnfld  --  reaction field potential energy  ##
c     ##                                                           ##
c     ###############################################################
c
c
c     "erxnfld" calculates the macroscopic reaction field energy
c
c
      subroutine erxnfld
      implicit none
      include 'sizes.i'
      integer UPN,SIZEMY
      parameter (SIZE = 10000)
      parameter (UPN = 30)
      real*8 h(0:UPN)
c
c
c     zero out the macroscopic reaction field energy
c
      er = 0.0d0
c
c
c
      a_r = 1.0d0/a
      a_r_sq = a_r*a_r
      a_r_factor = a_r
      do i = 0, upper_n
         h(i) = 0.5d0*(i+1.0d0)*(1.0d0-epi)/((i+1.0d0)*epi+i)*a_r_factor
         a_r_factor = a_r_factor * a_r_sq
      end do
c
c
c
      if ( ) then
         call eimgchg
      else if ( ) then
         call elinear
      else if ( ) then

      end if

      return
      end
