c
c
c     ######################
c     ##                  ##
c     ##  program gather  ##
c     ##                  ##
c     ######################
c
c
c     gather data from a previously performed sdp
c     that resides in the form of sequence files
c     and perform structural analysis
c
c     need to put updates into this : new x axis labeling and
c     zeroing of TS energy, which is done in 'SDPATH'
c
c
      program gather
      implicit none
      include 'sizes.i'
c     TINKER VARIABLES
      include 'align.i'
      include 'atoms.i'
      include 'atmtyp.i'
      include 'iounit.i'
      include 'output.i'
      include 'files.i'
c     PATH CALCULATION VARIABLES
      include 'pathsz.i'
      include 'pathdata.i'
      include 'pathatm.i'
      include 'pathtol.i'
      include 'sdpcycl.i'
      include 'sdpfiles.i'
      integer icon,idih
      integer j1,j2,j3
      integer ihyb,it0,it1
      integer i,j,start,stop,next,end
      integer thousand,hundred,tens,ones
      integer freeunit,trimtext,len
c
      real*8 e,energy,dih,dihed
      real*8 fctval,sdp1,dume
      real*8 p(3*maxatm),tsvec(3*maxatm)
      real*8 deriv(3*maxatm)
      character*1 letter,answer,digit(0:9)
      character*5 seq
      character*8 mode,blank
      character*60 coordfile,rmsfile,nrgfile,radfile
      character*80 record,string
      logical done,exist,dogeom
      external freeunit,trimtext,dihed,energy
      data blank  / '        ' /
      data digit  / '0','1','2','3','4','5','6','7','8','9' /
c
c     initialize some TINKER stuff
c
      call initial
c
c     open output files
c
      irms = freeunit ()
      rmsfile = filename(1:leng)//'.rmsdat'
      call version (rmsfile,'new')
      open (unit=irms,file=rmsfile,status='new')
c
      irad = freeunit ()
      radfile = filename(1:leng)//'.rdat'
      call version (radfile,'new')
      open (unit=irad,file=radfile,status='new')
c
      inrg = freeunit ()
      nrgfile = filename(1:leng)//'.edat'
      call version (nrgfile,'new')
      open (unit=inrg,file=nrgfile,status='new')
c
c     get the name of the coordinates files
c
      write (iout,10)
   10 format (' Enter Name of the Coordinate Files :  ',$)
      read (input,20)  filename
   20 format (a60)
      leng = trimtext (filename)
c
c     remove any extension from the filename
c
      end = leng
      do i = 1, leng
         letter = filename(i:i)
         if (letter .eq. '/')  end = leng
         if (letter .eq. ']')  end = leng
         if (letter .eq. ':')  end = leng
         if (letter .eq. '.')  end = i - 1
      end do
      leng = min(leng,end)
      write (iout,30)
   30 format (' Enter Number of First File :  ',$)
      read (input,40)  start
   40 format (i10)
      write (iout,50)
   50 format (' Enter Number of Last File :   ',$)
      read (input,60)  stop
   60 format (i10)
c
c     cycle over the user specified coordinate files
c
      i = start
      dowhile (i.ge.start .and. i.le.stop)
         thousand = i / 1000
         hundred = (i - 1000*thousand) / 100
         tens = (i - 1000*thousand - 100*hundred) / 10
         ones = i - 1000*thousand - 100*hundred - 10*tens
         seq(1:1) = '.'
         seq(2:2) = digit(thousand)
         seq(3:3) = digit(hundred)
         seq(4:4) = digit(tens)
         seq(5:5) = digit(ones)
         icon = freeunit ()
         coordfile = filename(1:leng)//seq(1:5)
         call version (coordfile,'old')
         open (unit=icon,file=coordfile,status='old',err=280)
c
c     read coordinates file
c
         call readcon (icon)
c
c     setup the molecular mechanics energy stuff
c
      if (i .eq. start) call mechanic
c
         e = energy ()
         write(inrg,*) i,e
         write(6,*) i,e
         call hbond(i)
  280    continue
         i = i+1
      end do
      end
c
c
c     #######################################################
c     ##                                                   ##
c     ##  subroutine hbond  --  get hbond info per residue ##
c     ##                                                   ##
c     #######################################################
c
c
c     "hbond" analyzes the hbond type
c      for each peptide residue
c
c      note:    "1" designates 3[10] type Hbond
c               "-1"  an alpha helix type Hbond
c               "0"   designates lack of either type Hbond
c               "2"   indicates a bifurcated Hbond of 3[10]/alpha type
c
      subroutine hbond (index)
      implicit none
      include 'sizes.i'
      include 'atoms.i'
      integer maxvar,mbig,index
      parameter(mbig = 100)
      integer hb_typ(mbig),hb_310(mbig),hb_alf(mbig)
      integer res_index,i,jc,jo,jh,jn
      real*8 x2,y2,z2,roh,xnh,ynh,znh,rnh
      real*8 xoh,yoh,zoh
      real*8 xoc,yoc,zoc,roc
      real*8 angh,angc
      real*8 dihed,phi,psi,opa
      external dihed
      open  (unit = 66, file = 'hbout', status=' unknown')
      do i = 1, mbig
         hb_typ(i) = 0
         hb_310(i) = 0
         hb_alf(i) = 0
      end do
      jc = 2
      do jo = 32, 50, 2
        i = 0
        do jh = 33, 51, 2
         i = i+1
         res_index = i
         jn = 3*i
         xoh = x(jo) - x(jh)
         yoh = y(jo) - y(jh)
         zoh = z(jo) - z(jh)
         x2 = xoh*xoh
         y2 = yoh*yoh
         z2 = zoh*zoh
         roh = sqrt(x2+y2+z2)
c
         xnh = x(jn) - x(jh)
         ynh = y(jn) - y(jh)
         znh = z(jn) - z(jh)
         rnh = sqrt(xnh*xnh+ynh*ynh+znh*znh)
         angh = xnh*xoh + ynh*yoh + znh*zoh
         angh = angh/roh/rnh
         angh = acos(angh)*57.3248
c
         xoc = x(jo) - x(jc)
         yoc = y(jo) - y(jc)
         zoc = z(jo) - z(jc)
         roc = sqrt(xoc*xoc+yoc*yoc+zoc*zoc)
         angc = xoh*xoc + yoh*yoc + zoh*zoc
         angc = angc/roh/roc
         angc = acos(angc)*57.3248
         phi = dihed(jn-1,jn,jn+1,jn+2)
         psi = dihed(jn,jn+1,jn+2,jo)
c
c     look at the angle N-DD-DD'-O, where [N-DD-DD] refer to the Donor
c     residue, and [O] to the Acceptor residue ( ala G. Rose in Protein
c     Folding Gierasch/King  AAAS  p 29-43)
c
         opa = dihed(jn,jn+1,jn-1,jo)
c    distance criteria designed to match G. Rose criteria on r(N-O) dist.
         if ( (roh .lt. 2.4) .and. (abs(opa) .lt. 25.0d0) ) then
           if  ( (jh-jo) .eq. 5 ) then
c
c     3[10] hbond type
c
               hb_310(res_index) = 1
           else if ( (jh-jo) .eq. 7 ) then
c
c     alpha hbond type
c
               hb_alf(res_index) = -1
           end if
         end if
        end do
        jc = jc + 3
      end do
      do i = 2,9
         if ( (hb_310(i) .ne. 0) .and. (hb_alf(i) .ne. 0) ) then
            hb_typ(i) = 2
         else if (hb_310(i) .ne. 0) then
            hb_typ(i) = hb_310(i)
         else if (hb_alf(i) .ne. 0) then
            hb_typ(i) = hb_alf(i)
         end if
      end do
      write(66,10) index,(hb_typ(i),i = 2,9 )
  10  format (i5,tr5,8(i3,tr2))
      return
      end
c
c
c     #############################################################
c     ##                                                         ##
c     ##  function dihed  --  dihedral angle between four atoms  ##
c     ##                                                         ##
c     #############################################################
c
c
      function dihed (ia,ib,ic,id)
      implicit none
      include 'sizes.i'
      include 'atoms.i'
      include 'math.i'
      integer ia,ib,ic,id
      real*8 xia,yia,zia,xib,yib,zib
      real*8 xic,yic,zic,xid,yid,zid
      real*8 xba,yba,zba,xcb,ycb,zcb
      real*8 xdc,ydc,zdc
      real*8 a1,b1,c1,a2,b2,c2
      real*8 dihed,cosine,sign
c
c
c     compute the value of the dihedral angle
c
      xia = x(ia)
      yia = y(ia)
      zia = z(ia)
      xib = x(ib)
      yib = y(ib)
      zib = z(ib)
      xic = x(ic)
      yic = y(ic)
      zic = z(ic)
      xid = x(id)
      yid = y(id)
      zid = z(id)
      xba = xib - xia
      yba = yib - yia
      zba = zib - zia
      xcb = xic - xib
      ycb = yic - yib
      zcb = zic - zib
      xdc = xid - xic
      ydc = yid - yic
      zdc = zid - zic
      a1 = yba*zcb - ycb*zba
      b1 = xcb*zba - xba*zcb
      c1 = xba*ycb - xcb*yba
      a2 = ycb*zdc - ydc*zcb
      b2 = xdc*zcb - xcb*zdc
      c2 = xcb*ydc - xdc*ycb
      cosine = (a1*a2+b1*b2+c1*c2) / sqrt((a1*a1+b1*b1+c1*c1)
     &     *(a2*a2+b2*b2+c2*c2))
      cosine = min(1.0d0,max(-1.0d0,cosine))
      dihed = radian * acos(cosine)
      sign = xba*a2 + yba*b2 + zba*c2
      if (sign .lt. 0.0d0)  dihed = -dihed
      return
      end
