      SUBROUTINE PSGMD(NATOM,IBLO,INB,IDXSUB,LSTSUB,AMASS,SMASS,
     &           FREE,DRAG,VSG,USG)
CWXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW
CWXW   THIS ROUTINE PERFORM INITIATION FOR THE LOCAL FREE ENERGY    *WXW
CWXW    GUIDED MD (THE SELF-GUIDED MD) SIMULAITON                   *WXW
CWXW                                                                *WXW
CWXW   By Xiongwu Wu, Ph.D.                                         *WXW
CWXW                Last update: 7/30/1998 at Georgetown University *WXW
CWXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW
#ifdef DPREC 
      implicit double precision (a-h,o-z)
#endif
      dimension IBLO(*),INB(*),AMASS(*)
      DIMENSION IDXSUB(*),LSTSUB(*)
      DIMENSION SMASS(*),FREE(*)
      DIMENSION DRAG(*),VSG(*),USG(*)
      DIMENSION ITEMP(36),JTEMP(36*36)
#include "sgmd.h"
CWXW    build up bonded substructure list
	JJ=0
	KK=0
	NTEMP=0
	DO I=1,NATOM
	  IDXSUB(I)=KK+1
CWXW      check the temporary array for structure members
	  DO J=1,NTEMP
	    IF(ITEMP(J).EQ.I)THEN
	      LL=36*(J-1)+1
	      DO WHILE (JTEMP(LL).NE.0) 
		KK=KK+1
		LSTSUB(KK)=JTEMP(LL)
		JTEMP(LL)=0
		LL=LL+1
	      END DO
CWXW       shift down the temperary array
	        LL=36*(J-1)+1
	        NN=36*(NTEMP-1)+1
	        DO WHILE (JTEMP(NN).NE.0)
		  JTEMP(LL)=JTEMP(NN)
		  JTEMP(NN)=0
		  NN=NN+1
		  LL=LL+1
	        END DO
	        ITEMP(J)=ITEMP(NTEMP)
	        ITEMP(NTEMP)=0
	        NTEMP=NTEMP-1
	    END IF
	  END DO
CWXW      update from exlusion list
	  NEX=IBLO(I)
	  DO J=JJ+1,JJ+NEX
	    K=INB(J)
	    IF(K.EQ.0) GOTO 99
	    KK=KK+1
	    LSTSUB(KK)=K
CWXW      put atom i to temporary array
	    IPUT=0
	    DO L=1, NTEMP
	      IF(ITEMP(L).EQ.K) THEN
	        LL=36*(L-1)+1
		DO WHILE (JTEMP(LL).NE.0)
		  LL=LL+1
		END DO
		JTEMP(LL)=I
		IPUT=1
  	      END IF
	    END DO
CWXW      if atom i is not in temporary array creat new one
c	  write(*,'(i5,i5,36i5)')i,ntemp,KK,k,iput
	    IF(IPUT.EQ.0)THEN
	      NTEMP=NTEMP+1
	      ITEMP(NTEMP)=K
	      JTEMP(36*(NTEMP-1)+1)=I
	      DO M=2,36
	        JTEMP(36*(NTEMP-1)+M)=0
	      END DO
	    ENDIF
99	  CONTINUE
	  END DO
	  JJ=JJ+NEX
	END DO
	IDXSUB(NATOM+1)=KK+1
CWXW    calculate total mass of each substructure
	DO I=1,NATOM
	  IS1=IDXSUB(I)
	  IS2=IDXSUB(I+1)-1
	  I3=3*(I-1)
	  AMASSI=AMASS(I)
	  SMASS(I)=1.0D0/AMASSI
CWXW    initialize arrays
	  DO M=1,3
	    FREE(I3+M)=0.0D0
	    DRAG(I3+M)=0.0D0
	    VSG(I3+M)=0.0D0
	    USG(I3+M)=0.0D0
	  END DO
	  DO J=IS1,IS2
	    K=LSTSUB(J)
	    SMASS(I)=SMASS(I)+1.0D0/AMASS(K)
	  END DO
	END DO
	TSMASS=0.0D0
	DO I=ISGSTA,ISGEND
	  AMASSI=AMASS(I)
	  SMASSI=SMASS(I)
	  TSMASS=TSMASS+SMASSI**2/AMASSI**2
	END DO
	EKSGT=0.0D0
	EKSGR=0.0D0
	EFREE=0.0D0
	RETURN
	END



      SUBROUTINE FDRAG(NATOM,IDXSUB,LSTSUB,AMASS,
     &                  F,X,V,SMASS,FREE,DRAG,VSG,USG)
CWXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW
CWXW   THIS ROUTINE CALCULATE THE AVERAGE FORCE AND ACTUAL          *WXW
CWXW   DRAGING FORCE FOR THE LOCAL FREE ENERGY                      *WXW
CWXW    GUIDED MD (THE SELF-GUIDED MD) SIMULAITON                   *WXW
CWXW                                                                *WXW
CWXW   By Xiongwu Wu, Ph.D.                                         *WXW
CWXW                Last update: 7/30/1998 at Georgetown University *WXW
CWXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW
#ifdef DPREC 
      implicit double precision (a-h,o-z)
#endif
      dimension AMASS(*),F(*),V(*),X(*)
      DIMENSION XST(36),YST(36),ZST(36)
      DIMENSION IDXSUB(*),LSTSUB(*)
      DIMENSION SMASS(*),FREE(*)
      DIMENSION DRAG(*),VSG(*),USG(*)
#include "sgmd.h"
C     CALCULATE AVERAGE NONBONDED FORCE
	DO I=1,3*NATOM
	  FREE(I)=SGAVG0*FREE(I)+SGAVG1*(F(I)+DRAG(I))
	  DRAG(I)=0.0D0
	  VSG(I)=SGAVG0*VSG(I)
	  USG(I)=SGAVG0*USG(I)
	END DO
	EKSGT=0.0D0
	DO I=ISGSTA,ISGEND
CWXW    calculate torque of the substructure of atom i
	  AMASSI=AMASS(I)
	  SMASSI=SMASS(I)
	  IS1=IDXSUB(I)
	  IS2=IDXSUB(I+1)-1
	  I3=3*(I-1)
	  FREEXI=FREE(I3+1)
	  FREEYI=FREE(I3+2)
	  FREEZI=FREE(I3+3)
C      accumlate the NEW DRAG FORCE
	  DRAG(I3+1)=DRAG(I3+1)+SGFT*(FREEXI/SMASSI)/AMASSI
	  DRAG(I3+2)=DRAG(I3+2)+SGFT*(FREEYI/SMASSI)/AMASSI
	  DRAG(I3+3)=DRAG(I3+3)+SGFT*(FREEZI/SMASSI)/AMASSI
	  VFBXI=V(I3+1)/AMASSI
	  VFBYI=V(I3+2)/AMASSI
	  VFBZI=V(I3+3)/AMASSI
	  ISI=0
 	  DO J=IS1,IS2
	    ISI=ISI+1
	    K=LSTSUB(J)
	    AMASSK=AMASS(K)
	    DRAG(3*K-2)=DRAG(3*K-2)+SGFT*(FREEXI/SMASSI)/AMASSK
	    DRAG(3*K-1)=DRAG(3*K-1)+SGFT*(FREEYI/SMASSI)/AMASSK
	    DRAG(3*K)=DRAG(3*K)+SGFT*(FREEZI/SMASSI)/AMASSK
	    VFBXI=VFBXI+V(3*K-2)/AMASSK
	    VFBYI=VFBYI+V(3*K-1)/AMASSK
	    VFBZI=VFBZI+V(3*K)/AMASSK
	  END DO
	  VSG(I3+1)=VSG(I3+1)+SGAVG1*VFBXI
	  VSG(I3+2)=VSG(I3+2)+SGAVG1*VFBYI
	  VSG(I3+3)=VSG(I3+3)+SGAVG1*VFBZI
CWXW     calculate total square translation momentum ***
	  EKSGT=EKSGT+
     &    (VSG(I3+1)**2+VSG(I3+2)**2+VSG(I3+3)**2)
	END DO
	RETURN
	END


	SUBROUTINE SGMOVE(NATOM,NTT,SCALP,SCALS,DTX,AMASS,F,DRAG,V)
CWXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW
CWXW   THIS ROUTINE PERFORM FORCE MODIFICATION AND CALCULATE        *WXW
CWXW   ENERGY COSERVING SCALING FACTOR FOR THE LOCAL FREE ENERGY    *WXW
CWXW    GUIDED MD (THE SELF-GUIDED MD) SIMULAITON                   *WXW
CWXW                                                                *WXW
CWXW   By Xiongwu Wu, Ph.D.                                         *WXW
CWXW                Last update: 7/30/1998 at Georgetown University *WXW
CWXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW*WXW
#ifdef DPREC 
      implicit double precision (a-h,o-z)
#endif
      dimension AMASS(*),F(*),V(*),DRAG(*)
#include "sgmd.h"
CWXW	estimate NVE scaling factor for the guided motion
      	FGUID=0.0D0
      	FMOVE=0.0D0
      	EKIN=0.0D0
      	DO  I = 1,NATOM 
          WIN = AMASS(I)*DTX
          DO  M = 1,3
            I3 = 3*(I-1)+M
	    VI3=V(I3)
            DELTV = (F(I3)+DRAG(I3))*WIN
	    FGUID=FGUID+DRAG(I3)*(VI3+DELTV/2.0)
	    FMOVE=FMOVE+F(I3)*(VI3+DELTV/2.0)
	    EKIN=EKIN+VI3*VI3/WIN
  	  END DO
	END DO
	EFREE=SGAVG0*EFREE+SGAVG1*FGUID
	IF(NTT.GT.5) GOTO 1000
	SCALF=DSQRT((2.0D0*FMOVE+EKIN)/(2.0D0*(FGUID+FMOVE)+EKIN))
	SCALP=SCALP*SCALF
	SCALS=SCALS*SCALF
1000   	DO  I = 1,3*NATOM 
	  F(I)=F(I)+DRAG(I)
	END DO
	RETURN
	END
