c
c
c     ###################################################
c     ##  COPYRIGHT (C)  1996  by  Jay William Ponder  ##
c     ##              All Rights Reserved              ##
c     ###################################################
c
c     ##############################################################
c     ##                                                          ##
c     ##  program getcalls  --  produce cross index from listing  ##
c     ##                                                          ##
c     ##############################################################
c
c
c     "getcalls" takes the formatted source listing produced by the
c     Digital F77 compiler -V option, and generates a list of the
c     function and subroutine calls made by each source code module
c
c     note that the 3 spaces separating each word in the output can
c     be replaced by single tabs to format the output for inclusion
c     in the TINKER User's Guide
c
c
      program getcalls
      implicit none
      include 'iounit.i'
      integer maxunit,maxcall
      parameter (maxunit=500)
      parameter (maxcall=100)
      integer i,k,idoc,isrc,ikey
      integer nunit,next,leng
      integer freeunit,trimtext
      integer ncall(maxunit),key(maxunit)
      character*16 string
      character*16 routine(maxunit)
      character*16 call(maxcall,maxunit)
      character*60 docfile,srcfile
      character*132 record
      logical exist,done
c
c
c     get the name of the formatted source code listing file
c
      isrc = freeunit ()
      exist = .false.
      dowhile (.not. exist)
         write (iout,10)
   10    format (/,' Enter Name of Source Code Listing File :  ',$)
         read (input,20)  srcfile
   20    format (a60)
         call suffix (srcfile,'txt')
         call version (srcfile,'old')
         inquire (file=srcfile,exist=exist)
      end do
      open (unit=isrc,file=srcfile,status='old')
c
c     find and store the calls made by each routine
c
      i = 0
      dowhile (.true.)
         k = 0
         read (isrc,30,end=70)  record
   30    format (a132)
         if (record(1:25) .eq. 'FUNCTIONS AND SUBROUTINES') then
            i = i + 1
            read (isrc,40)
   40       format (//)
            done = .false.
            dowhile (.not. done)
               read (isrc,50)  record
   50          format (a132)
               leng = trimtext (record)
               if (leng .lt. 8) then
                  done = .true.
               else
                  next = 1
                  dowhile (next .lt. leng)
                     call getword (record,string,next)
                     if (string(2:2) .ne. '*') then
                        k = k + 1
                        call(k,i) = string
                     end if
                  end do
               end if
            end do
            read (isrc,60)  record
   60       format (a132)
            next = 1
            call getword (record,routine(i),next)
            ncall(i) = k
         end if
      end do
   70 continue
      nunit = i
      close (unit=isrc)
c
c     write the list of calls made by each routine
c
      call sort7 (nunit,routine,key)
      idoc = freeunit ()
      docfile = 'calls.doc'
      call version (docfile,'new')
      open (unit=idoc,file=docfile,status='new')
      do i = 1, nunit
         ikey = key(i)
         call sort6 (ncall(ikey),call(1,ikey))
         write (idoc,90)  routine(i)(1:trimtext(routine(i))),
     &                    (call(k,ikey)(1:trimtext(call(k,ikey))),
     &                             k=1,min(ncall(ikey),5))
   90    format (/,a,5(3x,a))
         if (ncall(ikey) .gt. 5) then
            write (idoc,100)  (call(k,ikey)(1:trimtext(call(k,ikey))),
     &                                  k=6,ncall(ikey))
  100       format (5(3x,a))
         end if
      end do
      close (unit=idoc)
      write (iout,110)  docfile(1:trimtext(docfile))
  110 format (/,' Cross Index Listing Written To:  ',a)
c
c     perform any final tasks before program exit
c
      call final
      end
