c
c
c     ###################################################
c     ##  COPYRIGHT (C)  1997  by  Jay William Ponder  ##
c     ##              All Rights Reserved              ##
c     ###################################################
c
c     ###########################################################
c     ##                                                       ##
c     ##  function bndleng  --  bond length between two atoms  ##
c     ##                                                       ##
c     ###########################################################
c
c
c     "bndleng" finds the value of the bond length defined
c     by two input atoms
c
c
      function bndleng (ia,ib)
      implicit none
      include 'sizes.i'
      include 'atoms.i'
      integer ia,ib
      real*8 bndleng
      real*8 xab,yab,zab
      real*8 rab2
c
c
c     set default value in case atoms are degenerate
c
      bndleng = 0.0d0
c
c     compute the value in Angstroms of the bond length
c
      xab = x(ia) - x(ib)
      yab = y(ia) - y(ib)
      zab = z(ia) - z(ib)
      rab2 = xab*xab + yab*yab + zab*zab
      if (rab2 .ne. 0.0d0) then
         bndleng = sqrt(rab2)
      end if
      return
      end
