c
c
c     ###################################################
c     ##  COPYRIGHT (C)  1997  by  Jay William Ponder  ##
c     ##              All Rights Reserved              ##
c     ###################################################
c
c     #################################################################
c     ##                                                             ##
c     ##  subroutine initprm  --  initialize force field parameters  ##
c     ##                                                             ##
c     #################################################################
c
c
c     "initprm" completely initializes a force field by setting
c     all values to zero prior to reading in a parameter set
c
c
      subroutine initprm
      implicit none
      include 'sizes.i'
      include 'fields.i'
      include 'kanang.i'
      include 'kangs.i'
      include 'katoms.i'
      include 'kbonds.i'
      include 'kchrge.i'
      include 'kdipol.i'
      include 'khbond.i'
      include 'kiprop.i'
      include 'kitors.i'
      include 'kmulti.i'
      include 'kopbnd.i'
      include 'kopdst.i'
      include 'korbs.i'
      include 'kpolr.i'
      include 'kstbnd.i'
      include 'ksttor.i'
      include 'ktorsn.i'
      include 'kurybr.i'
      include 'kvdws.i'
      include 'kvdwpr.i'
      integer i,j
c
c
c     initialize strings of parameter atom types and classes
c
      do i = 1, maxnvp
         kvpr(i) = '      '
      end do
      do i = 1, maxnhb
         khb(i) = '      '
      end do
      do i = 1, maxnb
         kb(i) = '      '
      end do
      do i = 1, maxnb5
         kb5(i) = '      '
      end do
      do i = 1, maxnb4
         kb4(i) = '      '
      end do
      do i = 1, maxnb3
         kb3(i) = '      '
      end do
      do i = 1, maxna
         ka(i) = '         '
      end do
      do i = 1, maxna5
         ka5(i) = '         '
      end do
      do i = 1, maxna4
         ka4(i) = '         '
      end do
      do i = 1, maxna3
         ka3(i) = '         '
      end do
      do i = 1, maxnaf
         kaf(i) = '         '
      end do
      do i = 1, maxnu
         ku(i) = '         '
      end do
      do i = 1, maxnopb
         kaopb(i) = '      '
      end do
      do i = 1, maxnopd
         kaopd(i) = '            '
      end do
      do i = 1, maxndi
         kdi(i) = '            '
      end do
      do i = 1, maxnti
         kti(i) = '            '
      end do
      do i = 1, maxnt
         kt(i) = '            '
      end do
      do i = 1, maxnt5
         kt5(i) = '            '
      end do
      do i = 1, maxnt4
         kt4(i) = '            '
      end do
      do i = 1, maxnbt
         kbt(i) = '      '
      end do
      do i = 1, maxnd
         kd(i) = '      '
      end do
      do i = 1, maxnd5
         kd5(i) = '      '
      end do
      do i = 1, maxnd4
         kd4(i) = '      '
      end do
      do i = 1, maxnd3
         kd3(i) = '      '
      end do
      do i = 1, maxnmp
         kmp(i) = '         '
      end do
      do i = 1, maxnpi
         kpi(i) = '      '
      end do
c
c     initialize some of the force field parameters
c
      forcefield = '                    '
      do i = 1, maxtyp
         symbol(i) = '   '
         atmcls(i) = 0
         atmnum(i) = 0
         weight(i) = 0.0d0
         ligand(i) = 0
         describe(i) = '                    '
         chg(i) = 0.0d0
         polr(i) = 0.0d0
      end do
      do i = 1, maxclass
         rad(i) = 0.0d0
         eps(i) = 0.0d0
         rad4(i) = 0.0d0
         eps4(i) = 0.0d0
         reduct(i) = 0.0d0
         do j = 1, 3
            stbn(j,i) = 0.0d0
            anan(j,i) = 0.0d0
         end do
         electron(i) = 0.0d0
         ionize(i) = 0.0d0
         repulse(i) = 0.0d0
      end do
      do i = 1, maxbio
         biotyp(i) = 0
      end do
      return
      end
