/*c
c
c     ###################################################
c     ##  COPYRIGHT (C)  1992  by  Jay William Ponder  ##
c     ##              All Rights Reserved              ##
c     ###################################################
c
c     #############################################################
c     ##                                                         ##
c     ##  sizes.h  --  parameter values to set array dimensions  ##
c     ##                                                         ##
c     #############################################################
c
c
c     "sizes.h" sets values for critical array dimensions used
c     throughout the software; these parameters will fix the size
c     of the largest systems that can be handled; values too large
c     for the computer's memory and/or swap space to accomodate
c     will result in poor performance or outright failure
c
c     parameter:      maximum allowed number of:
c
c     maxatm          atoms in the molecular system
c     maxval          atoms directly bonded to an atom
c     maxgrp          user-defined groups of atoms
c     maxtyp          force field atom type definitions
c     maxclass        force field atom class definitions
c     maxkey          lines in the keyword file
c     maxrot          bonds for torsional rotation
c     maxhess         off-diagonal Hessian elements
c     maxopt          optimization variables (full-matrix)
c     maxvib          vibrational frequencies
c     maxgeo          distance geometry points
c     maxpi           atoms in conjugated pisystem
c     maxcell         unit cells in replicated crystal
c     maxring         3-, 4-, or 5-membered rings
c     maxfix          geometric restraints
c     maxbio          biopolymer atom definitions
c     maxres          residues in the macromolecule
c     maxamino        amino acid residue types
c     maxvar          optimization variables (linear storage)
c     maxbnd          covalent bonds in molecular system
c     maxang          bond angles in molecular system
c     maxtors         dihedral angles in molecular system
c     maxlight        sites for method of lights neighbors
c     maxpib          covalent bonds in pisystem
c     maxpit          dihedrals involving pisystem
c
c
*/
      	const int maxatm=10000,maxpi=50,maxgrp=100,maxtyp=1000,maxval=4;
	int maxclass=500,maxkey=5000,maxrot=500;
	int maxhess=1000000,maxopt=500,maxvib=500,maxgeo=500, maxcell=5000,maxring=500;
      	int maxfix=5000,maxbio=500,maxres=500,maxamino=31,maxvar=3*maxatm,maxbnd=6*maxatm/5;
	int maxang=12*maxatm/5, maxtors=4*maxatm,maxlight=8*maxatm,maxpib=6*maxpi/5;
	int maxpit=4*maxpi;
