c
c
c     ###################################################
c     ##  COPYRIGHT (C)  1992  by  Jay William Ponder  ##
c     ##              All Rights Reserved              ##
c     ###################################################
c
c     #############################################################
c     ##                                                         ##
c     ##  sizes.i  --  parameter values to set array dimensions  ##
c     ##                                                         ##
c     #############################################################
c
c
c     "sizes.i" sets values for critical array dimensions used
c     throughout the software; these parameters will fix the size
c     of the largest systems that can be handled; values too large
c     for the computer's memory and/or swap space to accomodate
c     will result in poor performance or outright failure
c
c     parameter:      maximum allowed number of:
c
c     maxatm          atoms in the molecular system
c     maxval          atoms directly bonded to an atom
c     maxgrp          user-defined groups of atoms
c     maxtyp          force field atom type definitions
c     maxclass        force field atom class definitions
c     maxkey          lines in the keyword file
c     maxrot          bonds for torsional rotation
c     maxhess         off-diagonal Hessian elements
c     maxopt          optimization variables (full-matrix)
c     maxvib          vibrational frequencies
c     maxgeo          distance geometry points
c     maxpi           atoms in conjugated pisystem
c     maxcell         unit cells in replicated crystal
c     maxring         3-, 4-, or 5-membered rings
c     maxfix          geometric restraints
c     maxbio          biopolymer atom definitions
c     maxres          residues in the macromolecule
c     maxamino        amino acid residue types
c     maxvar          optimization variables (linear storage)
c     maxbnd          covalent bonds in molecular system
c     maxang          bond angles in molecular system
c     maxtors         dihedral angles in molecular system
c     maxlight        sites for method of lights neighbors
c     maxpib          covalent bonds in pisystem
c     maxpit          dihedrals involving pisystem
c
c
      integer maxatm,maxval,maxgrp,maxtyp,maxclass,maxkey,maxrot
      integer maxhess,maxopt,maxvib,maxgeo,maxpi,maxcell,maxring
      integer maxfix,maxbio,maxres,maxamino,maxvar,maxbnd,maxang
      integer maxtors,maxlight,maxpib,maxpit
      parameter (maxatm=10000)
      parameter (maxval=4)
      parameter (maxgrp=100)
      parameter (maxtyp=1000)
      parameter (maxclass=500)
      parameter (maxkey=10000)
      parameter (maxrot=1000)
      parameter (maxhess=1000000)
      parameter (maxopt=1000)
      parameter (maxvib=1000)
      parameter (maxgeo=1000)
      parameter (maxpi=100)
      parameter (maxcell=1000)
      parameter (maxring=1000)
      parameter (maxfix=10000)
      parameter (maxbio=1000)
      parameter (maxres=1000)
      parameter (maxamino=31)
      parameter (maxvar=3*maxatm)
      parameter (maxbnd=6*maxatm/5)
      parameter (maxang=12*maxatm/5)
      parameter (maxtors=4*maxatm)
      parameter (maxlight=8*maxatm)
      parameter (maxpib=6*maxpi/5)
      parameter (maxpit=4*maxpi)
