	subroutine empole8	

	implicit none
	
	
	include 'sizes.i'
	include 'atmtyp.i'
	include 'atoms.i'
	include 'couple.i'
	include 'files.i'
	include 'iounit.i'
	include 'title.i'
	include 'mpole.i'
	include 'mpole1.i'
	include 'mpole2.i'
	include 'switch.i'
	include 'd2cut.i'
	include 'newco.i'


	integer i,j,k,l,p,q
	real*8 rm1(13),rm2(13)
	real*8 dm1(13),dm2(13)
	real*8 d0(3),di(3,3),dj(3,3)
	real*8 mjd2tmi(3,3),mjdtdmi(3,3,3),dmjdtmi(3,3,3),dmjtdmi(3,3,3,3)
	real*8 mjtd2mi(3,3,3,3),d2mjtmi(3,3,3,3)
	real*8 en,emdqij2,emdqij2new,eij
	real*8 dempole(3,1000)
	real*8 d2e(3,30,3,30)
	real*8 h(200000),hdiag(3,1000),ht(200000),hone(1000)
	real*8 dij(3,6),d2ij(3,6,3,6)
	real*8 r,r2,dx,dy,dz,old
	real*8 ron,roff,ronsq,roffsq
	real*8 rij,rijsq,rij3,rij4,rij5,rij6,rij7
	real*8 chg,shift,monoi
	real*8 dsdt_term,dtaper,dtrans,taper,trans
	real*8 d2taper,d2trans,d2sd2t_term1,d2sd2t_term2
	real tm,tarray(2),dtime
	real*8 dxyz(3),d2xyz,dxyzpq1,dxyzpq2,dxyzpq,linkikjl,hmax,tmax
	real*8 comp1,comp2
	integer skip(maxatm)
	integer jcn(200000),link(200000),irowst(1000),oldp(1000)
	integer ii,atomi,atomj,oldst,nextfree,pointer,oldpointer,listend,m
	integer hstart(3,1000),hstop(3,1000),htp,smallp,honep
	integer hjcn(200000),hjone(1000)
	integer start,stop
	logical cutoff,fullmatrix

	write(*,102)
 102	format($'Cutoff? ')
	read(*,*) cutoff

	write(*,103)
 103	format($'Cutoff for hessian? ')
	read(*,*) hcut

	write(*,104)
 104	format($'Full matrix? ')
	read(*,*) fullmatrix

	ron = 10000.0d0
	roff = 10010.0d0
	if(cutoff) then
		ron = 8.0d0
		roff = 12.0d0
	end if
	ronsq = ron*ron
	roffsq = roff*roff

	call smooth(ron,roff)

	do i=1,n
		skip(i) = 0
		call getzxy2(i)
		call derm(i)
		call d2mpole(i)
		call rot(i)
		do j=1,3
			dempole(j,i) = 0.0d0
		end do
		do j=1,n
			do k=1,3
				do l=1,3
					d2e(k,i,l,j) = 0.0d0
				end do
			end do
		end do
	end do
	
	do i=1,n
		z(i) = z(i) + 0.5d0
	end do

	if(.not. fullmatrix) go to 1000

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c	full matrix storage
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	tm = dtime(tarray)
	en = 0.0d0
	do i=1,n-1
		if(e14) then
	        	do k = 1, n12(i)
  		        	skip(i12(k,i)) = i
        		end do
   	    		do k = 1, n13(i)
   	    			skip(i13(k,i)) = i
   	    		end do
		end if
		do k=1,len
			rm1(k) = rmultip(i,k)
		end do
		monoi = rmultip(i,1)
		do j=i+1,n
			if(skip(j) .ne. i) then	
				dxyz(1) = x(j) - x(i)
				dxyz(2) = y(j) - y(i)
				dxyz(3) = z(j) - z(i)
				rijsq = dxyz(1)*dxyz(1) + dxyz(2)*dxyz(2) + dxyz(3)*dxyz(3)					
				if(rijsq .le. roffsq) then
					do k = 1, len
		           	rm2(k) = rmultip(j,k)
		         end do
					eij = emdqij2(i,j,rm1,rm2,d0,di,dj,mjd2tmi,mjdtdmi,
     &			dmjdtmi,dmjtdmi,mjtd2mi,d2mjtmi)

					do p=1,3
						dij(p,1) = -d0(p) + di(1,p)
						dij(p,2) = di(2,p)
						dij(p,3) = di(3,p)
						dij(p,4) = d0(p) + dj(1,p)
						dij(p,5) = dj(2,p)
						dij(p,6) = dj(3,p)
					end do

					do p=1,3
						do q=1,3
							d2ij(p,1,q,1) = mjd2tmi(p,q) - mjdtdmi(p,1,q)
     &										  -mjdtdmi(q,1,p) + mjtd2mi(1,p,1,q)
							d2ij(p,1,q,2) = -mjdtdmi(p,2,q) + mjtd2mi(1,p,2,q)
							d2ij(p,1,q,3) = -mjdtdmi(p,3,q) + mjtd2mi(1,p,3,q)
							d2ij(p,1,q,4) = -mjd2tmi(p,q) - dmjdtmi(p,1,q)
     &										 + dmjtdmi(1,q,1,p) + mjdtdmi(q,1,p)
							d2ij(p,1,q,5) = -dmjdtmi(p,2,q) + dmjtdmi(2,q,1,p)
							d2ij(p,1,q,6) = -dmjdtmi(p,3,q) + dmjtdmi(3,q,1,p)

							d2ij(p,2,q,1) = -mjdtdmi(q,2,p) + mjtd2mi(2,p,1,q)
							d2ij(p,2,q,2) = mjtd2mi(2,p,2,q)
							d2ij(p,2,q,3) = mjtd2mi(2,p,3,q)
							d2ij(p,2,q,4) = dmjtdmi(1,q,2,p) + mjdtdmi(q,2,p)
							d2ij(p,2,q,5) = dmjtdmi(2,q,2,p)
							d2ij(p,2,q,6) = dmjtdmi(3,q,2,p)
	
							d2ij(p,3,q,1) = -mjdtdmi(q,3,p) + mjtd2mi(3,p,1,q)
							d2ij(p,3,q,2) = mjtd2mi(3,p,2,q)
							d2ij(p,3,q,3) = mjtd2mi(3,p,3,q)
							d2ij(p,3,q,4) = dmjtdmi(1,q,3,p) + mjdtdmi(q,3,p)
							d2ij(p,3,q,5) = dmjtdmi(2,q,3,p)
							d2ij(p,3,q,6) = dmjtdmi(3,q,3,p)


 							d2ij(p,4,q,1) = -dmjdtmi(q,1,p) + dmjtdmi(1,p,1,q)
     &										  -mjd2tmi(p,q) + mjdtdmi(p,1,q)
							d2ij(p,4,q,2) = dmjtdmi(1,p,2,q) + mjdtdmi(p,2,q)
							d2ij(p,4,q,3) = dmjtdmi(1,p,3,q) + mjdtdmi(p,3,q)
							d2ij(p,4,q,4) = d2mjtmi(1,p,1,q) + dmjdtmi(q,1,p)
     &						  + dmjdtmi(p,1,q) + mjd2tmi(p,q)
							d2ij(p,4,q,5) = d2mjtmi(1,p,2,q) + dmjdtmi(p,2,q)
							d2ij(p,4,q,6) = d2mjtmi(1,p,3,q) + dmjdtmi(p,3,q)
	
							d2ij(p,5,q,1) = -dmjdtmi(q,2,p) + dmjtdmi(2,p,1,q)
 							d2ij(p,5,q,2) = dmjtdmi(2,p,2,q)
							d2ij(p,5,q,3) = dmjtdmi(2,p,3,q)
							d2ij(p,5,q,4) = d2mjtmi(2,p,1,q) + dmjdtmi(q,2,p)
							d2ij(p,5,q,5) = d2mjtmi(2,p,2,q)
							d2ij(p,5,q,6) = d2mjtmi(2,p,3,q)

							d2ij(p,6,q,1) = -dmjdtmi(q,3,p) + dmjtdmi(3,p,1,q)
							d2ij(p,6,q,2) = dmjtdmi(3,p,2,q)
							d2ij(p,6,q,3) = dmjtdmi(3,p,3,q)
							d2ij(p,6,q,4) = d2mjtmi(3,p,1,q) + dmjdtmi(q,3,p)
							d2ij(p,6,q,5) = d2mjtmi(3,p,2,q)
							d2ij(p,6,q,6) = d2mjtmi(3,p,3,q)
						end do
					end do
					
					chg = monoi * rmultip(j,1)
					shift = chg / (0.5*(ron + roff))

					if(rijsq .gt. ronsq) then
						rij = sqrt(rijsq)
						rij3 = rijsq * rij
						rij4 = rijsq * rijsq
						rij5 = rijsq * rij3
						rij6 = rij3 * rij3
						rij7 = rij4 * rij3
						taper = c5*rij5 + c4*rij4 + c3*rij3
     &                             + c2*rijsq + c1*rij + c0
						trans = chg * (f7*rij7 + f6*rij6 + f5*rij5 + f4*rij4
     &                                            + f3*rij3 + f2*rijsq
     &                                            + f1*rij + f0)
						dtaper = 5.0d0*c5*rij4 + 4.0d0*c4*rij3 + 3.0d0*c3*rijsq
     &													 + 2.0d0*c2*rij + c1
						dtrans = chg * (7.0d0*f7*rij6 + 6.0d0*f6*rij5 
     &						+ 5.0d0*f5*rij4+ 4.0d0*f4*rij3 
     &						+ 3.0d0*f3*rijsq + 2.0d0*f2*rij + f1)

						d2taper = 20.0d0*c5*rij3 + 12.0d0*c4*rijsq + 6.0d0*c3*rij
     &						+ 2.0d0*c2
						d2trans = chg * (42.0d0*f7*rij5 + 30.0d0*f6*rij4 
     &						+ 20.0d0*f5*rij3+ 12.0d0*f4*rijsq 
     &						+ 6.0d0*f3*rij + 2.0d0*f2)
						dsdt_term = ((eij-shift)*dtaper + dtrans)/rij
						d2sd2t_term1 = ((eij-shift)*d2taper + d2trans)/rijsq
						d2sd2t_term2 = dsdt_term/rijsq
						dtaper = dtaper/rij
			
						do p=1,3
							do q=1,3
								d2xyz = dxyz(p)*dxyz(q)
								dxyzpq1 = d2sd2t_term1*d2xyz
								if(p .eq. q) then
									d2xyz = rijsq - d2xyz
								else
									d2xyz = - d2xyz
								end if
								dxyzpq2 = d2sd2t_term2*d2xyz
								dxyzpq = dxyzpq1 + dxyzpq2
								
								
								d2ij(p,1,q,1) = d2ij(p,1,q,1)*taper 
     &-(dij(p,1)*dxyz(q) + dij(q,1)*dxyz(p))*dtaper + dxyzpq
								d2ij(p,1,q,2) = d2ij(p,1,q,2)*taper 
     &-dij(q,2)*dxyz(p)*dtaper
								d2ij(p,1,q,3) = d2ij(p,1,q,3)*taper
     &-dij(q,3)*dxyz(p)*dtaper
								d2ij(p,1,q,4) = d2ij(p,1,q,4)*taper
     &+(dij(p,1)*dxyz(q) - dij(q,4)*dxyz(p))*dtaper - dxyzpq
								d2ij(p,1,q,5) = d2ij(p,1,q,5)*taper
     &-dij(q,5)*dxyz(p)*dtaper
								d2ij(p,1,q,6) = d2ij(p,1,q,6)*taper
     &-dij(q,6)*dxyz(p)*dtaper

								d2ij(p,2,q,1) = d2ij(p,2,q,1)*taper
     &-dij(p,2)*dxyz(q)*dtaper
								d2ij(p,2,q,2) = d2ij(p,2,q,2)*taper
								d2ij(p,2,q,3) = d2ij(p,2,q,3)*taper
								d2ij(p,2,q,4) = d2ij(p,2,q,4)*taper
     &+dij(p,2)*dxyz(q)*dtaper
								d2ij(p,2,q,5) = d2ij(p,2,q,5)*taper
								d2ij(p,2,q,6) = d2ij(p,2,q,6)*taper
	
								d2ij(p,3,q,1) = d2ij(p,3,q,1)*taper
     &-dij(p,3)*dxyz(q)*dtaper
								d2ij(p,3,q,2) = d2ij(p,3,q,2)*taper
								d2ij(p,3,q,3) = d2ij(p,3,q,3)*taper
								d2ij(p,3,q,4) = d2ij(p,3,q,4)*taper
     &+dij(p,3)*dxyz(q)*dtaper
								d2ij(p,3,q,5) = d2ij(p,3,q,5)*taper
								d2ij(p,3,q,6) = d2ij(p,3,q,6)*taper


 								d2ij(p,4,q,1) = d2ij(p,4,q,1)*taper
     &+(-dij(p,4)*dxyz(q) + dij(q,1)*dxyz(p))*dtaper - dxyzpq
								d2ij(p,4,q,2) = d2ij(p,4,q,2)*taper
     &+dij(q,2)*dxyz(p)*dtaper
								d2ij(p,4,q,3) = d2ij(p,4,q,3)*taper
     &+dij(q,3)*dxyz(p)*dtaper
								d2ij(p,4,q,4) = d2ij(p,4,q,4)*taper
     &+(dij(p,4)*dxyz(q) + dij(q,4)*dxyz(p))*dtaper + dxyzpq
								d2ij(p,4,q,5) = d2ij(p,4,q,5)*taper
     &+dij(q,5)*dxyz(p)*dtaper
								d2ij(p,4,q,6) = d2ij(p,4,q,6)*taper	
     &+dij(q,6)*dxyz(p)*dtaper

								d2ij(p,5,q,1) = d2ij(p,5,q,1)*taper
     &-dij(p,5)*dxyz(q)*dtaper
 								d2ij(p,5,q,2) = d2ij(p,5,q,2)*taper
								d2ij(p,5,q,3) = d2ij(p,5,q,3)*taper
								d2ij(p,5,q,4) = d2ij(p,5,q,4)*taper
     &+dij(p,5)*dxyz(q)*dtaper
								d2ij(p,5,q,5) = d2ij(p,5,q,5)*taper
								d2ij(p,5,q,6) = d2ij(p,5,q,6)*taper

								d2ij(p,6,q,1) = d2ij(p,6,q,1)*taper
     &-dij(p,6)*dxyz(q)*dtaper
								d2ij(p,6,q,2) = d2ij(p,6,q,2)*taper
								d2ij(p,6,q,3) = d2ij(p,6,q,3)*taper
								d2ij(p,6,q,4) = d2ij(p,6,q,4)*taper
     &+dij(p,6)*dxyz(q)*dtaper
								d2ij(p,6,q,5) = d2ij(p,6,q,5)*taper
								d2ij(p,6,q,6) = d2ij(p,6,q,6)*taper
							end do
						end do

						do p=1,3
							dij(p,1) = (-d0(p) + di(1,p))*taper
     &												- dsdt_term*dxyz(p)
							dij(p,2) = di(2,p)*taper
							dij(p,3) = di(3,p)*taper
							dij(p,4) = (d0(p) + dj(1,p))*taper
     &												+ dsdt_term*dxyz(p)
							dij(p,5) = dj(2,p)*taper
							dij(p,6) = dj(3,p)*taper
						end do

						eij = (eij-shift)*taper + trans
					else
						eij = eij - shift					
					end if
					
					en = en + eij
					do p=1,3
						dempole(p,i) = dempole(p,i) + dij(p,1)
						dempole(p,zaxis(i)) = dempole(p,zaxis(i)) + dij(p,2)
						dempole(p,xaxis(i)) = dempole(p,xaxis(i)) + dij(p,3)
						dempole(p,j) = dempole(p,j) + dij(p,4)
						dempole(p,zaxis(j)) = dempole(p,zaxis(j)) + dij(p,5)
						dempole(p,xaxis(j)) = dempole(p,xaxis(j)) + dij(p,6)
					end do
					do p=1,3
						do q=1,3
							d2e(p,i,q,i) = d2e(p,i,q,i) + d2ij(p,1,q,1)
							d2e(p,i,q,zaxis(i)) = d2e(p,i,q,zaxis(i))
     &					 									 + d2ij(p,1,q,2)
							d2e(p,i,q,xaxis(i)) = d2e(p,i,q,xaxis(i))
     &														 + d2ij(p,1,q,3)
							d2e(p,i,q,j) = d2e(p,i,q,j) + d2ij(p,1,q,4)
							d2e(p,i,q,zaxis(j)) = d2e(p,i,q,zaxis(j))
     &					 								    + d2ij(p,1,q,5)
							d2e(p,i,q,xaxis(j)) = d2e(p,i,q,xaxis(j))
     &														 + d2ij(p,1,q,6)

							d2e(p,zaxis(i),q,i) = d2e(p,zaxis(i),q,i)
     &														 + d2ij(p,2,q,1)
							d2e(p,zaxis(i),q,zaxis(i)) =d2e(p,zaxis(i),q,zaxis(i)) 
     &														 + d2ij(p,2,q,2)
							d2e(p,zaxis(i),q,xaxis(i)) =d2e(p,zaxis(i),q,xaxis(i)) 
     &					 									 + d2ij(p,2,q,3)
							d2e(p,zaxis(i),q,j) = d2e(p,zaxis(i),q,j)
     &														 + d2ij(p,2,q,4)
							d2e(p,zaxis(i),q,zaxis(j)) =d2e(p,zaxis(i),q,zaxis(j)) 
     &														 + d2ij(p,2,q,5) 
							d2e(p,zaxis(i),q,xaxis(j)) =d2e(p,zaxis(i),q,xaxis(j)) 
     &														 + d2ij(p,2,q,6) 
	
							d2e(p,xaxis(i),q,i) = d2e(p,xaxis(i),q,i)
     &					 								    + d2ij(p,3,q,1)
							d2e(p,xaxis(i),q,zaxis(i)) =d2e(p,xaxis(i),q,zaxis(i)) 
     &					 									 + d2ij(p,3,q,2)
							d2e(p,xaxis(i),q,xaxis(i)) =d2e(p,xaxis(i),q,xaxis(i)) 
     &					 									 + d2ij(p,3,q,3)
							d2e(p,xaxis(i),q,j) = d2e(p,xaxis(i),q,j)
     &					 									 + d2ij(p,3,q,4)
							d2e(p,xaxis(i),q,zaxis(j)) =d2e(p,xaxis(i),q,zaxis(j)) 
     &					 									 + d2ij(p,3,q,5)
							d2e(p,xaxis(i),q,xaxis(j)) =d2e(p,xaxis(i),q,xaxis(j)) 
     &					 									 + d2ij(p,3,q,6)


 							d2e(p,j,q,i) = d2e(p,j,q,i) + d2ij(p,4,q,1)
							d2e(p,j,q,zaxis(i)) = d2e(p,j,q,zaxis(i)) 
     &					 									 + d2ij(p,4,q,2)
							d2e(p,j,q,xaxis(i)) = d2e(p,j,q,xaxis(i)) 
     &					 									 + d2ij(p,4,q,3)
							d2e(p,j,q,j) = d2e(p,j,q,j) + d2ij(p,4,q,4)
							d2e(p,j,q,zaxis(j)) = d2e(p,j,q,zaxis(j)) 
     &					 									 + d2ij(p,4,q,5)
							d2e(p,j,q,xaxis(j)) = d2e(p,j,q,xaxis(j)) 
     &														 + d2ij(p,4,q,6)
	
							d2e(p,zaxis(j),q,i) = d2e(p,zaxis(j),q,i) 
     &					 									 + d2ij(p,5,q,1)
 							d2e(p,zaxis(j),q,zaxis(i)) =d2e(p,zaxis(j),q,zaxis(i))
     &					 									 + d2ij(p,5,q,2)
							d2e(p,zaxis(j),q,xaxis(i)) =d2e(p,zaxis(j),q,xaxis(i))
     &					 									 + d2ij(p,5,q,3)
							d2e(p,zaxis(j),q,j) = d2e(p,zaxis(j),q,j)
     &					 									 + d2ij(p,5,q,4)
							d2e(p,zaxis(j),q,zaxis(j)) =d2e(p,zaxis(j),q,zaxis(j))
     &					 									 + d2ij(p,5,q,5)
							d2e(p,zaxis(j),q,xaxis(j)) =d2e(p,zaxis(j),q,xaxis(j))
     &					 									 + d2ij(p,5,q,6)

							d2e(p,xaxis(j),q,i) = d2e(p,xaxis(j),q,i) 
     &														 + d2ij(p,6,q,1)
							d2e(p,xaxis(j),q,zaxis(i)) =d2e(p,xaxis(j),q,zaxis(i))
     &					 									 + d2ij(p,6,q,2)
							d2e(p,xaxis(j),q,xaxis(i)) =d2e(p,xaxis(j),q,xaxis(i))
     &					 									 + d2ij(p,6,q,3)
							d2e(p,xaxis(j),q,j) = d2e(p,xaxis(j),q,j)
     &					 									 + d2ij(p,6,q,4)
							d2e(p,xaxis(j),q,zaxis(j)) =d2e(p,xaxis(j),q,zaxis(j))
     &					 									 + d2ij(p,6,q,5)
							d2e(p,xaxis(j),q,xaxis(j)) =d2e(p,xaxis(j),q,xaxis(j))
     &					 									 + d2ij(p,6,q,6)
						end do
					end do
				end if		
 			end if
		end do
	end do
	tm = dtime(tarray)
	write(*,99) tm,tarray(1),tarray(2)
 99     format('Time:',3f20.10)


 1000	continue
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c	linked list
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	do i=1,n
		skip(i) = 0
		do j=1,3
			dempole(j,i) = 0.0d0
			hdiag(j,i) = 0.0d0
		end do
	end do

	nextfree = 1
	do i=1,n
		irowst(i) = 0
		oldp(i) = 0
	end do
	do i=1,10000
		link(i) = 0
	end do

	tm = dtime(tarray)
	en = 0.0d0
	do i=1,n-1
		if(e14) then
	        	do k = 1, n12(i)
  		        	skip(i12(k,i)) = i
        		end do
   	    		do k = 1, n13(i)
   	    			skip(i13(k,i)) = i
   	    		end do
		end if
		do k=1,len
			rm1(k) = rmultip(i,k)
		end do
		monoi = rmultip(i,1)
		do j=i+1,n
			if(skip(j) .ne. i) then	
				dxyz(1) = x(j) - x(i)
				dxyz(2) = y(j) - y(i)
				dxyz(3) = z(j) - z(i)
				rijsq = dxyz(1)*dxyz(1) + dxyz(2)*dxyz(2) + dxyz(3)*dxyz(3)					
				if(rijsq .le. roffsq) then
					do k = 1, len
		           	rm2(k) = rmultip(j,k)
		         end do
					rij = sqrt(rijsq)
					rij3 = rijsq * rij
					rij4 = rijsq * rijsq
					rij5 = rijsq * rij3
					rij6 = rij3 * rij3
					rij7 = rij4 * rij3
					rpower(1) = 1.0d0/rij
					rpower(2) = 1.0d0/rijsq
					rpower(3) = 1.0d0/rij3
					rpower(4) = 1.0d0/rij4
					rpower(5) = 1.0d0/rij5
					rpower(6) = 1.0d0/rij6
					rpower(7) = 1.0d0/rij7
					eij = emdqij2new(i,j,rij,rm1,rm2,d0,di,dj,mjd2tmi,mjdtdmi,
     &			dmjdtmi,dmjtdmi,mjtd2mi,d2mjtmi)

					do p=1,3
						dij(p,1) = -d0(p) + di(1,p)
						dij(p,2) = di(2,p)
						dij(p,3) = di(3,p)
						dij(p,4) = d0(p) + dj(1,p)
						dij(p,5) = dj(2,p)
						dij(p,6) = dj(3,p)
					end do

					do p=1,3
						do q=1,3
							d2ij(p,1,q,1) = mjd2tmi(p,q) - mjdtdmi(p,1,q)
     &										  -mjdtdmi(q,1,p) + mjtd2mi(1,p,1,q)
							d2ij(p,1,q,2) = -mjdtdmi(p,2,q) + mjtd2mi(1,p,2,q)
							d2ij(p,1,q,3) = -mjdtdmi(p,3,q) + mjtd2mi(1,p,3,q)
							d2ij(p,1,q,4) = -mjd2tmi(p,q) - dmjdtmi(p,1,q)
     &										 + dmjtdmi(1,q,1,p) + mjdtdmi(q,1,p)
							d2ij(p,1,q,5) = -dmjdtmi(p,2,q) + dmjtdmi(2,q,1,p)
							d2ij(p,1,q,6) = -dmjdtmi(p,3,q) + dmjtdmi(3,q,1,p)

							d2ij(q,2,p,1) = d2ij(p,1,q,2)
							d2ij(p,2,q,2) = mjtd2mi(2,p,2,q)
							d2ij(p,2,q,3) = mjtd2mi(2,p,3,q)
							d2ij(p,2,q,4) = dmjtdmi(1,q,2,p) + mjdtdmi(q,2,p)
							d2ij(p,2,q,5) = dmjtdmi(2,q,2,p)
							d2ij(p,2,q,6) = dmjtdmi(3,q,2,p)
	
							d2ij(q,3,p,1) = d2ij(p,1,q,3)
							d2ij(q,3,p,2) = d2ij(p,2,q,3)			
							d2ij(p,3,q,3) = mjtd2mi(3,p,3,q)
							d2ij(p,3,q,4) = dmjtdmi(1,q,3,p) + mjdtdmi(q,3,p)
							d2ij(p,3,q,5) = dmjtdmi(2,q,3,p)
							d2ij(p,3,q,6) = dmjtdmi(3,q,3,p)

							d2ij(q,4,p,1) = d2ij(p,1,q,4)
							d2ij(q,4,p,2) = d2ij(p,2,q,4)
							d2ij(q,4,p,3) = d2ij(p,3,q,4)
							d2ij(p,4,q,4) = d2mjtmi(1,p,1,q) + dmjdtmi(q,1,p)
     &						  + dmjdtmi(p,1,q) + mjd2tmi(p,q)
							d2ij(p,4,q,5) = d2mjtmi(1,p,2,q) + dmjdtmi(p,2,q)
							d2ij(p,4,q,6) = d2mjtmi(1,p,3,q) + dmjdtmi(p,3,q)
	
							d2ij(q,5,p,1) = d2ij(p,1,q,5)
							d2ij(q,5,p,2) = d2ij(p,2,q,5)
							d2ij(q,5,p,3) = d2ij(p,3,q,5)
							d2ij(q,5,p,4) = d2ij(p,4,q,5)
							d2ij(p,5,q,5) = d2mjtmi(2,p,2,q)
							d2ij(p,5,q,6) = d2mjtmi(2,p,3,q)

							d2ij(q,6,p,1) = d2ij(p,1,q,6)
							d2ij(q,6,p,2) = d2ij(p,2,q,6)
							d2ij(q,6,p,3) = d2ij(p,3,q,6)
							d2ij(q,6,p,4) = d2ij(p,4,q,6)
							d2ij(q,6,p,5) = d2ij(p,5,q,6)
							d2ij(p,6,q,6) = d2mjtmi(3,p,3,q)
						end do
					end do

					chg = monoi * rmultip(j,1)
					shift = chg / (0.5*(ron + roff))

					if(rijsq .gt. ronsq) then
						taper = c5*rij5 + c4*rij4 + c3*rij3
     &                             + c2*rijsq + c1*rij + c0
						trans = chg * (f7*rij7 + f6*rij6 + f5*rij5 + f4*rij4
     &                                            + f3*rij3 + f2*rijsq
     &                                            + f1*rij + f0)
						dtaper = 5.0d0*c5*rij4 + 4.0d0*c4*rij3 + 3.0d0*c3*rijsq
     &													 + 2.0d0*c2*rij + c1
						dtrans = chg * (7.0d0*f7*rij6 + 6.0d0*f6*rij5 
     &						+ 5.0d0*f5*rij4+ 4.0d0*f4*rij3 
     &						+ 3.0d0*f3*rijsq + 2.0d0*f2*rij + f1)

						d2taper = 20.0d0*c5*rij3 + 12.0d0*c4*rijsq + 6.0d0*c3*rij
     &						+ 2.0d0*c2
						d2trans = chg * (42.0d0*f7*rij5 + 30.0d0*f6*rij4 
     &						+ 20.0d0*f5*rij3+ 12.0d0*f4*rijsq 
     &						+ 6.0d0*f3*rij + 2.0d0*f2)

						dsdt_term = ((eij-shift)*dtaper + dtrans)/rij
						d2sd2t_term1 = ((eij-shift)*d2taper + d2trans)/rijsq
						d2sd2t_term2 = dsdt_term/rijsq
						dtaper = dtaper/rij
			
						do p=1,3
							do q=1,3
								d2xyz = dxyz(p)*dxyz(q)
								dxyzpq1 = d2sd2t_term1*d2xyz
								if(p .eq. q) then
									d2xyz = rijsq - d2xyz
								else
									d2xyz = - d2xyz
								end if
								dxyzpq2 = d2sd2t_term2*d2xyz
								dxyzpq = dxyzpq1 + dxyzpq2
								
								
								d2ij(p,1,q,1) = d2ij(p,1,q,1)*taper 
     &-(dij(p,1)*dxyz(q) + dij(q,1)*dxyz(p))*dtaper + dxyzpq
								d2ij(p,1,q,2) = d2ij(p,1,q,2)*taper 
     &-dij(q,2)*dxyz(p)*dtaper
								d2ij(p,1,q,3) = d2ij(p,1,q,3)*taper
     &-dij(q,3)*dxyz(p)*dtaper
								d2ij(p,1,q,4) = d2ij(p,1,q,4)*taper
     &+(dij(p,1)*dxyz(q) - dij(q,4)*dxyz(p))*dtaper - dxyzpq
								d2ij(p,1,q,5) = d2ij(p,1,q,5)*taper
     &-dij(q,5)*dxyz(p)*dtaper
								d2ij(p,1,q,6) = d2ij(p,1,q,6)*taper
     &-dij(q,6)*dxyz(p)*dtaper

								d2ij(p,2,q,1) = d2ij(p,2,q,1)*taper
     &-dij(p,2)*dxyz(q)*dtaper
								d2ij(p,2,q,2) = d2ij(p,2,q,2)*taper
								d2ij(p,2,q,3) = d2ij(p,2,q,3)*taper
								d2ij(p,2,q,4) = d2ij(p,2,q,4)*taper
     &+dij(p,2)*dxyz(q)*dtaper
								d2ij(p,2,q,5) = d2ij(p,2,q,5)*taper
								d2ij(p,2,q,6) = d2ij(p,2,q,6)*taper
	
								d2ij(p,3,q,1) = d2ij(p,3,q,1)*taper
     &-dij(p,3)*dxyz(q)*dtaper
								d2ij(p,3,q,2) = d2ij(p,3,q,2)*taper
								d2ij(p,3,q,3) = d2ij(p,3,q,3)*taper
								d2ij(p,3,q,4) = d2ij(p,3,q,4)*taper
     &+dij(p,3)*dxyz(q)*dtaper
								d2ij(p,3,q,5) = d2ij(p,3,q,5)*taper
								d2ij(p,3,q,6) = d2ij(p,3,q,6)*taper


 								d2ij(p,4,q,1) = d2ij(p,4,q,1)*taper
     &+(-dij(p,4)*dxyz(q) + dij(q,1)*dxyz(p))*dtaper - dxyzpq
								d2ij(p,4,q,2) = d2ij(p,4,q,2)*taper
     &+dij(q,2)*dxyz(p)*dtaper
								d2ij(p,4,q,3) = d2ij(p,4,q,3)*taper
     &+dij(q,3)*dxyz(p)*dtaper
								d2ij(p,4,q,4) = d2ij(p,4,q,4)*taper
     &+(dij(p,4)*dxyz(q) + dij(q,4)*dxyz(p))*dtaper + dxyzpq
								d2ij(p,4,q,5) = d2ij(p,4,q,5)*taper
     &+dij(q,5)*dxyz(p)*dtaper
								d2ij(p,4,q,6) = d2ij(p,4,q,6)*taper	
     &+dij(q,6)*dxyz(p)*dtaper

								d2ij(p,5,q,1) = d2ij(p,5,q,1)*taper
     &-dij(p,5)*dxyz(q)*dtaper
 								d2ij(p,5,q,2) = d2ij(p,5,q,2)*taper
								d2ij(p,5,q,3) = d2ij(p,5,q,3)*taper
								d2ij(p,5,q,4) = d2ij(p,5,q,4)*taper
     &+dij(p,5)*dxyz(q)*dtaper
								d2ij(p,5,q,5) = d2ij(p,5,q,5)*taper
								d2ij(p,5,q,6) = d2ij(p,5,q,6)*taper

								d2ij(p,6,q,1) = d2ij(p,6,q,1)*taper
     &-dij(p,6)*dxyz(q)*dtaper
								d2ij(p,6,q,2) = d2ij(p,6,q,2)*taper
								d2ij(p,6,q,3) = d2ij(p,6,q,3)*taper
								d2ij(p,6,q,4) = d2ij(p,6,q,4)*taper
     &+dij(p,6)*dxyz(q)*dtaper
								d2ij(p,6,q,5) = d2ij(p,6,q,5)*taper
								d2ij(p,6,q,6) = d2ij(p,6,q,6)*taper
							end do
						end do

						do p=1,3
							dij(p,1) = (-d0(p) + di(1,p))*taper
     &												- dsdt_term*dxyz(p)
							dij(p,2) = di(2,p)*taper
							dij(p,3) = di(3,p)*taper
							dij(p,4) = (d0(p) + dj(1,p))*taper
     &												+ dsdt_term*dxyz(p)
							dij(p,5) = dj(2,p)*taper
							dij(p,6) = dj(3,p)*taper
						end do

						eij = (eij-shift)*taper + trans
					else
						eij = eij - shift					
					end if
					
					en = en + eij
					do p=1,3
						dempole(p,i) = dempole(p,i) + dij(p,1)
						dempole(p,zaxis(i)) = dempole(p,zaxis(i)) + dij(p,2)
						dempole(p,xaxis(i)) = dempole(p,xaxis(i)) + dij(p,3)
						dempole(p,j) = dempole(p,j) + dij(p,4)
						dempole(p,zaxis(j)) = dempole(p,zaxis(j)) + dij(p,5)
						dempole(p,xaxis(j)) = dempole(p,xaxis(j)) + dij(p,6)
					end do
									
					do p=1,3
						hdiag(p,i) = hdiag(p,i) + d2ij(p,1,p,1)
						hdiag(p,zaxis(i)) = hdiag(p,zaxis(i)) + d2ij(p,2,p,2)
						hdiag(p,xaxis(i)) = hdiag(p,xaxis(i)) + d2ij(p,3,p,3)
						hdiag(p,j) = hdiag(p,j) + d2ij(p,4,p,4)
			 			hdiag(p,zaxis(j)) = hdiag(p,zaxis(j)) + d2ij(p,5,p,5)
						hdiag(p,xaxis(j)) = hdiag(p,xaxis(j)) + d2ij(p,6,p,6)
					end do

					do k=1,6
						if(k .eq. 1) then
							atomi = i
						else if(k .eq. 2) then
								atomi = zaxis(i)
						else if(k .eq. 3) then
							atomi = xaxis(i)
						else if(k .eq. 4) then
							atomi = j
						else if(k .eq. 5) then
							atomi = zaxis(j)
						else if(k .eq. 6) then
							atomi = xaxis(j)
						end if
						do l=1,6
							if(l .eq. 1) then
								atomj = i
							else if(l .eq. 2) then
									atomj = zaxis(i)
							else if(l .eq. 3) then
								atomj = xaxis(i)
							else if(l .eq. 4) then
								atomj = j
							else if(l .eq. 5) then
								atomj = zaxis(j)
							else if(l .eq. 6) then
								atomj = xaxis(j)	
							end if
							if(atomi .le. atomj) then
								hmax = max(
     &								  abs(d2ij(1,k,1,l)),abs(d2ij(1,k,2,l)),
     &								  abs(d2ij(1,k,3,l)),abs(d2ij(2,k,1,l)),
     &								  abs(d2ij(2,k,2,l)),abs(d2ij(2,k,3,l)),		
     &								  abs(d2ij(3,k,1,l)),abs(d2ij(3,k,2,l)),
     &								  abs(d2ij(3,k,3,l)) )
								if(hmax .ge. hcut) then		
									if(irowst(atomi) .eq. 0) then
										irowst(atomi) = nextfree
										oldp(atomi) = nextfree
										jcn(nextfree) = atomj
										link(nextfree) = 0
										do p=1,3
											do q=1,3
												h(nextfree) = d2ij(p,k,q,l)
												nextfree = nextfree + 1
											end do
										end do
									else
										pointer = irowst(atomi)
										do while(jcn(pointer) .ne. atomj
     &											.and. link(pointer) .ne. 0)
											pointer = link(pointer)
										end do

c										pointer = oldp(atomi)
c										oldpointer = pointer
c										do while(jcn(pointer) .ne. atomj
c     &											.and. link(pointer) .ne. 0)
c  											pointer = link(pointer)
c										end do
c										if(link(pointer) .eq. 0 .and. 
c     &						 			jcn(pointer) .ne. atomj) then
c											listend = pointer
c											pointer = irowst(atomi)
c											do while(jcn(pointer) .ne. atomj
c     &										.and. pointer .ne. oldpointer)
c												pointer = link(pointer)
c											end do
c										end if	

										if(jcn(pointer) .eq. atomj) then
											oldp(atomi) = pointer
											do p=1,3
												do q=1,3
													h(pointer) = h(pointer) + d2ij(p,k,q,l)
													pointer = pointer + 1
												end do
											end do
										else
c											oldst = irowst(atomi)
c											irowst(atomi) = nextfree
c											oldp(atomi) = nextfree
c											jcn(nextfree) = atomj
c											link(nextfree) = oldst
c											do p=1,3
c												do q=1,3
c													h(nextfree) = d2ij(p,k,q,l)
c													nextfree = nextfree + 1
c												end do
c											end do
											
											link(pointer) = nextfree
											link(nextfree) = 0
											jcn(nextfree) = atomj
											do p=1,3
												do q=1,3
													h(nextfree) = d2ij(p,k,q,l)
													nextfree = nextfree + 1
												end do
											end do											
											
c1											link(listend) = nextfree
c1											link(nextfree) = 0
c1											jcn(nextfree) = atomj
c1											oldp(atomi) = nextfree
c1											do p=1,3
c1												do q=1,3
c1													h(nextfree) = d2ij(p,k,q,l)
c1													nextfree = nextfree + 1
c1												end do
c1											end do											
c1
										end if
									end if
								end if
							end if
						end do
					end do								
				end if		
 			end if
		end do
	end do
	tm = dtime(tarray)
	write(*,99) tm,tarray(1),tarray(2)
	
	if(.not. fullmatrix) go to 2000

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c	compare the two storage methods
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc	

	do k=1,n
		do l=k,n
			pointer = irowst(k)
			do while(jcn(pointer) .ne. l .and. link(pointer) .ne. 0)
				pointer = link(pointer)
			end do
			tmax = 0.0d0
			if(jcn(pointer) .eq. l) then
				do i=1,3
					do j=1,3						
						linkikjl = h(pointer)
						if(abs(d2e(i,k,j,l) - linkikjl) .gt. 1.0d-15) then
							if(abs(d2e(i,k,j,l) - linkikjl) .gt. tmax) then
								tmax = abs(d2e(i,k,j,l) - linkikjl)
							end if
							write(iout,300) i,j,k,l,d2e(i,k,j,l),linkikjl,tmax
 300						format(4i3,2f20.15,e20.15)
						end if
						pointer = pointer + 1
					end do
				end do
			else
				do i=1,3
					do j=1,3
						if(abs(d2e(i,k,j,l)) .gt. tmax) then
							tmax = abs(d2e(i,k,j,l))
						end if
						write(*,400) i,j,k,l,d2e(i,k,j,l),tmax
 400					format(4i3,f20.15,'********************',e20.15)
					end do
				end do
			end if
			if(tmax .gt. hcut) then
				write(*,*)
			end if
		end do
	end do

 2000 continue

	write(*,500) nextfree-1,100.0d0*(nextfree-1)/(9*(n*(n-1)/2+n))
 500	format('Total storage:',i7,'	Percentage: ',f8.3,'%')
	
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c	convert the linked list to a list of compressed vectors
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c	tm = dtime(tarray)
c	htp = 1
c	do i=1,n
c		pointer = irowst(i)
c		if(pointer .ne. 0) then
c			hstart(1,i) = htp
c			do j=i,n
c				pointer = irowst(i) 
c				do while(link(pointer) .ne. 0 .and. jcn(pointer) .ne. j)
c					pointer = link(pointer)
c				end do
c				if(jcn(pointer) .eq. j) then
c					hjcn(htp) = j
c					if(jcn(pointer) .eq. i) then
c						smallp = pointer	
c						smallp = smallp + 1
c						ht(htp) = h(smallp)
c						smallp = smallp + 1
c						htp = htp + 1				
c						ht(htp) = h(smallp)
c						htp = htp + 1	
c					else
c						smallp = pointer	
c						do k=1,3
c							ht(htp) = h(smallp)
c							smallp = smallp + 1
c							htp = htp + 1				
c						end do
c						pointer = link(pointer)
c					end if	
c				end if
c			end do
c			hstop(1,i) = htp - 1
c
c			hstart(2,i) = htp
c			do j=i,n
c				pointer = irowst(i) 
c				do while(link(pointer) .ne. 0 .and. jcn(pointer) .ne. j)
c					pointer = link(pointer)
c				end do
c				if(jcn(pointer) .eq. j) then
c					hjcn(htp) = j
c					if(jcn(pointer) .eq. i) then
c						smallp = pointer	
c						smallp = smallp + 5
c						ht(htp) = h(smallp)
c						htp = htp + 1	
c					else
c						smallp = pointer + 3
c						do k=1,3
c							ht(htp) = h(smallp)
c							smallp = smallp + 1
c							htp = htp + 1				
c						end do
c						pointer = link(pointer)
c					end if	
c				end if
c			end do
c			hstop(2,i) = htp - 1
c
c			hstart(3,i) = htp
c			do j=i,n
c				pointer = irowst(i) 
c				do while(link(pointer) .ne. 0 .and. jcn(pointer) .ne. j)
c					pointer = link(pointer)
c				end do
c				if(jcn(pointer) .eq. j) then
c					hjcn(htp) = j
c					if(j .ne. i) then
c						smallp = pointer + 6
c						do k=1,3
c							ht(htp) = h(smallp)
c							smallp = smallp + 1
c							htp = htp + 1				
c						end do
c						pointer = link(pointer)
c					end if
c				end if	
c			end do
c			hstop(3,i) = htp - 1
c		end if
c	end do
c	tm = dtime(tarray)
c	write(*,99) tm,tarray(1),tarray(2)
c	
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c	convert the linked list to a list of compressed vectors: method2
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	tm = dtime(tarray)
	htp = 1
	do i=1,n
		pointer = irowst(i)
		honep = 1
		if(pointer .ne. 0) then
			hstart(1,i) = htp
			do j=i,n
				pointer = irowst(i) 
				do while(link(pointer) .ne. 0 .and. jcn(pointer) .ne. j)
					pointer = link(pointer)
				end do
				if(jcn(pointer) .eq. j) then
					smallp = pointer + 4
					hjone(honep) = j	
					do k=1,6
						hone(honep) = h(smallp)
						smallp = smallp + 1
						honep = honep + 1
					end do
					hjcn(htp) = j
					if(jcn(pointer) .eq. i) then
						smallp = pointer + 1	
						ht(htp) = h(smallp)
						smallp = smallp + 1
						htp = htp + 1				
						ht(htp) = h(smallp)
						htp = htp + 1	
					else
						smallp = pointer	
						do k=1,3
							ht(htp) = h(smallp)
							smallp = smallp + 1
							htp = htp + 1				
						end do
						pointer = link(pointer)
					end if	
				end if
			end do
			hstop(1,i) = htp - 1
			write(*,*) (hjone(k),k=1,honep)
			
			hstart(2,i) = htp
			smallp = 1
			do j=1,honep
				hjcn(htp) = hjone(smallp)
				if(hjone(j) .eq. i) then
					smallp = smallp + 1
					ht(htp) = hone(smallp)
					smallp = smallp + 2
					htp = htp + 1	
				else
					do k=1,3
						ht(htp) = hone(smallp)
						smallp = smallp + 1
						htp = htp + 1
					end do
				end if	
			end do
			hstop(2,i) = htp - 1

			hstart(3,i) = htp
			smallp = 1
			do j=1,honep
				hjcn(htp) = hjone(smallp)
				if(hjone(j) .eq. i) then
					smallp = smallp + 3
				else
					do k=1,3
						ht(htp) = hone(smallp)
						smallp = smallp + 1
						htp = htp + 1
					end do
				end if	
			end do
			hstop(3,i) = htp - 1
		end if
	end do
	tm = dtime(tarray)
	write(*,99) tm,tarray(1),tarray(2)

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c	compare these two lists
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	do i=1,n
		start = hstart(1,i)
		stop = hstop(1,i)
		smallp = start
		do while(smallp .lt. stop)
			pointer = irowst(i)
			do while(jcn(pointer) .ne. hjcn(smallp))
				pointer = link(pointer)
			end do
			if(hjcn(smallp) .ne. i) then
				do k=1,3
					comp1 = h(pointer)
					comp2 = ht(smallp)
					if( comp1 .ne. comp2) then
						write(*,*) i,hjcn(j),'X',k,comp1,comp2	
					end if	
					pointer = pointer + 1
					smallp = smallp + 1
				end do
			else
				smallp = smallp + 2
			end if	
		end do

		start = hstart(2,i)
		stop = hstop(2,i)
		smallp = start
		do while(smallp .lt. stop)
			pointer = irowst(i)
			do while(jcn(pointer) .ne. hjcn(smallp))
				pointer = link(pointer)
			end do
			if(hjcn(smallp) .ne. i) then
				pointer = pointer + 3
				do k=1,3
					comp1 = h(pointer)
					comp2 = ht(smallp)
					if( comp1 .ne. comp2) then
						write(*,*) i,hjcn(j),'Y',k,comp1,comp2	
					end if	
					pointer = pointer + 1
					smallp = smallp + 1
				end do
			else
				smallp = smallp + 1
			end if	
		end do

		start = hstart(3,i)
		stop = hstop(3,i)
		smallp = start
		do while(smallp .lt. stop)
			pointer = irowst(i)
			do while(jcn(pointer) .ne. hjcn(smallp))
				pointer = link(pointer)
			end do
			if(hjcn(smallp) .ne. i) then
				pointer = pointer + 6
				do k=1,3
					comp1 = h(pointer)
					comp2 = ht(smallp)
					if( comp1 .ne. comp2) then
						write(*,*) i,hjcn(j),'Z',k,comp1,comp2	
					end if	
					pointer = pointer + 1
					smallp = smallp + 1
				end do
			end if	
		end do

	end do

	return
	end
