	function emdqij2(i1,i2,rm1,rm2,mjdtmi,mjtdmi,dmjtmi,
     &			mjd2tmi,mjdtdmi,dmjdtmi,dmjtdmi,mjtd2mi,d2mjtmi)
       
	implicit none

	include 'sizes.i'
	include 'atmtyp.i'
	include 'atoms.i'
	include 'couple.i'
	include 'files.i'

	include 'iounit.i'
	include 'mpole.i'
	include 'mpole1.i'
	include 'mpole2.i'
	include 'newco.i'

	real*8	emdqij2
	integer	i1,i2
	real*8	r,rm1(13),rm2(13)
	real*8	mjdtmi(3),mjtdmi(3,3),dmjtmi(3,3)
	real*8	mjd2tmi(3,3),mjdtdmi(3,3,3),dmjdtmi(3,3,3),dmjtdmi(3,3,3,3)
	real*8	mjtd2mi(3,3,3,3),d2mjtmi(3,3,3,3)
	real*8	t2matrix,t2old
	integer	i,j,k,l,p
	real*8	m2t2(13),t2m1(13),m2dt2(13,3),dt2m1(13,3)
	real*8	t2dm1(13,3,3),inter(13)
	integer	xyz,deri
	real*8	dx,dy,dz,dzz1,dzz2,dzz3,dzz4,dzz5
		
	dx = x(i2) - x(i1)
	dy = y(i2) - y(i1)
	dz = z(i2) - z(i1)
	do i=1,3*(3*len+1)+1
		do j=1,len
			t2(i,j) =  t2old(mindex(i,j,1),
     &   	mindex(i,j,2),mindex(i,j,3),dx,dy,dz)
			if(mindex(i,j,4) .eq. 1) then
				t2(i,j) = -t2(i,j)
			end if
		end do
	end do

c	if(i1 .eq. 4 .and. i2 .eq. 13) then
c		write(*,*) 'rm1 and rm2'
c		write(*,100) (rm1(k),k=1,len)
c		write(*,100) (rm2(k),k=1,len)
c		write(*,*) 'd2m1 and d2m2'
c		do i=1,3
c			do j=1,3
c				write(*,100) 1,i,1,j,(d2m11(k,i,j,i1),k=1,len)
c				write(*,100) 1,i,3,j,(d2m13(k,i,j,i1),k=1,len)
c				write(*,100) 3,i,3,j,(d2m33(k,i,j,i1),k=1,len)
c				write(*,100) 1,i,1,j,(d2m11(k,i,j,i2),k=1,len)
c				write(*,100) 1,i,3,j,(d2m13(k,i,j,i2),k=1,len)
c				write(*,100) 3,i,3,j,(d2m33(k,i,j,i2),k=1,len)
c			end do
c		end do
c	
c		write(*,*) 'T2'
c		do i=1,3*len+1
c			write(*,100) (t2(i,j),j=1,len)
c		end do
c	end if
c 100	format(4i5,4f15.10)
	
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c	get some matrix products that are needed in the calculations     c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c	get Mj*T2
	do i=1,len
		m2t2(i) = 0
		do j=1,len
			m2t2(i) = m2t2(i) + rm2(j)*t2(j,i)
		end do
	end do

c	get T2*Mi
	do i=1,len
		t2m1(i) = 0.0d0
		do j=1,len	
			t2m1(i) = t2m1(i) + t2(i,j)*rm1(j)
		end do
	end do		

c	get Mj*(dT2/dx),etc.
	do i=1,3
		do j=1,len
			m2dt2(j,i) = 0.0d0
			do k=0,len-1
				m2dt2(j,i) = m2dt2(j,i) + rm2(k+1)*t2(i+1+3*k,j)
			end do
		end do
	end do

c	get (dT2/dx)*Mi,etc.
	do i=1,3
		do j=1,len
			dt2m1(j,i) = 0.0d0
			do k=1,len
				dt2m1(j,i) = dt2m1(j,i) + t2(i+1+3*(j-1),k)*rm1(k)
			end do
		end do
	end do

c	get T2*dMi/dx,etc
	do i=1,3
		do j=1,3
			do k=1,len
				t2dm1(k,i,j) = 0.0d0
				do l=2,len
					t2dm1(k,i,j) = t2dm1(k,i,j) + t2(k,l)*demultip(l,i,j,i1)
				end do
			end do
		end do
	end do
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c	get energy                      
c
	emdqij2 = 0.0d0
	do i=1,len
		emdqij2 = emdqij2 +rm2(i)*t2m1(i)
	end do

c	get Mj*(dT/dx)*Mi,etc
	do i=1,3
		mjdtmi(i) = 0.0d0
		do j=1,len
			mjdtmi(i) = mjdtmi(i) + m2dt2(j,i)*rm1(j)
		end do
	end do

c	get Mj*(d2T/dxdx)*Mi,etc
	do i=1,len
		inter(i) = 0.0d0
		do j=0,len-1
			inter(i) = inter(i) + rm2(j+1)*t2(5+9*j,i)
		end do
	end do
	mjd2tmi(1,1) = 0.0d0
	do i=1,len
		mjd2tmi(1,1) = mjd2tmi(1,1) + inter(i)*rm1(i)
	end do

	do i=1,len
		inter(i) = 0.0d0
		do j=0,len-1
			inter(i) = inter(i) + rm2(j+1)*t2(6+9*j,i)
		end do
	end do
	mjd2tmi(1,2) = 0.0d0
	do i=1,len
		mjd2tmi(1,2) = mjd2tmi(1,2) + inter(i)*rm1(i)
	end do
	mjd2tmi(2,1) = mjd2tmi(1,2)

	do i=1,len
		inter(i) = 0.0d0
		do j=0,len-1
			inter(i) = inter(i) + rm2(j+1)*t2(7+9*j,i)
		end do
	end do
	mjd2tmi(1,3) = 0.0d0
	do i=1,len
		mjd2tmi(1,3) = mjd2tmi(1,3) + inter(i)*rm1(i)
	end do
	mjd2tmi(3,1) = mjd2tmi(1,3)

	do i=1,len
		inter(i) = 0.0d0
		do j=1,len
			inter(i) = inter(i) + rm2(j)*t2(9*j,i)
		end do
	end do
	mjd2tmi(2,2) = 0.0d0
	do i=1,len
		mjd2tmi(2,2) = mjd2tmi(2,2) + inter(i)*rm1(i)
	end do

	do i=1,len
		inter(i) = 0.0d0
		do j=1,len
			inter(i) = inter(i) + rm2(j)*t2(1+9*j,i)
		end do
	end do
	mjd2tmi(2,3) = 0.0d0
	do i=1,len
		mjd2tmi(2,3) = mjd2tmi(2,3)  + inter(i)*rm1(i)
	end do
	mjd2tmi(3,2) = mjd2tmi(2,3)
	mjd2tmi(3,3) = -mjd2tmi(1,1) -mjd2tmi(2,2)


c	get (dMj/dx)*T*Mi,Mj*T*(dMi/dx),etc.
	do i=1,2
		do j=1,3
			mjtdmi(i,j) = 0.0d0
			dmjtmi(i,j) = 0.0d0
			do k=2,len			
				mjtdmi(i,j) = mjtdmi(i,j) + m2t2(k)*demultip(k,i,j,i1)
				dmjtmi(i,j) = dmjtmi(i,j) + demultip(k,i,j,i2)*t2m1(k)
			end do
		end do
	end do
	mjtdmi(3,1) = -mjtdmi(1,1) -mjtdmi(2,1)
	mjtdmi(3,2) = -mjtdmi(1,2) -mjtdmi(2,2)
	mjtdmi(3,3) = -mjtdmi(1,3) -mjtdmi(2,3)
	dmjtmi(3,1) = -dmjtmi(1,1) -dmjtmi(2,1)
	dmjtmi(3,2) = -dmjtmi(1,2) -dmjtmi(2,2)
	dmjtmi(3,3) = -dmjtmi(1,3) -dmjtmi(2,3)

c	get Mj*(dT2/dx)*(dMi/dx), (dMj/dx)*(dT2/dx)*Mi,etc.
	do i=1,3
		do j=1,3
			do k=1,3
				mjdtdmi(k,i,j) = 0.0d0
				dmjdtmi(k,i,j) = 0.0d0
				do l=2,len
					mjdtdmi(k,i,j) = mjdtdmi(k,i,j) + 
     &									m2dt2(l,k)*demultip(l,i,j,i1)
					dmjdtmi(k,i,j) = dmjdtmi(k,i,j) + 
     &									demultip(l,i,j,i2)*dt2m1(l,k)
				end do
			end do
		end do
	end do

c	get (dMj/dx)*T2*(dMi/dx),etc.
	do i=1,3
		do j=1,3
			do k=1,3
				do l=1,3
				dmjtdmi(i,j,k,l) = 0.0d0
					do p=2,len
						dmjtdmi(i,j,k,l) = dmjtdmi(i,j,k,l)
     &				 + demultip(p,i,j,i2)*t2dm1(p,k,l)
					end do
				end do
			end do
		end do
	end do

c	get Mj*T2*(d2Mi/dxdx),(d2Mj/dxdx)*T2*Mi, etc.
	do i=1,3
		do j=1,3
			mjtd2mi(1,i,1,j) = 0.0d0
			mjtd2mi(1,i,3,j) = 0.0d0
			mjtd2mi(3,i,3,j) = 0.0d0
			d2mjtmi(1,i,1,j) = 0.0d0
			d2mjtmi(1,i,3,j) = 0.0d0
			d2mjtmi(3,i,3,j) = 0.0d0
			do k=2,len
				mjtd2mi(1,i,1,j) = mjtd2mi(1,i,1,j) +m2t2(k)*d2m11(k,i,j,i1)
				mjtd2mi(1,i,3,j) = mjtd2mi(1,i,3,j) +m2t2(k)*d2m13(k,i,j,i1)
				mjtd2mi(3,i,3,j) = mjtd2mi(3,i,3,j) +m2t2(k)*d2m33(k,i,j,i1)
				
				d2mjtmi(1,i,1,j) = d2mjtmi(1,i,1,j) +d2m11(k,i,j,i2)*t2m1(k)
				d2mjtmi(1,i,3,j) = d2mjtmi(1,i,3,j) +d2m13(k,i,j,i2)*t2m1(k)
				d2mjtmi(3,i,3,j) = d2mjtmi(3,i,3,j) +d2m33(k,i,j,i2)*t2m1(k)
			end do
			mjtd2mi(1,i,2,j) = -mjtd2mi(1,i,1,j) -mjtd2mi(1,i,3,j)
			mjtd2mi(2,i,3,j) = -mjtd2mi(1,i,3,j) -mjtd2mi(3,i,3,j)
			mjtd2mi(2,j,1,i) = mjtd2mi(1,i,2,j)
			mjtd2mi(3,j,1,i) = mjtd2mi(1,i,3,j)
			mjtd2mi(3,j,2,i) = mjtd2mi(2,i,3,j)

			d2mjtmi(1,i,2,j) = -d2mjtmi(1,i,1,j) -d2mjtmi(1,i,3,j)
			d2mjtmi(2,i,3,j) = -d2mjtmi(1,i,3,j) -d2mjtmi(3,i,3,j)
			d2mjtmi(2,j,1,i) = d2mjtmi(1,i,2,j)
			d2mjtmi(3,j,1,i) = d2mjtmi(1,i,3,j)
			d2mjtmi(3,j,2,i) = d2mjtmi(2,i,3,j)
		end do
	end do

	do i=1,3
		do j=1,3
			mjtd2mi(2,i,2,j) = -mjtd2mi(1,i,2,j) -mjtd2mi(3,i,2,j)
			d2mjtmi(2,i,2,j) = -d2mjtmi(1,i,2,j) -d2mjtmi(3,i,2,j)
		end do
	end do		
					
	return
	end
