	subroutine kmpole4

	implicit none

	include 'sizes.i'
	include 'atmtyp.i'
	include 'atoms.i'
	include 'couple.i'
	include 'files.i'
	include 'iounit.i'
	include 'title.i'
	include 'mpole.i'
	include 'mpole1.i'
	include 'mpole2.i'
	
	integer	i,j,k,l
	real*8 en
	real*8 dempole(3,200),dempole1(3,200)
	real*8 d2e(3,30,3,30),d2enum(3,30,3,30)
	real*8 old
	real*8 delta
	integer ii

	write(*,12) 
 12 	format($'length: ')
	read(input,*) len
	write(*,21) 
 21 	format($'1-4?: ')
	read(*,*) e14

	call coeffi(13,6)
	call maxind(4,2)
	call getpaa
			
	do i=1,n
		call getzxy2(i)
		call derm(i)
		call d2mpole(i)
		call rot(i)
	end do

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c	caculate analytical second derivatives for each atom
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	
	do i=1,n
		call empole3(i)
		do j=1,n
			do k=1,3
				d2e(1,i,k,j) = hx(k,j)
				d2e(2,i,k,j) = hy(k,j)
				d2e(3,i,k,j) = hz(k,j)
			end do
		end do
	end do
			
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c	numerical second derivatives
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

	delta = 0.0000001d0
	do ii=1,n
		old = x(ii)
		x(ii) = x(ii) - delta
		call gradient(en, dempole)
		x(ii) = x(ii) + 2*delta
		call gradient(en, dempole1)
		x(ii) = old
		do i=1,n
			do j=1,3
				d2enum(j,i,1,ii) = 0.5d0*(dempole1(j,i)-dempole(j,i))/delta
			end do
		end do


		old = y(ii)
		y(ii) = y(ii) - delta
		call gradient(en, dempole)
		y(ii) = y(ii) + 2*delta
		call gradient(en, dempole1)
		y(ii) = old
		do i=1,n
			do j=1,3
				d2enum(j,i,2,ii) = 0.5d0*(dempole1(j,i)-dempole(j,i))/delta
			end do
		end do
		
		old = z(ii)
		z(ii) = z(ii) - delta
		call gradient(en, dempole)
		z(ii) = z(ii) + 2*delta
		call gradient(en, dempole1)
		z(ii) = old
		do i=1,n
			do j=1,3
				d2enum(j,i,3,ii) = 0.5d0*(dempole1(j,i)-dempole(j,i))/delta
			end do
		end do
	end do

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c	compare the analytical and numerical results
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	do i=1,3
		do j=1,3
			do k=1,n
				do l=1,n
					if(abs(d2e(i,k,j,l)-d2enum(i,k,j,l)) .gt. 1.0d-8) then
						write(iout,300) i,j,k,l,d2e(i,k,j,l),d2enum(i,k,j,l)
 300					format(4i3,2f15.10)
					end if
				end do
			end do
		end do
	end do

	return
	end
