c
c
c     ############################################################
c     ##  COPYRIGHT (C) 1996 by Yong Kong & Jay William Ponder  ##
c     ##                  All Rights Reserved                   ##
c     ############################################################
c
c     ###############################################################
c     ##                                                           ##
c     ##  subroutine elinmpole  --  linear method, multipole, energy  ##
c     ##                                                           ##
c     ###############################################################
c
c
      subroutine elinmpole

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     fast algorithm                                      c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      do i = 1, n
         call rotmat (i,a)
         call rotpole (i,a)
      end do

cccccccccccccccccccccccccccccc
c     timing
cccccccccccccccccccccccccccccc

      frac(0) = 1.0d0
      do i=1,upper_n
         frac(i) = i*frac(i-1)
      end do

      energy = 0.0d0

      do ii=0, upper_n
         call tr_trless_index(ii,deg)
         trace_num = (ii+1)*(ii+2)/2
ccccccccccccccccccccccccccccccccccccccccccccccc
c     trace multipoles (Notice the order: first
c        looping over a given site)
ccccccccccccccccccccccccccccccccccccccccccccccc
         do j=1,trace_num
            mn(j) = 0.0d0
         end do
         do i=1,n
            x1 = x(i)
            y1 = y(i)
            z1 = z(i)
            q1(1) = rmq(1,i)
            q1(2) = rmq(4,i)
            q1(3) = rmq(3,i)
            q1(4) = rmq(2,i)
            q1(5) = rmq(13,i)*2.0d0
            q1(6) = rmq(10,i)*2.0d0
            q1(7) = rmq(9,i)*2.0d0
            q1(8) = rmq(7,i)*2.0d0
            q1(9) = rmq(6,i)*2.0d0
            q1(10) = rmq(5,i)*2.0d0
            
            x_power(0) = 1.0d0
            y_power(0) = 1.0d0
            z_power(0) = 1.0d0
            do j=1,ii
               x_power(j) = x_power(j-1)*x1
               y_power(j) = y_power(j-1)*y1
               z_power(j) = z_power(j-1)*z1
            end do

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     for multipoles energy, this is the only change
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
            count_t1 = 1
            do j=0,ii
               do k=0,ii-j

                  p = ii-j-k
                  mp_count = 1
                  do mii = 0,HIGH_MPORDER
                     do mj=0,mii
                        if(mj .gt. j) go to 19
                        do mk=0,mii-mj
                           mpp = mii - mj - mk
                           if(mk .gt. k .or. mpp .gt. p) go to 19
                           t1 = dble(bico(j,mj)*bico(k,mk)*bico(p,mpp))
                           mn(count_t1) = mn(count_t1) 
     &                      + x_power(j-mj)*y_power(k-mk)*z_power(p-mpp)
     &                        *q1(mp_count)*t1
  19                       continue
                           mp_count = mp_count + 1
                        end do
                     end do
                  end do

                  nmn(ii,count_t1) = mn(count_t1)
                  count_t1 = count_t1 + 1
               end do
            end do

         end do

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

         if(ii .eq. 0) then
            yn(1) = mn(1)
            nyn(0,1) = yn(1)
         else if(ii .eq. 1) then
            call mtoy_1(3, mn, yn)
            do i=1,3
               nyn(1,i) = yn(i)
            end do
         else if(ii .eq. 2) then
            call mtoy_2(5, mn, yn)
            do i=1,5
               nyn(2,i) = yn(i)
            end do
         else if(ii .eq. 3) then
            call mtoy_3(7, mn, yn)
            do i=1,7
               nyn(3,i) = yn(i)
            end do
         else if(ii .eq. 4) then
            call mtoy_4(9, mn, yn)
            do i=1,9
               nyn(4,i) = yn(i)
            end do
         else if(ii .eq. 5) then
            call mtoy_5(11, mn, yn)
            do i=1,11
               nyn(5,i) = yn(i)
            end do
         else if(ii .eq. 6) then
            call mtoy_6(13, mn, yn)
            do i=1,13
               nyn(6,i) = yn(i)
            end do
         else if(ii .eq. 7) then
            call mtoy_7(15, mn, yn)
            do i=1,15
               nyn(7,i) = yn(i)
            end do
         else if(ii .eq. 8) then
            call mtoy_8(17, mn, yn)
            do i=1,17
               nyn(8,i) = yn(i)
            end do
         else if(ii .eq. 9) then
            call mtoy_9(19, mn, yn)
            do i=1,19
               nyn(9,i) = yn(i)
            end do
         else if(ii .eq. 10) then
            call mtoy_10(21, mn, yn)
            do i=1,21
               nyn(10,i) = yn(i)
            end do
         else if(ii .eq. 11) then
            call mtoy_11(23, mn, yn)
            do i=1,23
               nyn(11,i) = yn(i)
            end do
         else if(ii. eq. 12) then
            call mtoy_12(25, mn, yn)
            do i=1,25
               nyn(12,i) = yn(i)
            end do
         else if(ii .eq. 13) then
            call mtoy_13(27, mn, yn)
            do i=1,27
               nyn(13,i) = yn(i)
            end do
         else if(ii .eq. 14) then
            call mtoy_14(29, mn, yn)
            do i=1,29
               nyn(14,i) = yn(i)
            end do
         else if(ii .eq. 15) then
            call mtoy_15(31, mn, yn)
            do i=1,31
               nyn(15,i) = yn(i)
            end do
         else if(ii .eq. 16) then
            call mtoy_16(33, mn, yn)
            do i=1,33
               nyn(16,i) = yn(i)
            end do
         else if(ii .eq. 17) then
            call mtoy_17(35, mn, yn)
            do i=1,35
               nyn(17,i) = yn(i)
            end do
         else if(ii .eq. 18) then
            call mtoy_18(37, mn, yn)
            do i=1,37
               nyn(18,i) = yn(i)
            end do
         else if(ii .eq. 19) then
            call mtoy_19(39, mn, yn)
            do i=1,39
               nyn(19,i) = yn(i)
            end do
         else if(ii .eq. 20) then
            call mtoy_20(41, mn, yn)
            do i=1,41
               nyn(20,i) = yn(i)
            end do
         end if
         count_t1 = 2*ii+2
         count_t2 = ii - 1
         count_t3 = 1
 17      if(count_t1 .le. trace_num) then
            do i=1,count_t2
               yn(count_t1) = -yn(count_t3)-yn(count_t3+2)
               nyn(ii,count_t1) = yn(count_t1)
               count_t1 = count_t1 + 1
               count_t3 = count_t3 + 1
            end do
            count_t3 = count_t3 + 2
            count_t2 = count_t2 - 1
            go to 17
         end if

         en = 0.0d0
         do i=1,trace_num
            en = en + yn(i)*mn(i)*deg(i)
         end do
         en = en * h(ii)
         energy = energy + en
      end do


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     index for the trace and traceless multipoles
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine tr_trless_index(upper_n,dege)

      implicit none
      include 'frac.i'

      real*8 dege(1000)
      integer upper_n
      integer i,j,k,trace_c
      
      trace_c = 1
      do i=0,upper_n
         do j=0,upper_n-i
            k = upper_n-i-j
            dege(trace_c) = frac(upper_n)/(frac(i)*frac(j)*frac(k))
            trace_c = trace_c + 1
         end do
      end do
      trace_c = trace_c-1

      return
      end

c
c
c     ########################
c     ##                    ##
c     ##  subroutine index  ##
c     ##                    ##
c     ########################
c
c
      subroutine index (n,m,ind_x,ind_y,ind_z,p_s,p_e)
      implicit none
      integer i,j,n,m,pt,p_s,p_e
      integer ind_x(m),ind_y(m),ind_z(m)
      integer k
c
c
      pt = 1
      p_s = 1
      p_e = 1

      do i = 1, m
         ind_x(i) = 0
         ind_y(i) = 0
         ind_z(i) = 0
      end do

      do i = 1, n
         do j = p_s, p_e
            pt = pt + 1  
            ind_x(pt) = ind_x(j) + 1
            ind_y(pt) = ind_y(j) 
            ind_z(pt) = ind_z(j)
         end do
         do j = p_s, p_e
            pt = pt + 1  
            ind_x(pt) = ind_x(j) 
            ind_y(pt) = ind_y(j) + 1
            ind_z(pt) = ind_z(j) 
         end do
         do j = p_s, p_e
            pt = pt + 1  
            ind_x(pt) = ind_x(j) 
            ind_y(pt) = ind_y(j) 
            ind_z(pt) = ind_z(j) + 1
         end do
         p_s = p_e + 1
         p_e = pt
      end do

      return
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      function bico (n,m)
      implicit none
      include 'frac.i'

      integer n,m,bico

      bico = frac(n)/(frac(m)*frac(n-m))

      return
      end
