c
c
c     ############################################################
c     ##  COPYRIGHT (C) 1996 by Yong Kong & Jay William Ponder  ##
c     ##                  All Rights Reserved                   ##
c     ############################################################
c
c     ###############################################################
c     ##                                                           ##
c     ##  subroutine elinmpole1  --  linear method, multipole, derivs  ##
c     ##                                                           ##
c     ###############################################################
c
c
      subroutine elinmpole1

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     fast algorithm                                      c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      do i = 1, n
         call rotmat (i,a)
         call rotpole (i,a)
         call drotmat (i,d)
         do j = 1, 3
            do k = 1, 3
               call drotpole (i,a,d,j,k)
            end do
         end do
      end do

cccccccccccccccccccccccccccccc
c     timing
cccccccccccccccccccccccccccccc
      timing_t1 = secnds(0.0)
      do iii=1,1

      frac(0) = 1.0d0
      do i=1,upper_n
         frac(i) = i*frac(i-1)
      end do

      energy = 0.0d0
      do i=1,n
         dx(i) = 0.0d0
         dy(i) = 0.0d0
         dz(i) = 0.0d0
      end do
      do ii=0, upper_n
         call tr_trless_index(ii,deg)
         trace_num = (ii+1)*(ii+2)/2
ccccccccccccccccccccccccccccccccccccccccccccccc
c     trace multipoles (Notice the order: first
c        looping over a given site)
ccccccccccccccccccccccccccccccccccccccccccccccc
         do j=1,trace_num
            mn(j) = 0.0d0
         end do
         do i=1,n
            x1 = x(i)
            y1 = y(i)
            z1 = z(i)
            q1(1) = rmq(1,i)
            q1(2) = rmq(4,i)
            q1(3) = rmq(3,i)
            q1(4) = rmq(2,i)
            q1(5) = rmq(13,i)*2.0d0
            q1(6) = rmq(10,i)*2.0d0
            q1(7) = rmq(9,i)*2.0d0
            q1(8) = rmq(7,i)*2.0d0
            q1(9) = rmq(6,i)*2.0d0
            q1(10) = rmq(5,i)*2.0d0
            
            x_power(0) = 1.0d0
            y_power(0) = 1.0d0
            z_power(0) = 1.0d0
            do j=1,ii
               x_power(j) = x_power(j-1)*x1
               y_power(j) = y_power(j-1)*y1
               z_power(j) = z_power(j-1)*z1
            end do

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     for multipoles energy, this is the only change
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
            count_t1 = 1
            do j=0,ii
               do k=0,ii-j

                  p = ii-j-k
                  mp_count = 1
                  do mii = 0,HIGH_MPORDER
                     do mj=0,mii
                        if(mj .gt. j) go to 19
                        do mk=0,mii-mj
                           mpp = mii - mj - mk
                           if(mk .gt. k .or. mpp .gt. p) go to 19
                           t1 = dble(bico(j,mj)*bico(k,mk)*bico(p,mpp))
                           mn(count_t1) = mn(count_t1) 
     &                      + x_power(j-mj)*y_power(k-mk)*z_power(p-mpp)
     &                        *q1(mp_count)*t1
  19                       continue
                           mp_count = mp_count + 1
                        end do
                     end do
                  end do

                  nmn(ii,count_t1) = mn(count_t1)
                  count_t1 = count_t1 + 1
               end do
            end do

         end do

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

         if(ii .eq. 0) then
            yn(1) = mn(1)
            nyn(0,1) = yn(1)
         else if(ii .eq. 1) then
            call mtoy_1(3, mn, yn)
            do i=1,3
               nyn(1,i) = yn(i)
            end do
         else if(ii .eq. 2) then
            call mtoy_2(5, mn, yn)
            do i=1,5
               nyn(2,i) = yn(i)
            end do
         else if(ii .eq. 3) then
            call mtoy_3(7, mn, yn)
            do i=1,7
               nyn(3,i) = yn(i)
            end do
         else if(ii .eq. 4) then
            call mtoy_4(9, mn, yn)
            do i=1,9
               nyn(4,i) = yn(i)
            end do
         else if(ii .eq. 5) then
            call mtoy_5(11, mn, yn)
            do i=1,11
               nyn(5,i) = yn(i)
            end do
         else if(ii .eq. 6) then
            call mtoy_6(13, mn, yn)
            do i=1,13
               nyn(6,i) = yn(i)
            end do
         else if(ii .eq. 7) then
            call mtoy_7(15, mn, yn)
            do i=1,15
               nyn(7,i) = yn(i)
            end do
         else if(ii .eq. 8) then
            call mtoy_8(17, mn, yn)
            do i=1,17
               nyn(8,i) = yn(i)
            end do
         else if(ii .eq. 9) then
            call mtoy_9(19, mn, yn)
            do i=1,19
               nyn(9,i) = yn(i)
            end do
         else if(ii .eq. 10) then
            call mtoy_10(21, mn, yn)
            do i=1,21
               nyn(10,i) = yn(i)
            end do
         else if(ii .eq. 11) then
            call mtoy_11(23, mn, yn)
            do i=1,23
               nyn(11,i) = yn(i)
            end do
         else if(ii. eq. 12) then
            call mtoy_12(25, mn, yn)
            do i=1,25
               nyn(12,i) = yn(i)
            end do
         else if(ii .eq. 13) then
            call mtoy_13(27, mn, yn)
            do i=1,27
               nyn(13,i) = yn(i)
            end do
         else if(ii .eq. 14) then
            call mtoy_14(29, mn, yn)
            do i=1,29
               nyn(14,i) = yn(i)
            end do
         else if(ii .eq. 15) then
            call mtoy_15(31, mn, yn)
            do i=1,31
               nyn(15,i) = yn(i)
            end do
         else if(ii .eq. 16) then
            call mtoy_16(33, mn, yn)
            do i=1,33
               nyn(16,i) = yn(i)
            end do
         else if(ii .eq. 17) then
            call mtoy_17(35, mn, yn)
            do i=1,35
               nyn(17,i) = yn(i)
            end do
         else if(ii .eq. 18) then
            call mtoy_18(37, mn, yn)
            do i=1,37
               nyn(18,i) = yn(i)
            end do
         else if(ii .eq. 19) then
            call mtoy_19(39, mn, yn)
            do i=1,39
               nyn(19,i) = yn(i)
            end do
         else if(ii .eq. 20) then
            call mtoy_20(41, mn, yn)
            do i=1,41
               nyn(20,i) = yn(i)
            end do
         end if
         count_t1 = 2*ii+2
         count_t2 = ii - 1
         count_t3 = 1
 17      if(count_t1 .le. trace_num) then
            do i=1,count_t2
               yn(count_t1) = -yn(count_t3)-yn(count_t3+2)
               nyn(ii,count_t1) = yn(count_t1)
               count_t1 = count_t1 + 1
               count_t3 = count_t3 + 1
            end do
            count_t3 = count_t3 + 2
            count_t2 = count_t2 - 1
            go to 17
         end if

         en = 0.0d0
         do i=1,trace_num
            en = en + yn(i)*mn(i)*deg(i)
         end do
         en = en * h(ii)
         energy = energy + en
      end do


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      if(ddd_a .ne. 0) then
      do i=1,n
         x1 = x(i)
         y1 = y(i)
         z1 = z(i)
         q1(1) = rmq(1,i)
         q1(2) = rmq(4,i)
         q1(3) = rmq(3,i)
         q1(4) = rmq(2,i)
         q1(5) = rmq(13,i)*2.0d0
         q1(6) = rmq(10,i)*2.0d0
         q1(7) = rmq(9,i)*2.0d0
         q1(8) = rmq(7,i)*2.0d0
         q1(9) = rmq(6,i)*2.0d0
         q1(10) = rmq(5,i)*2.0d0
         do j=1,3
            do k=1,3
               dmq1(1,j,k) = dmq(1,j,k,i)
               dmq1(2,j,k) = dmq(4,j,k,i)
               dmq1(3,j,k) = dmq(3,j,k,i)
               dmq1(4,j,k) = dmq(2,j,k,i)
               dmq1(5,j,k) = dmq(13,j,k,i)*2.0d0
               dmq1(6,j,k) = dmq(10,j,k,i)*2.0d0
               dmq1(7,j,k) = dmq(9,j,k,i)*2.0d0
               dmq1(8,j,k) = dmq(7,j,k,i)*2.0d0
               dmq1(9,j,k) = dmq(6,j,k,i)*2.0d0
               dmq1(10,j,k) = dmq(5,j,k,i)*2.0d0
            end do
         end do

         x_power(0) = 1.0d0
         y_power(0) = 1.0d0
         z_power(0) = 1.0d0
         do j=1,upper_n
            x_power(j) = x_power(j-1)*x1
            y_power(j) = y_power(j-1)*y1
            z_power(j) = z_power(j-1)*z1
         end do

         il = 1
 219     if(local_num(il,i) .ne. 0 .and. il .lt. LOCAL) then
            ilnum = local_num(il,i)
            xl_power(0,il) = 1.0d0
            yl_power(0,il) = 1.0d0
            zl_power(0,il) = 1.0d0
            do j=1,upper_n
               xl_power(j,il) = xl_power(j-1,il)*x(ilnum)
               yl_power(j,il) = yl_power(j-1,il)*y(ilnum)
               zl_power(j,il) = zl_power(j-1,il)*z(ilnum)
            end do
            il = il + 1
            go to 219
         end if
         il = il - 1
         do m=1,il
            ilnum = local_num(m,i)
            do j=1,3
               do k=1,3        
                  dmqlocal(1,j,k,m) = dmq(1,j,k,ilnum)
                  dmqlocal(2,j,k,m) = dmq(4,j,k,ilnum)
                  dmqlocal(3,j,k,m) = dmq(3,j,k,ilnum)
                  dmqlocal(4,j,k,m) = dmq(2,j,k,ilnum)
                  dmqlocal(5,j,k,m) = dmq(13,j,k,ilnum)*2.0d0
                  dmqlocal(6,j,k,m) = dmq(10,j,k,ilnum)*2.0d0
                  dmqlocal(7,j,k,m) = dmq(9,j,k,ilnum)*2.0d0
                  dmqlocal(8,j,k,m) = dmq(7,j,k,ilnum)*2.0d0
                  dmqlocal(9,j,k,m) = dmq(6,j,k,ilnum)*2.0d0
                  dmqlocal(10,j,k,m) = dmq(5,j,k,ilnum)*2.0d0
               end do
            end do
         end do

         do ii=1,upper_n
            call tr_trless_index(ii,deg)
            trace_num = (ii+1)*(ii+2)/2
            count_t1 = 1
            do j=0,ii
               do k=0,ii-j

                  p = ii-j-k
                  mp_count = 1
                  ttx = 0.0d0
                  tty = 0.0d0
                  ttz = 0.0d0
                  do mii = 0,HIGH_MPORDER
                     do mj=0,mii
                        if(mj .gt. j) go to 119
                        do mk=0,mii-mj
                           mpp = mii - mj - mk
                        if(mk .gt. k .or. mpp .gt. p) go to 119
                           
                           q1_mp_count = q1(mp_count)
                           j_mj = j - mj
                           k_mk = k - mk
                           p_mpp = p - mpp
                           tx = j_mj*x_power(j_mj-1)*q1_mp_count 
     &                          + x_power(j_mj)*dmq1(mp_count,1,1)
                           ty = k_mk*y_power(k_mk-1)*q1_mp_count 
     &                          + y_power(k_mk)*dmq1(mp_count,1,2)
                           tz = p_mpp*z_power(p_mpp-1)*q1_mp_count
     &                          + z_power(p_mpp)*dmq1(mp_count,1,3)
                           tx2 = y_power(k_mk)*z_power(p_mpp)*tx
                           ty2 = x_power(j_mj)*z_power(p_mpp)*ty
                           tz2 = x_power(j_mj)*y_power(k_mk)*tz

                           do mil=1,il
                              ilxyz = local_xyz(mil,i)
                              dxyz = xl_power(j_mj,mil)
     &                          *yl_power(k_mk,mil)*zl_power(p_mpp,mil)
                              tx2 = tx2 + dxyz
     &                              *dmqlocal(mp_count,ilxyz,1,mil)
                              ty2 = ty2 + dxyz
     &                              *dmqlocal(mp_count,ilxyz,2,mil)
                              tz2 = tz2 + dxyz
     &                              *dmqlocal(mp_count,ilxyz,3,mil)
                           end do

                           t1 = dble(bico(j,mj)*bico(k,mk)*bico(p,mpp))
                           ttx = ttx + tx2*t1
                           tty = tty + ty2*t1
                           ttz = ttz + tz2*t1

  119                      continue
                           mp_count = mp_count + 1
                        end do
                     end do
                  end do
                  dxmn(count_t1) = ttx
                  dymn(count_t1) = tty
                  dzmn(count_t1) = ttz
                  count_t1 = count_t1 + 1
               end do
            end do

            if(ii .eq. 0) then
               dxyn(1) = dxmn(1)
               dyyn(1) = dymn(1)
               dzyn(1) = dzmn(1)
            else if(ii .eq. 1) then
               call mtoy_1(3, dxmn, dxyn)
               call mtoy_1(3, dymn, dyyn)
               call mtoy_1(3, dzmn, dzyn)
            else if(ii .eq. 2) then
               call mtoy_2(5, dxmn, dxyn)
               call mtoy_2(5, dymn, dyyn)
               call mtoy_2(5, dzmn, dzyn)
            else if(ii .eq. 3) then
               call mtoy_3(7, dxmn, dxyn)
               call mtoy_3(7, dymn, dyyn)
               call mtoy_3(7, dzmn, dzyn)
            else if(ii .eq. 4) then
               call mtoy_4(9, dxmn, dxyn)
               call mtoy_4(9, dymn, dyyn)
               call mtoy_4(9, dzmn, dzyn)
            else if(ii .eq. 5) then
               call mtoy_5(11, dxmn, dxyn)
               call mtoy_5(11, dymn, dyyn)
               call mtoy_5(11, dzmn, dzyn)
            else if(ii .eq. 6) then
               call mtoy_6(13, dxmn, dxyn)
               call mtoy_6(13, dymn, dyyn)
               call mtoy_6(13, dzmn, dzyn)
            else if(ii .eq. 7) then
               call mtoy_7(15, dxmn, dxyn)
               call mtoy_7(15, dymn, dyyn)
               call mtoy_7(15, dzmn, dzyn)
            else if(ii .eq. 8) then
               call mtoy_8(17, dxmn, dxyn)
               call mtoy_8(17, dymn, dyyn)
               call mtoy_8(17, dzmn, dzyn)
            else if(ii .eq. 9) then
               call mtoy_9(19, dxmn, dxyn)
               call mtoy_9(19, dymn, dyyn)
               call mtoy_9(19, dzmn, dzyn)
            else if(ii .eq. 10) then
               call mtoy_10(21, dxmn, dxyn)
               call mtoy_10(21, dymn, dyyn)
               call mtoy_10(21, dzmn, dzyn)
            else if(ii .eq. 11) then
               call mtoy_11(23, dxmn, dxyn)
               call mtoy_11(23, dymn, dyyn)
               call mtoy_11(23, dzmn, dzyn)
            else if(ii. eq. 12) then
               call mtoy_12(25, dxmn, dxyn)
               call mtoy_12(25, dymn, dyyn)
               call mtoy_12(25, dzmn, dzyn)
            else if(ii .eq. 13) then
               call mtoy_13(27, dxmn, dxyn)
               call mtoy_13(27, dymn, dyyn)
               call mtoy_13(27, dzmn, dzyn) 
            else if(ii .eq. 14) then
               call mtoy_14(29, dxmn, dxyn)
               call mtoy_14(29, dymn, dyyn)
               call mtoy_14(29, dzmn, dzyn) 
            else if(ii .eq. 15) then
               call mtoy_15(31, dxmn, dxyn)
               call mtoy_15(31, dymn, dyyn)
               call mtoy_15(31, dzmn, dzyn) 
            else if(ii .eq. 16) then
               call mtoy_16(33, dxmn, dxyn)
               call mtoy_16(33, dymn, dyyn)
               call mtoy_16(33, dzmn, dzyn) 
            else if(ii .eq. 17) then
               call mtoy_17(35, dxmn, dxyn)
               call mtoy_17(35, dymn, dyyn)
               call mtoy_17(35, dzmn, dzyn) 
            else if(ii .eq. 18) then
               call mtoy_18(37, dxmn, dxyn)
               call mtoy_18(37, dymn, dyyn)
               call mtoy_18(37, dzmn, dzyn) 
            else if(ii .eq. 19) then
               call mtoy_19(39, dxmn, dxyn)
               call mtoy_19(39, dymn, dyyn)
               call mtoy_19(39, dzmn, dzyn) 
            else if(ii .eq. 20) then
               call mtoy_20(41, dxmn, dxyn)
               call mtoy_20(41, dymn, dyyn)
               call mtoy_20(41, dzmn, dzyn) 
            end if
            count_t1 = 2*ii+2
            count_t2 = ii - 1
            count_t3 = 1
 18         if(count_t1 .le. trace_num) then
               do j=1,count_t2
                  dxyn(count_t1) = -dxyn(count_t3)-dxyn(count_t3+2)
                  dyyn(count_t1) = -dyyn(count_t3)-dyyn(count_t3+2)
                  dzyn(count_t1) = -dzyn(count_t3)-dzyn(count_t3+2)
                  count_t1 = count_t1 + 1
                  count_t3 = count_t3 + 1
               end do
               count_t3 = count_t3 + 2
               count_t2 = count_t2 - 1
               go to 18
            end if

            dxen = 0.0d0
            dyen = 0.0d0
            dzen = 0.0d0
            do di=1,trace_num
               degi = deg(di)
               mni = nmn(ii,di)
               yni = nyn(ii,di)
c               write(*,1234) i,ii,di,degi,dxmn(di),dymn(di),dzmn(di)
c 1234          format(3i5,4f30.20)
               en = en + yni*mni*degi
               dxen = dxen + (dxyn(di)*mni+yni*dxmn(di))*degi
               dyen = dyen + (dyyn(di)*mni+yni*dymn(di))*degi
               dzen = dzen + (dzyn(di)*mni+yni*dzmn(di))*degi
            end do
            dxen = dxen * h(ii)
            dyen = dyen * h(ii)
            dzen = dzen * h(ii)
            dx(i) = dx(i) + dxen
            dy(i) = dy(i) + dyen
            dz(i) = dz(i) + dzen
         end do
      end do
      end if

      end do
      delta_t = secnds(timing_t1)

      write(*,10) energy,delta_t
 10   format("MYmethod ENERGY:",2f30.25)



      write(*,*)
      dx_count = 0.0d0
      dy_count = 0.0d0
      dz_count = 0.0d0
      do i=1,n
         dx_count = dx_count + dx(i)
         dy_count = dy_count + dy(i)
         dz_count = dz_count + dz(i)
         write(*,22) i,dx(i),dy(i),dz(i)
 22      format(i5,3f40.30)
      end do
      write(*,*)
      write(*,*) dx_count,dy_count,dz_count
      end
