      function legendre(l,m,x)

      implicit none
      real*8 legendre,x
      integer l,m

      integer i,ll
      real*8 fact,pll,pmm,pmmp1,somx2


      pmm = 1.0d0
      if(m .gt. 0) then
         somx2 = dsqrt( (1.0d0-x)*(1.0d0+x))
         fact = 1.0d0
         do i=1,m
            pmm = -pmm*fact*somx2
            fact = fact + 2.0d0
         end do
      end if

      if(l .eq. m) then
         legendre = pmm
      else
      pmmp1 = x*(2*m+1)*pmm
         if(l .eq. m+1) then
            legendre = pmmp1
         else
            do ll=m+2,l
               pll = (x*(2*ll-1)*pmmp1-(ll+m-1)*pmm)/(ll-m)
               pmm = pmmp1
               pmmp1 = pll
            end do
            legendre = pll
         end if
      end if

      return
      end



cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      function d1_legendre(l,x)

      implicit none

      real*8 d1_legendre,legendre,x
      integer l
    
      if(l .lt. 0) then
         d1_legendre = 0.0d0
         return
      end if

      d1_legendre = l*(x*legendre(l,0,x) -  legendre(l-1,0,x))/(x*x-1)

      return
      end


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      function d2_legendre(l,x)

      implicit none

      real*8 d2_legendre,d1_legendre,legendre,x
      integer l

      real*8 t1,t2

      if(l .lt. 0) then
         d2_legendre = 0.0d0
         return
      end if

      t1 = d1_legendre(l,x)
      t2 = legendre(l,0,x)
      d2_legendre = (-2.0d0*x*t1 + l*(l+1)*t2)/(x*x-1)

      return
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      function d3_legendre(l,x)

      implicit none

      real*8 d3_legendre,d2_legendre,d1_legendre,x
      integer l

      if(l .lt. 0) then
         d3_legendre = 0.0d0
         return
      end if

      d3_legendre = 
     &      ((l+2)*(l-1)*d1_legendre(l,x) - 4.0d0*x*d2_legendre(l,x))
     &      /(x*x-1)
      return
      end


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      function d4_legendre(l,x)

      implicit none

      real*8 d4_legendre,x
      integer l

      real*8 d3_legendre,d2_legendre
      real*8 t1,t2

      if(l .lt. 0) then
         d4_legendre = 0.0d0
         return
      end if

      t1 = d2_legendre(l,x)
      t2 = d3_legendre(l,x)

      d4_legendre = ((l+3)*(l-2)*t1 - 6.0d0*x*t2)/(x*x-1)
      return

      end
